(PackageInfo named: 'Path-View') preamble: '"below, add code to be run before the loading of this package"'!
SystemOrganization addCategory: #'Path-View-ClassMorph'!
SystemOrganization addCategory: #'Path-View-Connector'!
SystemOrganization addCategory: #'Path-View-GraphLayout'!
SystemOrganization addCategory: #'Path-View-Monticello'!
SystemOrganization addCategory: #'Path-View-Morphic'!
SystemOrganization addCategory: #'Path-View-Refactorings'!
SystemOrganization addCategory: #'Path-View-Tools'!
SystemOrganization addCategory: #'Path-View-Visitors'!
(PackageInfo named: 'Path-View') postscript: '"below, add code to be run after the loading of this package"
SProject allProjects do: [:p | p views: OrderedCollection new].'!

MoveMethodRefactoring subclass: #SMoveMethodRefactoring
	instanceVariableNames: 'targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SMoveMethodRefactoring methodsFor: 'as yet unclassified' stamp: 'ag 6/28/2012 15:04:27.832'!
getClassesToMoveTo
	"Instead of querying the user for the new class, we use the class, that has been configured here."
	
	moveToClasses := { self model classFor: targetClass }.! !

!SMoveMethodRefactoring methodsFor: 'accessing' stamp: 'ag 6/28/2012 13:46:25.268'!
targetClass
	^ targetClass! !

!SMoveMethodRefactoring methodsFor: 'accessing' stamp: 'ag 6/28/2012 13:46:25.581'!
targetClass: anObject
	targetClass := anObject! !

SystemWindow subclass: #SRefactoringChangeBrowser
	instanceVariableNames: 'selectedRefactoring change undos codePane onClose'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Tools'!

!SRefactoringChangeBrowser class methodsFor: 'instance creation' stamp: 'tfel 6/4/2012 14:14:28.861'!
openChange: aChange

	^ self basicNew
		change: (SRefactoringChange on: aChange);
		initialize;
		open;
		yourself! !

!SRefactoringChangeBrowser class methodsFor: 'instance creation' stamp: 'ag 6/4/2012 16:02:55.214'!
openChange: aChange onClose: aBlock

	^ self basicNew
		change: (SRefactoringChange on: aChange);
		onClose: aBlock;
		initialize;
		open;
		yourself! !

!SRefactoringChangeBrowser methodsFor: 'actions' stamp: 'sp 6/5/2012 11:42:35.403'!
accept
	| refactoring |
	self selectedChange ifNil: [
		(UIManager confirm: 'Really apply all changes at once?') ifFalse: [^ self].
		change executeNotifying: [].
		^self delete].
	refactoring := self selectedChange.
	(undos includesKey: refactoring)
		ifTrue: [(undos at: refactoring) execute.
				undos removeKey: refactoring]
		ifFalse: [undos at: refactoring put: (refactoring executeNotifying: [])].
	self changed: #refactorings.
	self changed: #acceptLabel.
	self changed: #refactoringText.! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:18:21.261'!
acceptLabel

	self selectedChange ifNil: [^ 'Apply all'].
	^ (undos includesKey: self selectedChange)
		ifTrue: ['Undo']
		ifFalse: ['Apply']! !

!SRefactoringChangeBrowser methodsFor: 'building' stamp: 'sp 6/28/2012 17:35:50.743'!
buildButtons
	| panel buttons |
	panel := PluggablePanelMorph new.
	buttons := #('done' 'accept' 'cancel') collect: [:n |
		PluggableButtonMorphPlus on: self
				getState: nil
				action: n asSymbol
				label: (n, 'Label') asSymbol].
	panel
		layoutInset: 0;
		addMorph: buttons first fullFrame: (LayoutFrame fractions: (0@0 corner: 0.33@1));
		addMorph: buttons second fullFrame: (LayoutFrame fractions: (0.33@0 corner: 0.66@1));
		addMorph: buttons third fullFrame: (LayoutFrame fractions: (0.66@0 corner: 1@1)).
	self addMorph: panel frame: (0@0.4 corner: 1@0.5).! !

!SRefactoringChangeBrowser methodsFor: 'building' stamp: 'sp 6/28/2012 16:37:50.398'!
buildCodePane
	
	codePane := SPluggableTextMorphPlus new.
	codePane on: self
		text: #refactoringText
		accept: #refactoringText:
		readSelection: nil
		menu: nil.
	codePane setProperty: #alwaysAccept toValue: true.
	self addMorph: codePane frame: (0@0.5 corner: 1@1).! !

!SRefactoringChangeBrowser methodsFor: 'building' stamp: 'tfel 6/4/2012 14:03:12.028'!
buildList
	| list |
	list := PluggableListMorphPlus on: self
		list: #refactorings
		selected: #selectedRefactoring
		changeSelected: #selectedRefactoring:
		menu: nil
		keystroke: nil.
	self addMorph: list frame: (0@0 corner: 1@0.4).! !

!SRefactoringChangeBrowser methodsFor: 'actions' stamp: 'tfel 6/4/2012 13:53:00.624'!
cancel

	self closeBoxHit.! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 12:33:24.891'!
cancelLabel

	^ 'Cancel' translated! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 13:31:05.473'!
change: anObject
	"Set the value of change"

	change := anObject.
	self changed: #refactorings.! !

!SRefactoringChangeBrowser methodsFor: 'open/close' stamp: 'ag 6/4/2012 16:01:21.696'!
closeBoxHit

	undos
		ifNotEmpty: [
			(UIManager confirm: 'Undo already applied changes?')
				ifTrue: [undos valuesDo: [:value | value execute]. undos removeAll]].
	onClose ifNotNilDo: [:blk | blk valueWithEnoughArguments: {undos keys}].  
	super closeBoxHit.! !

!SRefactoringChangeBrowser methodsFor: 'executing' stamp: 'tfel 6/4/2012 13:58:07.776'!
doItContext

	^ nil! !

!SRefactoringChangeBrowser methodsFor: 'executing' stamp: 'tfel 6/4/2012 14:16:26.709'!
doItReceiver

	^ self selectedChange ifNotNilDo: [:ch | ch changeClass theNonMetaClass]! !

!SRefactoringChangeBrowser methodsFor: 'actions' stamp: 'sp 6/28/2012 17:35:19.055'!
done

	self delete.! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'sp 6/28/2012 17:35:35.079'!
doneLabel

	^ 'Done' translated! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'sp 7/2/2012 13:47:55.006'!
ifNilGetEmptyString: aString

	aString
		ifNil: [^'']
		ifNotNil: [^aString]! !

!SRefactoringChangeBrowser methodsFor: 'initialization' stamp: 'tfel 6/4/2012 14:02:15.646'!
initialize

	super initialize.
	undos := IdentityDictionary new.
	selectedRefactoring := 0.
	self
		setLabel: 'Refactoring Changes';
		buildList;
		buildCodePane;
		buildButtons.! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'ag 6/4/2012 16:02:27.441'!
onClose: aBlock
	"aBlock will be evaluated when the dialog is closed.
	The block will receive an optional parameter, that is a collection with all refactoring-objects,
	that have been applied by the user."
	
	onClose := aBlock.! !

!SRefactoringChangeBrowser methodsFor: 'open/close' stamp: 'tfel 6/4/2012 15:17:07.542'!
open

	self openInWorld.
	ActiveHand keyboardFocus: codePane.! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'sp 7/2/2012 13:48:38.89'!
refactoringText
	| text stream |
	self selectedChange ifNil: [^ ''].
	
	(self selectedChange change isKindOf: AddMethodChange) ifTrue: [
		^ TextDiffBuilder
			buildDisplayPatchFrom: 
				(self ifNilGetEmptyString: (self selectedChange change methodSourceFor: 
						self selectedChange change selector))
			to: (self ifNilGetEmptyString: self selectedChange change source).
	]  ifFalse: [  
		text := self selectedChange printString withBlanksTrimmed.
		(text startsWith: '!!') ifTrue: [text := text allButFirst].
		(text endsWith: '!!') ifTrue: [text := text allButLast].
		stream := ReadStream on: text.
		[stream nextChunk ifEmpty: [false] ifNotEmptyDo: [:chunk | text := chunk. true]]
			whileTrue.
		^ text. 
	]! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 15:09:09.803'!
refactoringText: aText

	self accept.! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'sp 6/22/2012 12:06:48.347'!
refactorings
	| parents |
	parents := OrderedCollection new.
	^ change changes collect: [:refactoring || indent name |
		refactoring parent ifNotNil: [parents addIfNotPresent: refactoring parent].
		indent := (parents indexOf: refactoring parent).
		indent = 0 ifTrue: [parents reset].
		name := (String new: indent withAll: Character space), refactoring name asString.
		
		(undos includesKey: refactoring)
			ifTrue: [name asText addAttribute: TextEmphasis struckOut
						from: 1
						to: name size;
						yourself]
			ifFalse: [name]]! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:41:24.891'!
selectedChange

	selectedRefactoring = 0 ifTrue: [^ nil].
	^ change changes at: selectedRefactoring! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:02:20.29'!
selectedRefactoring
	"Answer the value of selectedRefactoring"

	^ selectedRefactoring! !

!SRefactoringChangeBrowser methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:05:40.321'!
selectedRefactoring: anObject
	"Set the value of selectedRefactoring"

	selectedRefactoring := anObject.
	self changed: #refactoringText.
	self changed: #selectedRefactoring.
	self changed: #acceptLabel.! !

Object subclass: #SBasicEdgeLayouter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SBasicEdgeLayouter class methodsFor: 'constants' stamp: 'ag 3/14/2012 12:10:54.406'!
edgeReroutingOffset
	
	^ SGraph minimumSpacing / 2! !

!SBasicEdgeLayouter class methodsFor: 'constants' stamp: 'ag 3/15/2012 12:18:10.28'!
maxRerouteIterations
	
	^ 50! !

!SBasicEdgeLayouter methodsFor: 'layouting' stamp: 'ag 3/30/2012 17:17:21.524'!
layoutEdge: edge in: aGraph
	"A normal edge will just be rerouted around the nodes in aGraph.
	In case of pseudo-edges, iterate their represented edges (that might be more pseudo-edges) and additionally
	reroute them around the nodes in the subgraphs where they start/end.
	This is hard to describe without a picture or something, sorry. Try to read the code."
	
	| originalEdge |
	originalEdge := edge originalEdge.
	edge pseudoEdgesDo: [ :pseudoEdge |
		pseudoEdge anchorNodes
			select: #containsSubgraph
			thenDo: [ :subgraphNode |
				self reroutePseudoEdge: originalEdge aroundNodesIn: subgraphNode graph ] ].
	self reroutePseudoEdge: edge aroundNodesIn: aGraph.! !

!SBasicEdgeLayouter methodsFor: 'layouting' stamp: 'ag 3/30/2012 17:31:58.321'!
layoutEdgesIn: aGraph
	"This recursively  traverses down all subgraphs and lays out all edges.
	This requires, that all positions are already assigned."
	
	aGraph edges do: [ :edge |
		self layoutEdge: edge in: aGraph ].
	aGraph nodes
		select: #containsSubgraph
		thenDo: [ :subgraphNode |
			self layoutEdgesIn: subgraphNode graph ].! !

!SBasicEdgeLayouter methodsFor: 'layouting' stamp: 'ag 3/30/2012 17:44:00.991'!
rerouteEdge: edge aroundNode: nodeToSegmentnumber
	"1. Find the corners, that should be used to reroute the edge.
	2. Insert bend-positions at these corners (either one or two!!), outset by a constant delta."
	
	| newBendPositions |
	newBendPositions := Set new.
	(edge findRerouteCornersIn: nodeToSegmentnumber)
		do: [ :corner | | outsetBounds |
			outsetBounds := nodeToSegmentnumber key absoluteBounds expandBy: self class edgeReroutingOffset.
			newBendPositions add: (outsetBounds perform: corner) ].
	edge
		insertBendPositions: newBendPositions
		inSegment: nodeToSegmentnumber value.! !

!SBasicEdgeLayouter methodsFor: 'layouting' stamp: 'ag 4/2/2012 10:37:51.302'!
rerouteEdge: edge aroundNodes: collectionOfNodes
	"Repeat the following, until no more nodes are intersected by the edge.
	The loop is guarded by an additional variable to avoid infinite looping.
	1. Find all nodes that are cut be the edge, in the correct ordering.
	2. Take the first of these nodes and reroute the edge around that node."
	
	| intersectingNodes guard |
	guard := 0.
	[ (intersectingNodes := edge intersectingNodesIn: collectionOfNodes) notEmpty
	and: [ guard := guard + 1. guard < self class maxRerouteIterations ] ]
		whileTrue: [
			self haltOnce.
			self
				rerouteEdge: edge
				aroundNode: intersectingNodes first ].! !

!SBasicEdgeLayouter methodsFor: 'layouting' stamp: 'ag 3/30/2012 16:52:06.152'!
reroutePseudoEdge: edge aroundNodesIn: graph
	
	^ self
		rerouteEdge: edge originalEdge
		aroundNodes: (edge rejectAnchorNodes: graph nodes)! !

Object subclass: #SClassMorphVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Visitors'!

!SClassMorphVisitor class methodsFor: 'subclass creation' stamp: 'tfel 6/12/2012 15:06:10.964'!
subclass: sym
instanceVariableNames: ivars
classVariableNames: classvars
poolDictionaries: pools
category: cat
	| cls |
	cls := super subclass: sym instanceVariableNames: ivars classVariableNames: classvars poolDictionaries: pools category: cat.
	cls methodDict ifEmpty: [
		self methodDict keys do: [:m |
			cls compile: m, ' aMorph
				super ', m, ' aMorph'
			classified: 'visiting']].
	^ cls! !

!SClassMorphVisitor class methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:38:23.387'!
visit: aMorph
	
	^ self new visit: aMorph! !

!SClassMorphVisitor class methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:39:01.022'!
visitAll: aCollection
	
	| instance |
	instance := self new.
	aCollection do: [ :object | instance visit: object ].! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 11:41:06.575'!
visit: aMorph

	aMorph accept: self.! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 14:55:25.425'!
visitAssociationConnection: aConnectionMorph! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:13.012'!
visitBehavior: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:16.012'!
visitClass: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:18.867'!
visitClassName: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:22.302'!
visitContainerClass: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:28.96'!
visitImplementation: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:32.526'!
visitInheritance: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 14:55:17.226'!
visitInheritanceConnection: aConnectionMorph! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:35.622'!
visitInstVar: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:39.424'!
visitMethod: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:42.866'!
visitMethodCategory: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:46.025'!
visitNote: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:48.916'!
visitState: aMorph
! !

!SClassMorphVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:29:52.54'!
visitStickySourceCode: aMorph
! !

SClassMorphVisitor subclass: #SReleaseSystemEventsVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Visitors'!

!SReleaseSystemEventsVisitor methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:36:28.678'!
visit: aMorph
	
	aMorph releaseSystemEvents.
	super visit: aMorph.! !

SClassMorphVisitor subclass: #SRestoreVisitor
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Visitors'!

!SRestoreVisitor class methodsFor: 'instance creation' stamp: 'tfel 6/12/2012 15:10:47.351'!
from: aDictionary

	^ self new
		store: aDictionary;
		yourself! !

!SRestoreVisitor class methodsFor: 'instance creation' stamp: 'ag 7/2/2012 15:57:11.459'!
restore: aClassMorph from: aDictionary
	| instance |
	instance := self new
		store: aDictionary;
		yourself.
	instance visit: aClassMorph.
	instance markInconsistencies: aClassMorph.! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:33:00.827'!
associationsStore

	^ store at: SStoreVisitor associationsStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:32:43.261'!
classStore

	^ store at: SStoreVisitor classStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'sp 7/6/2012 13:28:00.651'!
connectAssociationsFrom: aMorph  

	self associationsStore copy
		detect: [:spec | spec first = aMorph variableName and: [spec second = aMorph type]]
		ifFound: [:spec ||morphs|
			Smalltalk at: spec third ifPresent: [:class |
				morphs := aMorph classMorph pasteUpMorphOrWorld
								classMorphsFor: class.].
			Smalltalk at: spec third ifAbsent: [
					morphs := aMorph classMorph pasteUpMorphOrWorld
								thContainerMorphFor: spec third. ].
				morphs
					ifNotEmpty: [
						morphs do: [:morph | aMorph openInstVarAssociationTo: morph].
						self associationsStore remove: spec]
					ifEmpty: []]
		ifNone: [].! !

!SRestoreVisitor methodsFor: 'inconsistencies' stamp: 'tfel 6/28/2012 06:57:46.55'!
exclamationMark: aString for: aMorph
	| randomOffset |
	randomOffset := [((-200 to: -100), (150 to: 250)) atRandom].
	^ (SExclamationMark withText: aString from: aMorph)
		topLeft: aMorph topLeft + (randomOffset value@randomOffset value)! !

!SRestoreVisitor methodsFor: 'inconsistencies' stamp: 'tfel 6/26/2012 18:15:12.271'!
indicateInheritanceConflict: aMorph

	self inheritanceStore do: [:spec || exclamation |
		exclamation := self exclamationMark: 'Used to inherit from: ', spec for: aMorph.
		(SInheritanceConnector openFor: aMorph classMorph connectedTo: exclamation)
			color: Color red]
! !

!SRestoreVisitor methodsFor: 'inconsistencies' stamp: 'ag 7/9/2012 15:35:53.455'!
indicateMissingAssociationClasses: aMorph

	self associationsStore do: [:spec | | message exclamation |
		"Find out, whether the association-partner-class or the variable itself were deleted. Both cases are handled here."
		message := (Smalltalk classNamed: spec third asSymbol)
			ifNil: [ 'Association partner ', spec third, ' deleted (was connected over variable ', spec first, ').' ]
			ifNotNil: [ 'Association to ', spec third, ' deleted (was connected over variable ', spec first, ').' ].
		exclamation := self exclamationMark: message for: aMorph.
		(SAssociationConnector openFor: aMorph connectedTo: exclamation variableName: spec first variableType: spec second)
			color: Color red].! !

!SRestoreVisitor methodsFor: 'inconsistencies' stamp: 'tfel 6/26/2012 18:16:21.491'!
indicateMissingSourceCode: aMorph

	self sourceCodeStore do: [:spec || exclamation |
		exclamation := (SExclamationMark withText: ('Missing source code method ', spec first) from: aMorph)
							topLeft: aMorph topLeft + (-200 to: 200) atRandom.
		(SNoteConnector openFor: aMorph connectedTo: exclamation)
			color: Color red].! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:33:06.624'!
inheritanceStore

	^ store at: SStoreVisitor inheritanceStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'inconsistencies' stamp: 'tfel 6/26/2012 18:16:10.078'!
markInconsistencies: aMorph

	self indicateMissingAssociationClasses: aMorph.
	self indicateMissingSourceCode: aMorph.
	self indicateInheritanceConflict: aMorph.! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:33:11.404'!
notesStore

	^ store at: SStoreVisitor notesStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'tfel 7/5/2012 16:04:54.269'!
openNotesOn: aMorph

	self notesStore copy do: [:spec || target |
		target := SNoteMorph new
			openInWorld: (aMorph pasteUpMorphOrWorld);
			setText: spec first;
			bounds: spec last.
		SNoteConnector openFor: aMorph connectedTo: target.
		self notesStore remove: spec].! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'tfel 7/5/2012 16:04:58.538'!
openSourceCodeFrom: aMorph

	self sourceCodeStore copy
		detect: [:spec |
			spec first = aMorph methodName and: [spec second = aMorph klass isMeta]]
		ifFound: [:spec |
			aMorph openMethodMorph
				openInWorld: (aMorph classMorph pasteUpMorphOrWorld);
				bounds: spec third.
			self sourceCodeStore remove: spec]
		ifNone: [].! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'tfel 7/5/2012 16:05:04.732'!
pinMethodsOn: aMorph

	self sourceCodeStore copy
		detect: [:spec |
			spec first = aMorph methodName and: [spec second = aMorph klass isMeta]]
		ifFound: [:spec | aMorph pin]
		ifNone: [].
	self pinnedMethodsStore copy
		detect: [:spec |
			spec first = aMorph methodName and: [spec second = aMorph klass isMeta]]
		ifFound: [:spec | aMorph pin. self pinnedMethodsStore remove: spec]
		ifNone: [].! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'sp 7/6/2012 13:40:25.828'!
pinVariablesOn: aMorph

	self pinnedVariablesStore copy
		detect: [:spec |
			spec first = aMorph variableName and: [spec second = aMorph type]]
		ifFound: [:spec | aMorph pin. self pinnedVariablesStore remove: spec]
		ifNone: [].! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:33:21.342'!
pinnedMethodsStore

	^ store at: SStoreVisitor pinnedMethodsStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:33:16.54'!
pinnedVariablesStore

	^ store at: SStoreVisitor pinnedVariablesStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'tfel 7/5/2012 16:04:36.81'!
recreateInheritanceConnection: aMorph

	self inheritanceStore copy do: [:spec |
		Smalltalk
			at: spec
			ifPresent: [:class || morphs |
				(aMorph klass allSuperclasses includes: class) ifTrue: [
					morphs := aMorph classMorph pasteUpMorphOrWorld classMorphsFor: class.
					morphs ifNotEmpty: [
						morphs do: [:morph | SInheritanceConnector openFor: aMorph classMorph connectedTo: morph].
						self inheritanceStore remove: spec]]]].! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'tfel 7/3/2012 15:07:12.038'!
setClassMorphColor: aMorph
	| storeArray color |
	storeArray := self classStore first.
	storeArray isArray ifTrue: [
		color := storeArray second.
		aMorph color: color].! !

!SRestoreVisitor methodsFor: 'restoring' stamp: 'tfel 7/3/2012 15:06:24.4'!
setClassMorphPosition: aMorph
	| position |
	position := self classStore first.
	position isArray ifTrue: [position := position first].
	aMorph bounds: position.! !

!SRestoreVisitor methodsFor: 'stores' stamp: 'tfel 6/12/2012 16:33:25.934'!
sourceCodeStore

	^ store at: SStoreVisitor sourceCodeStore ifAbsent: [#()]! !

!SRestoreVisitor methodsFor: 'accessing' stamp: 'tfel 6/12/2012 15:11:18.237'!
store: anObject
	"Set the value of store"

	store := anObject! !

!SRestoreVisitor methodsFor: 'visiting' stamp: 'tfel 7/3/2012 15:06:41.397'!
visitClass: aMorph

	self
		setClassMorphPosition: aMorph;
		setClassMorphColor: aMorph;  
		openNotesOn: aMorph.
	self classStore removeFirst.! !

!SRestoreVisitor methodsFor: 'visiting' stamp: 'sp 7/5/2012 13:50:01.538'!
visitContainerClass: aMorph
	
	self visitClass: aMorph.! !

!SRestoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/26/2012 16:40:22.033'!
visitInheritance: aMorph

	self recreateInheritanceConnection: aMorph.! !

!SRestoreVisitor methodsFor: 'visiting' stamp: 'sp 7/6/2012 13:30:12.905'!
visitInstVar: aMorph
	self
		pinVariablesOn: aMorph;
		connectAssociationsFrom: aMorph.! !

!SRestoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/26/2012 16:44:01.658'!
visitMethod: aMorph

	self
		pinMethodsOn: aMorph;
		openSourceCodeFrom: aMorph.
	self sourceCodeStore
		detect: [:spec |
			spec first = aMorph methodName and: [spec second = aMorph klass isMeta]]
		ifFound: [:spec |
			aMorph openMethodMorph
				openInWorld: (aMorph classMorph pasteUpMorphOrWorld);
				bounds: spec third.
			self sourceCodeStore remove: spec]
		ifNone: [].! !

SClassMorphVisitor subclass: #SStoreVisitor
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Visitors'!

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:16:17.747'!
associationsStore

	^ #associations! !

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:15:51.919'!
classStore

	^ #class! !

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:16:52.156'!
inheritanceStore

	^ #inheritance! !

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:17:02.481'!
notesStore

	^ #notes! !

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:16:39.001'!
pinnedMethodsStore

	^ #pinnedMethods! !

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:58:05.619'!
pinnedVariablesStore

	^ #pinnedVariables! !

!SStoreVisitor class methodsFor: 'stores' stamp: 'tfel 6/12/2012 15:16:27.538'!
sourceCodeStore

	^ #sourceCode! !

!SStoreVisitor class methodsFor: 'instance creation' stamp: 'pt 7/2/2012 11:55:05.416'!
store: aClassMorph

	^ [(self new visit: aClassMorph) store] on: SVisitorNotification do: [nil]! !

!SStoreVisitor methodsFor: 'storing' stamp: 'tfel 6/12/2012 13:31:46.655'!
add: anObject to: aKey

	(store at: aKey ifAbsentPut: [OrderedCollection new])
		add: anObject! !

!SStoreVisitor methodsFor: 'initialize-release' stamp: 'tfel 6/12/2012 13:32:12.197'!
initialize

	super initialize.
	store := IdentityDictionary new.! !

!SStoreVisitor methodsFor: 'storing' stamp: 'tfel 6/12/2012 13:31:51.957'!
store

	^ store copy! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 7/5/2012 13:52:47.332'!
visitAssociationConnection: aConnection

	self add: {aConnection variableName. aConnection variableType.
				aConnection targetMorph klass name}
		 to: self class associationsStore.! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 7/3/2012 15:04:40.172'!
visitClass: aMorph

	self add: {aMorph bounds. aMorph color} to: self class classStore.! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'sp 7/5/2012 13:50:16.267'!
visitContainerClass: aMorph

	self visitClass: aMorph.! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 16:42:21.011'!
visitInheritanceConnection: aConnection

	self add: aConnection targetMorph klass name to: self class inheritanceStore.! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 15:13:27.855'!
visitInstVar: aMorph

	aMorph isPinned ifTrue: [
		self add: {aMorph variableName. aMorph type}
			to: self class pinnedVariablesStore].! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 15:13:36.796'!
visitMethod: aMorph

	aMorph isPinned ifTrue: [
		self add: {aMorph methodName. aMorph klass isMeta}
			to: self class pinnedMethodsStore].! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 15:13:46.509'!
visitNote: aMorph

	self add: {aMorph contentText. aMorph bounds} to: self class notesStore.! !

!SStoreVisitor methodsFor: 'visiting' stamp: 'tfel 6/12/2012 16:18:35.877'!
visitStickySourceCode: aMorph

	self add: {aMorph partner methodName. aMorph partner klass isMeta. aMorph bounds}
		to: self class sourceCodeStore.! !

SClassMorphVisitor subclass: #SVarFinder
	instanceVariableNames: 'varName type foundMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Visitors'!

!SVarFinder class methodsFor: 'instance creation' stamp: 'pt 7/2/2012 11:37:32.92'!
findVariable: aString in: aClassMorph

	^ self findVariable: aString type: nil in: aClassMorph! !

!SVarFinder class methodsFor: 'instance creation' stamp: 'pt 7/2/2012 11:55:02.008'!
findVariable: aString type: aType in: aClassMorph
	| instance |
	instance := self new
		varName: aString;
		type: aType;
		yourself.
	[instance visit: aClassMorph. ^ nil]
		on: SVisitorNotification
		do: [^ instance foundMorph]! !

!SVarFinder methodsFor: 'accessing' stamp: 'pt 7/2/2012 11:34:51.49'!
foundMorph
	"Answer the value of foundMorph"

	^ foundMorph! !

!SVarFinder methodsFor: 'accessing' stamp: 'pt 7/2/2012 11:34:51.484'!
type: anObject
	"Set the value of type"

	type := anObject! !

!SVarFinder methodsFor: 'accessing' stamp: 'pt 7/2/2012 11:34:51.47'!
varName: anObject
	"Set the value of varName"

	varName := anObject! !

!SVarFinder methodsFor: 'visiting' stamp: 'pt 7/2/2012 11:54:57.172'!
visitInstVar: aMorph

	(varName = aMorph variableName and: [type = aMorph type or: [type isNil]])
		ifTrue: [
			foundMorph := aMorph.
			SVisitorNotification signal]! !

Object subclass: #SGraph
	instanceVariableNames: 'nodes edges edgeLayouter isLayedOut'
	classVariableNames: 'CurrentGraph'
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

SGraph subclass: #SCornerOrientedGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SCornerOrientedGraph methodsFor: 'asserting' stamp: 'ag 4/18/2012 13:13:28.878'!
assertCornerConsistency
	"For all nodes, check that their corneringNodes are assigned consistently. Throw an error, if not so."
	
	SClassDiagram debugShowSubgraphs ifTrue: [
		nodes do: [ :node |
			node corneringNodes withIndexDo: [ :cornering :i |
				cornering ifNotNil: [
					(cornering corneringNodes
						at: (i - 1 + 4) \\ 8 + 1) "The opposite corner"
						== node
						ifFalse: [ "Inconsistency!!"
							self error: 'Inconsistency in assigned corners detected' ] ] ] ] ].! !

!SCornerOrientedGraph methodsFor: 'layout - assigning' stamp: 'ag 2/25/2012 17:49:36.671'!
assignCorners
	"Starting from a center node, recursively go through its neighbors and attach them as close as possible.
	Then, until all nodes are handled, pick a leftover node, attach it to the center node and attach all its neighbors as close as possible."
	
	| allNodes centerNode |
	allNodes := nodes copy.
	centerNode := self biggestNodeIn: allNodes.
	self recursivelyAttachTo: centerNode from: allNodes.
	[ allNodes notEmpty ] "If all nodes in this graph are interconnected, this loop will not even be entered."
		whileTrue: [ | nextNode |
			nextNode := self biggestNodeIn: allNodes.
			self attach: nextNode to: centerNode.
			self recursivelyAttachTo: nextNode from: allNodes ].! !

!SCornerOrientedGraph methodsFor: 'layout - assigning' stamp: 'ag 2/17/2012 14:48:46.763'!
assignCornersOf: node
	
	node sortedNeighbors
		do: [ :neighbor | self attach: neighbor to: node ].! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 20:21:36.658'!
assignPositions
	"From the assigned corners of the nodes, compute a grid/matrix from the nodes. Each column is as wide as the widest node in it, each row is as high as the highest node in it.
	This way there can really be no overlapping, if the corners are assigned correctly. The imaginary matrix starts in the top-left corner, meaning x grows downwards and y grows to the right."
	
	| startNode positions heightsAndWidths |
	positions := Dictionary new. "Maps from nodes to their x/y-indices in the matrix."
	startNode := self nodes anyOne.
	positions at: startNode put: 0@0.
	self positionNeighborsOf: startNode intoMatrix: positions.
	self normalizeMatrixPositions: positions.
	
	heightsAndWidths := self columnAndRowCentersOfMatrix: positions.
	self assignPositionsFromMatrix: positions columnWidths: heightsAndWidths key rowHeights: heightsAndWidths value.
	self normalizeElements.! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 2/24/2012 22:39:38.281'!
assignPositionsFromMatrix: positions columnWidths: columnWidths rowHeights: rowHeights
	
	positions keysAndValuesDo: [ :node :matrixPosition |
		node position: 
			((columnWidths at: matrixPosition x) - (node extent x / 2) + (matrixPosition x - 1 * self class minimumSpacing))
			@ ((rowHeights at: matrixPosition y) - (node extent y / 2) + (matrixPosition y - 1 * self class minimumSpacing)) ].! !

!SCornerOrientedGraph methodsFor: 'layout - positioning - naive' stamp: 'ag 2/24/2012 00:22:35.172'!
assignPositionsNaively
	"Pick any node and position all cornering nodes recursively going from there, always relative to a single other, already positioned element.
	Can quickly result in overlapping nodes, e.g. if to close nodes are too big. Only the size of a single neighbor is taken into account when positioning a node."
	
	| node |
	node := nodes anyOne.
	node position: 0 @ 0.
	self positionNeighborsOf: node alreadyPositioned: (Set with: node).
	self normalizeElements.! !

!SCornerOrientedGraph methodsFor: 'layout - assigning' stamp: 'ag 2/17/2012 14:50:18.817'!
attach: neighbor asCloseAsPossibleTo: node
	"Start from corners of node, find the closest corner of any node that we can attach to."
	
	node corneringNodes
		select: #notNil
		thenDo: [ :otherNeighbor |
			self attach: neighbor to: otherNeighbor ].! !

!SCornerOrientedGraph methodsFor: 'layout - assigning' stamp: 'ag 3/6/2012 19:36:25.236'!
attach: neighbor directlyTo: node
	"Try to find a corner of node, where neighbor can be attached to. If not possible, return false."
	
	node nextFreeCorner
		ifNil: [ ^ false ]
		ifNotNilDo: [ :freeCorner |
			node attach: neighbor toCorner: freeCorner.
			^ true ].! !

!SCornerOrientedGraph methodsFor: 'layout - assigning' stamp: 'ag 2/17/2012 14:49:04.572'!
attach: neighbor to: node
	
	^ (self attach: neighbor directlyTo: node)
		ifFalse: [ self attach: neighbor asCloseAsPossibleTo: node ]! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 20:21:08.076'!
columnAndRowCentersOfMatrix: positions
	"The matrix-coordinated in the positions-dictionary are assumed to be normalized (smallest possible position being 1@1).
	Return association (columns -> rows, 2 arrays), filled with the distance from zero-zero to the CENTER of that row/column."
	
	| widthsAndHeights widths heights |
	widthsAndHeights := self columnAndRowDimensionsOfMatrix: positions.
	widths := widthsAndHeights key.
	heights := widthsAndHeights value.
	
	"First, divide everything by two, to account for half of each row/column for its own result value. Below, double this value when adding it to the other rows."
	widths withIndexDo: [ :width :i | widths at: i put: width / 2 ].
	heights withIndexDo: [ :height :i | heights at: i put: height / 2 ].
	
	"Now add the width/height of every column/row to all columns/rows right of it / beneath it."
	widths size to: 1 by: -1 do: [ : i |
		i + 1 to: widths size do: [ :j |
			widths at: j put: (widths at: j) + ((widths at: i) * 2) ] ].
	heights size to: 1 by: -1 do: [ :i |
		i + 1 to: heights size do: [ :j |
			heights at: j put: (heights at: j) + ((heights at: i) * 2) ] ].
	
	^ widthsAndHeights! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 2/24/2012 22:36:10.738'!
columnAndRowDimensionsOfMatrix: positions
	"The matrix-coordinated in the positions-dictionary are assumed to be normalized (smallest possible position being 1@1).
	Return association (columns -> rows, 2 arrays), filled with the widths/heights of the matrix-columns/rows."
	
	| extent rows columns |
	extent := self extentOfMatrix: positions.
	columns := Array new: extent x withAll: 0.
	rows := Array new: extent y withAll: 0.
	positions keysAndValuesDo: [ :node :position |
		columns at: position x put: (node extent x max: (columns at: position x)).
		rows at: position y put: (node extent y max: (rows at: position y)) ].
	^ columns -> rows! !

!SCornerOrientedGraph methodsFor: 'layout' stamp: 'ag 3/7/2012 10:52:40.442'!
doPerformLayout
	"First assign the corners of the nodes to each other. Then calculate the actual positions from that."
	
	self
		assignCorners;
		assertCornerConsistency; "Check, whether assignCorners worked correctly"
		assignPositions.
		"assignPositionsNaively." "Alternative algorithm"! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 2/24/2012 18:42:34.275'!
extentOfMatrix: positions
	"Return a point denoting the number of columns and rows in the matrix built up by the values in the positions-dictionary.
	These values are given by the maximum x/y-values present in the collection of matrix-indices."
	
	| anyPoint numColumns numRows |
	anyPoint := positions values anyOne.
	numColumns := anyPoint x.
	numRows := anyPoint y.
	positions values do: [ :point |
		numColumns := point x max: numColumns.
		numRows := point y max: numRows ].
	^ numColumns @ numRows! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 2/24/2012 00:54:36.706'!
normalizeMatrixPositions: positions
	"After this, the points in the positions-matrix will be normalized to 1@1 (to ease using these points as collection-indices)."
	
	| anyPoint minX minY offset |
	anyPoint := positions values anyOne.
	minX := anyPoint x.
	minY := anyPoint y.
	positions values do: [ :point |
		minX := point x min: minX.
		minY := point y min: minY ].
	offset := (minX negated  + 1) @ (minY negated + 1).
	positions keysAndValuesDo: [ :node :point |
		positions at: node put: point + offset ].! !

!SCornerOrientedGraph methodsFor: 'layout - positioning - naive' stamp: 'ag 2/19/2012 12:49:39.088'!
positionNeighborsOf: node alreadyPositioned: aSet
	"node is assumed to be positioned already."
	
	node corneringNodes withIndexDo: [ :neighbor :i |
		(neighbor notNil and: [ (aSet includes: neighbor) not ]) ifTrue: [
			neighbor position: (node position +
				(i caseOf: {
					[ 1 ] -> [ neighbor extent negated - self class minimumSpacing ].
					[ 2 ] -> [ (node extent x - neighbor extent x) / 2 @ (self class minimumSpacing negated - neighbor extent y) ].
					[ 3 ] -> [ (node extent x + self class minimumSpacing) @ (self class minimumSpacing negated - neighbor extent y) ].
					[ 4 ] -> [ (node extent x + self class minimumSpacing) @ ((node extent y - neighbor extent y) / 2) ].
					[ 5 ] -> [ node extent + self class minimumSpacing ].
					[ 6 ] -> [ (node extent x - neighbor extent x) / 2 @ (node extent y + self class minimumSpacing) ].
					[ 7 ] -> [ (neighbor extent x negated - self class minimumSpacing) @ (node extent y + self class minimumSpacing) ].
					[ 8 ] -> [ (neighbor extent x negated - self class minimumSpacing) @ ((node extent y - neighbor extent y) / 2) ].
				})).
			aSet add: neighbor.
			self positionNeighborsOf: neighbor alreadyPositioned: aSet ] ].! !

!SCornerOrientedGraph methodsFor: 'layout - positioning' stamp: 'ag 2/24/2012 00:34:17.109'!
positionNeighborsOf: node intoMatrix: positions
	
	node corneringNodes withIndexDo: [ :neighbor :i |
		(neighbor notNil and: [ (positions includesKey: neighbor) not ]) ifTrue: [ | newPosition |
			newPosition := (positions at: node) + (i caseOf: {
				[ 1 ] -> [ -1 @ -1 ].
				[ 2 ] -> [ 0 @ -1 ].
				[ 3 ] -> [ 1 @ -1].
				[ 4 ] -> [ 1 @ 0 ].
				[ 5 ] -> [ 1 @ 1 ].
				[ 6 ] -> [ 0 @ 1 ].
				[ 7 ] -> [ -1 @ 1 ].
				[ 8 ] -> [ -1 @ 0 ].
			}).
			positions at: neighbor put: newPosition.
			self positionNeighborsOf: neighbor intoMatrix: positions ] ].! !

!SCornerOrientedGraph methodsFor: 'layout - assigning' stamp: 'ag 2/19/2012 21:07:38.573'!
recursivelyAttachTo: node from: sourceSet
	
	(sourceSet includes: node)
		ifTrue: [
			sourceSet remove: node.
			self assignCornersOf: node.
			node neighborNodes do: [ :neighbor |
				self recursivelyAttachTo: neighbor from: sourceSet ] ].! !

!SGraph class methodsFor: 'debugging' stamp: 'ag 5/14/2012 12:53:00.623'!
applyCurrentGraph
	"This is used for debugging, to re-layout the last layouted graph. Changes in the layout-algorithm can be quickly visualized this way."
	
	CurrentGraph ifNotNilDo: #applyLayout.! !

!SGraph class methodsFor: 'instance creation' stamp: 'ag 6/4/2012 16:35:09.882'!
buildFrom: collectionOfElements
	"The collection can contain SClassMorphs (or subclasses), SNoteMorphs or SStickySourceCodeMorphs. Alternatively, a collection of already built elements is also possible."
	
	| instance morphsToNodes nodeFactory connectors |
	morphsToNodes := Dictionary new.
	nodeFactory := [ :morph | morphsToNodes at: morph ifAbsentPut: [ SGraphElement buildFrom: morph ] ].
	instance := self new.
	connectors := Set new.
	collectionOfElements do: [ :element |
		(element isKindOf: SGraphElement)
			ifTrue: [
				instance addElement: element.
				(element isKindOf: SGraphNode) ifTrue: [ instance addElements: element edges ] ]
			ifFalse: [
				((element isKindOf: SClassMorph) or: [ element isKindOf: SStickySourceCodeMorph ]) ifTrue: [
					instance addElement: (nodeFactory value: element).
					connectors addAll: (element connections copyWithoutAll: connectors) ] ] ].
	connectors do: [ :connector | | edge |
		edge := SGraphElement buildFrom: connector.
		edge from: (nodeFactory value: connector graphSourceMorph) to: (nodeFactory value: connector graphTargetMorph).
		instance addElement: edge ].
	^ instance! !

!SGraph class methodsFor: 'debugging' stamp: 'ag 5/14/2012 12:50:56.655'!
deleteCurrentGraph
	"After removing this reference, a garbage-collect run might free some megabyte of memory."
	
	CurrentGraph := nil.! !

!SGraph class methodsFor: 'constants' stamp: 'ag 3/14/2012 11:58:32.993'!
edgeLayouterClass
	"If no other edge-layouter is set, an instance of this will be created and asked to layout the edges in a graph."
	
	^ SBasicEdgeLayouter! !

!SGraph class methodsFor: 'class initialization' stamp: 'ag 5/14/2012 13:00:00.244'!
initialize
	"self initialize"
	
	super initialize.
	Smalltalk addToStartUpList: SGraph.! !

!SGraph class methodsFor: 'constants' stamp: 'ag 2/15/2012 14:37:06.716'!
minimumSpacing
	"Minimum space in pixels, that has to be left between elements."
	
	^ 20! !

!SGraph class methodsFor: 'debugging' stamp: 'ag 5/14/2012 12:46:58.388'!
setCurrentGraph: aGraph
	"For debugging, to be able to apply the current state of the graph to see intermediary layout-states."
	
	CurrentGraph := aGraph.! !

!SGraph class methodsFor: 'class initialization' stamp: 'ag 5/14/2012 12:50:13.331'!
startUp
	"This message is sent when the image is started. Delete the CurrentGraph class-variable, that is only used for debugging."
	
	super startUp.
	self deleteCurrentGraph.! !

!SGraph methodsFor: 'accessing' stamp: 'ag 2/18/2012 21:34:19.615'!
addElement: nodeOrEdge
	
	(nodeOrEdge isKindOf: SAbstractGraphEdge) ifTrue: [ edges add: nodeOrEdge ].
	(nodeOrEdge isKindOf: SGraphNode) ifTrue: [ nodes add: nodeOrEdge ].
	"Ignore other objects..."! !

!SGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:04:49.123'!
addElements: aCollectionOfElements
	
	aCollectionOfElements do: [ :elem | self addElement: elem ].! !

!SGraph methodsFor: 'debug' stamp: 'ag 3/30/2012 12:52:10.165'!
applyDebugLayout
	
	self
		debugHighlight;
		applyLayout.! !

!SGraph methodsFor: 'layout' stamp: 'ag 3/30/2012 17:31:54.158'!
applyLayout
	
	self elements do: #applyLayout.! !

!SGraph methodsFor: 'computation' stamp: 'ag 3/6/2012 15:38:50.464'!
biggestNodeIn: collectionOfNodes
	
	collectionOfNodes ifEmpty: [ ^ nil ].
	^ collectionOfNodes
		inject: collectionOfNodes anyOne
		into: [ :biggest :each |
			each extent > biggest extent ifTrue: [ each ] ifFalse: [ biggest ] ] "test"! !

!SGraph methodsFor: 'accessing' stamp: 'ag 5/11/2012 12:37:57.514'!
bounds
	
	^ self totalBoundsOf: self nodes! !

!SGraph methodsFor: 'debug' stamp: 'ag 2/23/2012 23:34:56.685'!
debugHighlight
	
	| subgraphColor |
	subgraphColor := Color random alpha: 0.2.
	self nodes do: [ :node |
		node debugHighlight: subgraphColor ].! !

!SGraph methodsFor: 'layout' stamp: 'ag 2/15/2012 12:41:01.658'!
doPerformLayout
	
	self subclassResponsibility.! !

!SGraph methodsFor: 'accessing' stamp: 'ag 3/14/2012 10:29:30.064'!
edgeLayouter: anEdgeLayouter
	"A single message will be sent to anEdgeLayouter during layouting - layoutEdgesIn: with the graph as parameter.
	From there, the edgeLayouter can access all the nodes and edges and add bend-positions to the edges.
	The edge-layouter will be invoked AFTER all nodes have been positioned."
	
	edgeLayouter := anEdgeLayouter.! !

!SGraph methodsFor: 'accessing' stamp: 'ag 2/14/2012 17:52:36.914'!
edges
	
	^ edges! !

!SGraph methodsFor: 'accessing' stamp: 'ag 2/16/2012 12:26:30.606'!
elements
	
	^ nodes, edges! !

!SGraph methodsFor: 'converting' stamp: 'ag 3/14/2012 13:53:02.611'!
groupNodes: aCollectionOfNodes toSubgraph: aGraph
	"acoaCollectionOfNodes contains nodes from the receiver-graph. Remove all these nodes from the receiver and add them to aGraph.
	Ensure, that all edges are rerouted consistently, create some pseud-edges to connect the new subgraph with other nodes."
	
	| subgraphNode |
	nodes := nodes copyWithoutAll: aCollectionOfNodes.
	aGraph addElements: aCollectionOfNodes.
	subgraphNode := SSubgraphNode createFrom: aGraph.
	nodes add: subgraphNode.
	aGraph addElements: (edges select: [ :edge | aCollectionOfNodes includesAllOf: { edge fromNode. edge toNode } ]). "Add all INNER edges to the subgraph."
	edges := edges reject: [ :edge | aCollectionOfNodes includesAnyOf: { edge fromNode. edge toNode } ]. "Remove all inner AND in-between edges from myself."
	self rerouteEdgesOf: aCollectionOfNodes in: subgraphNode. "Turn in-between edges into PseudoEdges and add them to myself."! !

!SGraph methodsFor: 'converting' stamp: 'ag 2/24/2012 22:44:33.983'!
groupNodesIntoCornerOrientedGraphs
	
	self groupNodesIntoGraphs: [ SCornerOrientedGraph new ].! !

!SGraph methodsFor: 'converting' stamp: 'ag 2/24/2012 22:57:10.885'!
groupNodesIntoGraphs: graphCreationBlock
	"Create groups from contained nodes, where there are no connections between nodes from different groups.
	For each group, evaluate graphCreationBlock (without parameters) to create an empty Graph object.
	Group nodes, that would build up a group with a single node, are put into one group of 'nonconnectec' nodes."
	
	| groups |
	groups := self nodeGroups.
	(groups select: [ :group | group size > 1 ])
		do: [ :group |
			self groupNodes: group toSubgraph: graphCreationBlock value ].
	self
		groupNodes: (groups select: [ :group | group size = 1 ]) flatten
		toSubgraph: graphCreationBlock value.! !

!SGraph methodsFor: 'converting' stamp: 'ag 3/30/2012 13:02:44.927'!
groupNodesIntoInheritanceTrees
	"Group nodes into trees, based on the inheritence-connections between the nodes. The original nodes will be removed from the node-set, replaced by tree-subgraphs."
	
	| classNodes inheritenceRoots subgraphs |
	classNodes := self nodes select: #containsClass.
	inheritenceRoots := Set new.
	classNodes do: [ :node | inheritenceRoots add: (node highestSuperclassNodeIn: classNodes) ].
	subgraphs := OrderedCollection new.
	inheritenceRoots
		do: [ :rootNode | | subgraph |
			subgraph := STreeOrientedGraph inheritanceTreeWithRoot: rootNode.
			self groupNodes: subgraph inheritanceTreeNodes toSubgraph: subgraph ].! !

!SGraph methodsFor: 'converting' stamp: 'ag 3/15/2012 20:52:22.087'!
groupNodesIntoMatrixGraphs
	
	self groupNodesIntoGraphs: [ SMatrixGraph new ].! !

!SGraph methodsFor: 'initialization' stamp: 'ag 2/16/2012 12:26:21.562'!
initialize
	
	super initialize.
	nodes := Set new.
	edges := Set new.
	isLayedOut := false.! !

!SGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 14:30:01.916'!
layoutAgain
	
	isLayedOut := false.! !

!SGraph methodsFor: 'layout' stamp: 'ag 3/30/2012 17:22:14.371'!
layoutEdges
	"This may be overwritten, if the graph-implementation itself wants to decide how to layout the edges."
	
	self nodes do: #prepareEdgeLayout.
	(edgeLayouter
		ifNil: [ self class edgeLayouterClass new ])
		layoutEdgesIn: self.! !

!SGraph methodsFor: 'layout' stamp: 'ag 3/30/2012 17:49:32.096'!
layoutNodes
	"Layout 'depth-first', so that higher-level layouts have the correct bounds/positions of nested sub-graphs."
	
	self nodes ifNotEmpty: [
		self nodes do: #layoutNodes. "This is mainly to propagate layouting into subgraphs, which are encapsulated in SSubgraphNodes."
		self doPerformLayout ].! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/23/2012 23:54:54.007'!
moveNeighborsOf: node from: collectionOfNodes into: set
	
	(collectionOfNodes includes: node)
		ifTrue: [
			collectionOfNodes remove: node.
			set add: node.
			node neighborNodes do: [ :neighbor |
				self moveNeighborsOf: neighbor from: collectionOfNodes into: set ] ].! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/19/2012 21:31:08.656'!
nodeGroups
	
	^ self splitIntoGroups: nodes! !

!SGraph methodsFor: 'accessing' stamp: 'ag 2/14/2012 17:52:29.34'!
nodes
	
	^ nodes! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/24/2012 00:23:06.393'!
normalizeElements
	"Position entire graph at zero-zero."
	
	self
		offsetAll: self elements
		by: self bounds origin negated.! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/19/2012 18:21:41.969'!
offsetAll: collectionOfElements by: aPoint
	
	collectionOfElements do: [ :node | node offsetBy: aPoint ].! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/19/2012 18:21:55.301'!
offsetBy: aPoint
	
	self offsetAll: self elements by: aPoint.! !

!SGraph methodsFor: 'layout' stamp: 'ag 3/30/2012 17:48:50.583'!
performLayout
	"Layout 'depth-first', so that higher-level layouts have the correct bounds/positions of nested sub-graphs."
	
	self elements notEmpty & isLayedOut not ifTrue: [
		self
			layoutNodes;
			layoutEdges.
		isLayedOut := true ].! !

!SGraph methodsFor: 'converting' stamp: 'ag 2/19/2012 12:48:21.825'!
rerouteEdgesOf: aCollectionOfNodes in: aSubgraphNode
	
	aCollectionOfNodes do: [ :node |
		node edges copy do: [ :edge | | pseudoEdge |
			edge fromNode = node
				ifTrue: [ (aCollectionOfNodes includes: edge toNode) ifFalse: [ "Edge from subgraph to the outside"
					node clipEdge: edge.
					pseudoEdge := SPseudoGraphEdge forEdge: edge from: aSubgraphNode to: edge toNode.
					self addElement: pseudoEdge ] ]
				ifFalse: [ (aCollectionOfNodes includes: edge fromNode) ifFalse: [ "Edge from the outside into the subgraph"
					node clipEdge: edge.
					pseudoEdge := SPseudoGraphEdge forEdge: edge from: edge fromNode to: aSubgraphNode.
					self addElement: pseudoEdge ] ] ] ].! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/19/2012 21:28:27.816'!
splitIntoGroups: collectionOfNodes
	
	| copy groups |
	copy := collectionOfNodes copy.
	groups := OrderedCollection new.
	[ copy notEmpty ]
		whileTrue: [ | start set |
			start := copy anyOne.
			set := Set new.
			groups add: set.
			self moveNeighborsOf: start from: copy into: set ].
	^ groups! !

!SGraph methodsFor: 'computation' stamp: 'ag 2/15/2012 14:43:24.267'!
totalBoundsOf: aCollectionOfElements
	
	aCollectionOfElements ifEmpty: [ ^ 0 asPoint corner: 0 asPoint ].
	^ aCollectionOfElements
		inject: aCollectionOfElements anyOne bounds
		into: [ :totalExtent :node | totalExtent quickMerge: node bounds ]! !

SGraph subclass: #SMatrixGraph
	instanceVariableNames: 'nodesToPositions positionsToNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SMatrixGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 21:28:29.614'!
assignPositions
	
	| heightsAndWidths |
	heightsAndWidths := self columnAndRowCenters.
	self
		assignPositionsFromColumnWidths: heightsAndWidths key rowHeights: heightsAndWidths value;
		normalizeElements.! !

!SMatrixGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 20:42:25.905'!
assignPositionsFromColumnWidths: columnWidths rowHeights: rowHeights
	
	nodesToPositions keysAndValuesDo: [ :node :matrixPosition |
		node position: 
			((columnWidths at: matrixPosition x) - (node extent x / 2) + (matrixPosition x - 1 * self class minimumSpacing))
			@ ((rowHeights at: matrixPosition y) - (node extent y / 2) + (matrixPosition y - 1 * self class minimumSpacing)) ].! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 21:04:43.453'!
attach: neighbor to: node
	
	| possiblePositions newPosition |
	possiblePositions := self positionsAround: (nodesToPositions at: node).
	newPosition := self
		findPositionAround: node position
		satisfying: [ :position |
			(positionsToNodes includesKey: position) not ].
	self position: neighbor inMatrixAt: newPosition.! !

!SMatrixGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 20:26:49.132'!
columnAndRowCenters
	"The matrix-coordinates of the nodes are now assumed to be normalized (smallest possible position being 1@1).
	Return association (columns -> rows, 2 arrays), filled with the distance from zero-zero to the CENTER of that row/column."
	
	| widthsAndHeights widths heights |
	widthsAndHeights := self columnAndRowDimensions.
	widths := widthsAndHeights key.
	heights := widthsAndHeights value.
	
	"First, divide everything by two, to account for half of each row/column for its own result value. Below, double this value when adding it to the other rows."
	widths withIndexDo: [ :width :i | widths at: i put: width / 2 ].
	heights withIndexDo: [ :height :i | heights at: i put: height / 2 ].
	
	"Now add the width/height of every column/row to all columns/rows right of it / beneath it."
	widths size to: 1 by: -1 do: [ : i |
		i + 1 to: widths size do: [ :j |
			widths at: j put: (widths at: j) + ((widths at: i) * 2) ] ].
	heights size to: 1 by: -1 do: [ :i |
		i + 1 to: heights size do: [ :j |
			heights at: j put: (heights at: j) + ((heights at: i) * 2) ] ].
	
	^ widthsAndHeights! !

!SMatrixGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 21:32:32.704'!
columnAndRowDimensions
	"The matrix-coordinates of the nodes are now assumed to be normalized (smallest possible position being 1@1).
	Return association (columns -> rows, 2 arrays), filled with the widths/heights of the matrix-columns/rows."
	
	| extent rows columns |
	extent := self extentOfMatrix.
	columns := Array new: extent x withAll: 0.
	rows := Array new: extent y withAll: 0.
	self nodes do: [ :node | | position |
		position := nodesToPositions at: node.
		columns at: position x put: (node extent x max: (columns at: position x)).
		rows at: position y put: (node extent y max: (rows at: position y)) ].
	^ columns -> rows! !

!SMatrixGraph methodsFor: 'layout' stamp: 'ag 3/15/2012 21:31:59.145'!
doPerformLayout
	
	nodesToPositions := Dictionary new.
	positionsToNodes := Dictionary new.
	self
		fillMatrix;
		assignPositions.! !

!SMatrixGraph methodsFor: 'layout - positioning' stamp: 'ag 3/15/2012 20:43:08.915'!
extentOfMatrix
	
	| anyPoint numColumns numRows |
	anyPoint := nodesToPositions at: self nodes anyOne.
	numColumns := anyPoint x.
	numRows := anyPoint y.
	positionsToNodes keysDo: [ :point |
		numColumns := point x max: numColumns.
		numRows := point y max: numRows ].
	^ numColumns @ numRows! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 21:28:38.591'!
fillMatrix
	"Starting from a center node, recursively go through its neighbors and position them as close as possible.
	Then, until all nodes are handled, pick a leftover node, attach it to the center node and attach all its neighbors as close as possible."
	
	| allNodes centerNode |
	allNodes := nodes copy.
	centerNode := self biggestNodeIn: allNodes.
	self position: centerNode inMatrixAt: 0@0.
	self recursivelyAttachTo: centerNode from: allNodes.
	[ allNodes notEmpty ] "If all nodes in this graph are interconnected, this loop will not even be entered."
		whileTrue: [ | nextNode |
			nextNode := self biggestNodeIn: allNodes.
			self attach: nextNode to: centerNode.
			self recursivelyAttachTo: nextNode from: allNodes ].
	self normalizeMatrixPositions.! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 21:23:58.012'!
findPositionAround: center satisfying: aBlock
	"Try to read the code to understand this, its just one loop. Basically, we search around the center in square-motions, getting wider."
	
	| currentPosition steps maxSteps direction directions directionIndex |
	maxSteps := 2. "Smallest possible steps on a side of a square around the center matrix-position"
	directionIndex := 1.
	directions := { 1@0 ">". 0@1 "v". -1@0 "<". 0@ -1 "^" }.
	direction := directions at: directionIndex.
	currentPosition := center - 1 asPoint.
	steps := 0.
	
	[ aBlock value: currentPosition ]
		whileFalse: [
			currentPosition := currentPosition + direction.
			steps := steps + 1.
			steps = maxSteps ifTrue: [
				directionIndex := directionIndex + 1.
				directionIndex > 4 ifTrue: [ "Start a new, wider square"
					maxSteps := maxSteps + 2.
					directionIndex := 1.
					currentPosition := currentPosition - 1 asPoint ].
				direction := directions at: directionIndex.
				steps := 0 ] ].
	^ currentPosition! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 21:30:04.797'!
normalizeMatrixPositions
	"After this, the points in the matrix will be normalized to 1@1 (to ease using these points as collection-indices)."
	
	| anyPoint minX minY offset |
	anyPoint := nodesToPositions values anyOne.
	minX := anyPoint x.
	minY := anyPoint y.
	nodesToPositions values do: [ :point |
		minX := point x min: minX.
		minY := point y min: minY ].
	offset := (minX negated  + 1) @ (minY negated + 1).
	self offsetMatrixBy: offset.! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 21:31:24.283'!
offsetMatrixBy: offset
	
	| nodesToPositionsCopy |
	nodesToPositionsCopy := nodesToPositions copy.
	nodesToPositions removeAll.
	positionsToNodes removeAll.
	nodesToPositionsCopy keysAndValuesDo: [ :node :point |
		self position: node inMatrixAt: point + offset ].! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 20:45:28.041'!
position: node inMatrixAt: position
	
	positionsToNodes at: position put: node.
	nodesToPositions at: node put: position.! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 20:34:37.19'!
positionNeighborsOf: node
	
	node sortedNeighbors
		do: [ :neighbor | self attach: neighbor to: node ].! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 20:51:02.023'!
positionsAround: position
	"Yes I love smalltalk"
	
	^ {
		-1@ -1.   0@ -1.  1@ -1.
		-1@0.   "center"  1@0.
		-1@1.     0@1.    1@1.
	} collect: [ :offset | position + offset ]! !

!SMatrixGraph methodsFor: 'layout - assigning' stamp: 'ag 3/15/2012 20:34:22.585'!
recursivelyAttachTo: node from: sourceSet
	
	(sourceSet includes: node)
		ifTrue: [
			sourceSet remove: node.
			self positionNeighborsOf: node.
			node neighborNodes do: [ :neighbor |
				self recursivelyAttachTo: neighbor from: sourceSet ] ].! !

SGraph subclass: #SNonLayoutingGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SNonLayoutingGraph methodsFor: 'layout' stamp: 'ag 2/15/2012 12:41:15.377'!
doPerformLayout
	"Do nothing - no layouting. All nodes will be at 0@0, the edges will be without bends."
	! !

SGraph subclass: #SOffsettingGraph
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

SOffsettingGraph subclass: #SCenteringGraph
	instanceVariableNames: 'parentMorph areaExtension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SCenteringGraph class methodsFor: 'instance creation' stamp: 'ag 4/2/2012 11:29:04.478'!
center: aGraph inside: aParentMorph
	
	^ self new
		addElement: (SGraphElement buildFrom: aGraph);
		parentMorph: aParentMorph;
		yourself! !

!SCenteringGraph class methodsFor: 'instance creation' stamp: 'ag 5/11/2012 12:20:50.043'!
center: aGraph inside: aParentMorph extendAreaBy: percentage
	
	^ self new
		addElement: (SGraphElement buildFrom: aGraph);
		parentMorph: aParentMorph;
		areaExtension: percentage;
		yourself! !

!SCenteringGraph methodsFor: 'accessing' stamp: 'ag 5/11/2012 12:21:13.769'!
areaExtension
	^ areaExtension! !

!SCenteringGraph methodsFor: 'accessing' stamp: 'ag 5/11/2012 12:21:13.862'!
areaExtension: anObject
	areaExtension := anObject! !

!SCenteringGraph methodsFor: 'layout' stamp: 'ag 5/11/2012 12:21:55.133'!
doPerformLayout
	
	self
		extendParentMorphArea;
		offset: (parentMorph extent - self bounds extent) / 2.
	super doPerformLayout.! !

!SCenteringGraph methodsFor: 'layout' stamp: 'ag 5/11/2012 12:52:29.516'!
extendParentMorphArea
	"Calculate, how big the graph currently is, extend the size by the configured percentage (areaExtension), 
	and make the parent-morph at least that big. Do not make it smaller."
	
	areaExtension ifNotNil: [ | newExtent |
		newExtent := self bounds extent * (1 + areaExtension) asPoint.
		"Only make the parent-morph bigger, never smaller."
		(0 asPoint corner: newExtent) area <= self parentMorph bounds area
			ifFalse: [
				self parentMorph extent: newExtent ] ].! !

!SCenteringGraph methodsFor: 'accessing' stamp: 'ag 4/2/2012 11:25:23.019'!
parentMorph
	^ parentMorph! !

!SCenteringGraph methodsFor: 'accessing' stamp: 'ag 4/2/2012 11:25:23.045'!
parentMorph: anObject
	parentMorph := anObject! !

!SOffsettingGraph class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 14:18:47.886'!
offsetting: anotherGraph by: anOffset
	"anotherGraph can be anything, that is wrappable by a graph-element."
	
	^ self new
		addElement: (SGraphElement buildFrom: anotherGraph);
		offset: anOffset;
		yourself! !

!SOffsettingGraph methodsFor: 'layout' stamp: 'ag 2/16/2012 14:01:59.515'!
doPerformLayout
	
	self offsetBy: offset.! !

!SOffsettingGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 14:17:22.167'!
offset
	^ offset ifNil: [ 0@0 ]! !

!SOffsettingGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 14:16:30.935'!
offset: anObject
	offset := anObject! !

SGraph subclass: #SSimpleHorizontalGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SSimpleHorizontalGraph methodsFor: 'layout' stamp: 'ag 2/15/2012 14:37:06.781'!
doPerformLayout
	
	| currentPos |
	currentPos := 0.
	self nodes do: [ :node |
		node position: currentPos @ 0.
		currentPos := currentPos + node width + self class minimumSpacing ].! !

SGraph subclass: #STreeOrientedGraph
	instanceVariableNames: 'root treeRuleBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!STreeOrientedGraph class methodsFor: 'instance creation' stamp: 'ag 2/18/2012 20:58:39.317'!
basedOn: aTreeRuleBlock withRoot: aNode
	
	^ self new root: aNode; treeRuleBlock: aTreeRuleBlock; yourself! !

!STreeOrientedGraph class methodsFor: 'instance creation' stamp: 'ag 2/18/2012 20:57:43.251'!
inheritanceTreeWithRoot: aNode
	
	^ self
		basedOn: [ :parent :child | parent morph isSuperClassOf: child morph ]
		withRoot: aNode! !

!STreeOrientedGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:46:36.893'!
childrenOf: aNode
	
	^ aNode getChildrenBasedOn: treeRuleBlock! !

!STreeOrientedGraph methodsFor: 'private' stamp: 'ag 2/16/2012 11:35:13.07'!
collectChildrenOf: aNode into: aSet
	
	aSet add: aNode.
	(self childrenOf: aNode) do: [ :child | self collectChildrenOf: child into: aSet ].! !

!STreeOrientedGraph methodsFor: 'layout' stamp: 'ag 2/15/2012 14:37:06.769'!
collectRecursiveWidths: aNode into: widthDictionary
	"Sum up the width of each node depth-first. The width is the total width of all children"
	
	(self childrenOf: aNode)
		ifEmpty: [ widthDictionary at: aNode put: aNode width ]
		ifNotEmptyDo: [ :children |
			children do: [ :child | self collectRecursiveWidths: child into: widthDictionary ].
			widthDictionary
				at: aNode
				put: 
					((children inject: 0 into: [ :total :element | total + self class minimumSpacing + (widthDictionary at: element) ] )
					max: aNode width) ].! !

!STreeOrientedGraph methodsFor: 'layout' stamp: 'ag 2/17/2012 12:25:59.963'!
doPerformLayout
	
	| widthDictionary |
	widthDictionary := Dictionary new.
	self collectRecursiveWidths: root into: widthDictionary.
	self setPositionOf: root rowStart: 0 currentRowWidth: 0 widthDictionary: widthDictionary totalHeight: 0.! !

!STreeOrientedGraph methodsFor: 'accessing' stamp: 'ag 2/18/2012 20:48:29.328'!
inheritanceTreeNodes
	
	| set |
	set := Set new.
	self collectChildrenOf: root into: set.
	^ set! !

!STreeOrientedGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:51:47.908'!
root: anElement
	
	root := anElement! !

!STreeOrientedGraph methodsFor: 'layout' stamp: 'ag 2/16/2012 13:31:22.229'!
setPositionOf: node rowStart: xRowStart currentRowWidth: xPosition widthDictionary: widthDictionary totalHeight: totalHeight
	
	| childRowStart rowWidth newTotalHeight |
	childRowStart := xRowStart + xPosition.
	"Position the node in its row, in the middle of its assigned space in the current row."
	node position: (childRowStart + (((widthDictionary at: node) - node width) / 2)) @ totalHeight.
	
	newTotalHeight := totalHeight + node height + self class minimumSpacing.
	rowWidth := 0.
	(self childrenOf: node) do: [ :child |
		self setPositionOf: child rowStart: childRowStart currentRowWidth: rowWidth widthDictionary: widthDictionary totalHeight: newTotalHeight.
		rowWidth := rowWidth + (widthDictionary at: child) + self class minimumSpacing ].! !

!STreeOrientedGraph methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:48:35.289'!
treeRuleBlock: aBlock
	"two-argument block: first the assumed parent node, then a neighbor of it. aBlock returns true, if the assumed parent node really is a parent of this neighbor."
	
	treeRuleBlock := aBlock! !

Object subclass: #SGraphElement
	instanceVariableNames: 'morph subgraphNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

SGraphElement subclass: #SAbstractGraphEdge
	instanceVariableNames: 'fromNode toNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 3/30/2012 16:49:19.002'!
anchorNodes
	
	^ { fromNode. toNode }! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 2/18/2012 18:39:25.318'!
from: aGraphNode to: anotherGraphNode
	
	fromNode := aGraphNode.
	toNode := anotherGraphNode.
	aGraphNode addEdge: self.
	anotherGraphNode addEdge: self.! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 2/17/2012 12:49:26.254'!
fromNode
	
	^ fromNode! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 2/17/2012 12:50:10.35'!
isConnectionInside: collectionOfNodes
	"Answer, whether the receiver is a connection between two nodes in collectionOfNodes."
	
	^ collectionOfNodes includesAllOf: { fromNode. toNode }! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 3/15/2012 11:12:04.526'!
isPseudoEdge
	
	self subclassResponsibility.! !

!SAbstractGraphEdge methodsFor: 'layout' stamp: 'ag 3/30/2012 16:54:32.692'!
offsetBy: aPoint
	"edge-bendPositions are not offset. They are calculated after all positions for nodes are already calculated,
	and are already absolute values."! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 3/14/2012 14:07:15.918'!
originalEdge
	
	self subclassResponsibility.! !

!SAbstractGraphEdge methodsFor: 'layout' stamp: 'ag 3/30/2012 17:23:37.061'!
prepareLayout
	"Implemented in one subclass."! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 3/15/2012 11:34:02.579'!
pseudoEdgesDo: aBlock
	"If this is a normal edge, aBlock is not invoked at all.
	If this is a pseudo-edge, aBlock is first invoked with the receiver and then (possibly) with further pseudo-edges, if this pseudo-edge represents furthe pseudo-edges."
	
	self subclassResponsibility.! !

!SAbstractGraphEdge methodsFor: 'filtering' stamp: 'ag 3/30/2012 16:57:13.013'!
rejectAnchorNodes: collectionOfNodes
	
	^ collectionOfNodes reject: [ :node |
		(self anchorNodes includes: node) 
			or: [ | isAnchorNode |
				isAnchorNode := false.
				self pseudoEdgesDo: [ :pseudoEdge |
				isAnchorNode := isAnchorNode or: [ pseudoEdge anchorNodes includes: node ] ].
				isAnchorNode ] ]! !

!SAbstractGraphEdge methodsFor: 'accessing' stamp: 'ag 2/17/2012 12:50:25.545'!
toNode
	
	^ toNode! !

SAbstractGraphEdge subclass: #SGraphEdge
	instanceVariableNames: 'bendPositions morphStraightened'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SGraphEdge class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:29:28.593'!
isAbstract
	
	^ false! !

!SGraphEdge class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:45:09.144'!
wrapsInstancesOf: aClass
	
	^ aClass isKindOf: SConnector class! !

!SGraphEdge methodsFor: 'layout' stamp: 'ag 4/2/2012 15:50:16.88'!
applyLayout
	
	| realMorph |realMorph := self morph.
	self originalEdge straightenMorph.
	"self sortBendPositions."
	realMorph setVertices: 
		{ realMorph vertices first }, bendPositions asArray, { realMorph vertices last }.! !

!SGraphEdge methodsFor: 'accessing' stamp: 'ag 3/30/2012 16:06:53.029'!
bendPositions
	"Not to be modified outside this object."
	
	^ bendPositions! !

!SGraphEdge methodsFor: 'debugging' stamp: 'ag 4/2/2012 15:49:27.078'!
debugBendPoints
	
	bendPositions withIndexDo: [ :point :i |
		self debugPoint: point text: i asString ].! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 3/30/2012 17:36:48.554'!
findRerouteCornersIn: nodeToSegmentnumber
	"Return corners (symbols, #topLeft, #bottomLeft, #topRight, #bottomRight), that should be used to reroute the receiver-edge.
	The argument is an association from the intersected node to the segment in the receiver-edge, that intersects the node (like returned by #intersectingNodesIn:)."
	
	| segment bounds intersections |
	bounds := nodeToSegmentnumber key absoluteBounds.
	segment := self segment: nodeToSegmentnumber value.
	intersections := bounds intersectionsWithLineFrom: segment key to: segment value.
	intersections ifEmpty: [ ^ #() ].
	intersections size = 1 ifTrue: [ intersections add: intersections anyOne ]. "Don't know, whether this can happen... Be sure."
	^ intersections collect: [ :point | bounds cornerNearsetTo: point ]! !

!SGraphEdge methodsFor: 'initialization' stamp: 'ag 3/30/2012 14:33:16.373'!
initialize
	
	super initialize.
	bendPositions := OrderedCollection new.! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 4/18/2012 13:00:28.719'!
insertBendPositions: collectionOfPoints inSegment: aNumber
	
	| resort |
	resort := false.
	collectionOfPoints do: [ :point |
		(bendPositions includes: point)
			ifFalse: [
				bendPositions add: point.
				resort := true ] ].
	
	"This is not nice, but depending on whether there is a code-box involved, we have to sort the bend-positions differently...
	Results from unexpected behaviour in the Connectors library."
	resort ifTrue: [
		self sortBendPositionsStarting: 
			((self toNode isKindOf: STextGraphNode)
				ifTrue: [ self toNode absoluteBounds ]
				ifFalse: [ self fromNode absoluteBounds ]) ].! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 3/30/2012 14:34:09.914'!
intersectingNodesIn: collectionOfNodes
	"Returns an ordered collection of nodes (in collectionOfNodes), that are intersected by the receiver edge.
	The elements are association from the intersected nodes to the segment-number, which intersects them."
	
	| result |
	result := OrderedCollection new.
	1 to: self numberOfSegments do: [ :segmentNumber |
		result addAll: 
			((self intersectionsOfSegment: segmentNumber in: collectionOfNodes)
				collect: [ :node | node -> segmentNumber ]) ].
	^ result! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 3/30/2012 16:33:09.419'!
intersectionsOfSegment: segmentNumber in: collectionOfNodes
	"Select those nodes from collectionOfNodes, that are intersected by the given segment of the receiver-edge.
	The intersected nodes will be sorted by the ordering of their intersection (by their distance from the segment-start).
	The segmentNumber is 1-based (the first segment is represented by 1).
	For correct results, the fromNode and toNode of the receiver should not be included in collectionOfNodes."
	
	| segment intersections |
	intersections := OrderedCollection new.
	segment := self segment: segmentNumber.
	collectionOfNodes do: [ :node |
		(node absoluteBounds intersectsLineFrom: segment key to: segment value)
			ifTrue: [ intersections add: node ] ].
	^ intersections
		asSortedCollection: [ :node1 :node2 |
			(segment key dist: node1 center) <= (segment key dist: node2 center) ]! !

!SGraphEdge methodsFor: 'accessing' stamp: 'ag 3/15/2012 11:12:12.791'!
isPseudoEdge
	
	^ false! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 3/30/2012 14:34:10.024'!
numberOfSegments
	
	^ bendPositions size + 1! !

!SGraphEdge methodsFor: 'accessing' stamp: 'ag 3/14/2012 14:07:07.815'!
originalEdge
	
	^ self! !

!SGraphEdge methodsFor: 'layout' stamp: 'ag 3/30/2012 17:27:15.063'!
prepareLayout
	"This is sent right before applyLayout, so reset the morphStraightened variable to ensure, that the GraphEdge-object
	can be used multiple times for layouting."
	
	morphStraightened := false.! !

!SGraphEdge methodsFor: 'accessing' stamp: 'ag 3/15/2012 11:34:13.875'!
pseudoEdgesDo: aBlock
	"Nothing, fromNode/toNode are not subgraphs."! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 3/30/2012 16:30:54.267'!
segment: segmentNumber
	"Return the start and end position (as association) of the segment <segmentNumber>. segmentNumber is 1-based (the first segment is represented by 1)."
	
	| segmentStart segmentEnd |
	segmentStart := segmentNumber = 1
		ifTrue: [ self fromNode absoluteBounds center ]
		ifFalse: [ bendPositions at: segmentNumber - 1 ].
	segmentEnd := bendPositions size >= segmentNumber
		ifTrue: [ bendPositions at: segmentNumber ]
		ifFalse: [ self toNode absoluteBounds center ].
	^ segmentStart -> segmentEnd! !

!SGraphEdge methodsFor: 'calculations' stamp: 'ag 4/18/2012 13:02:15.51'!
sortBendPositionsStarting: aRectangle
	"The closest point to aRectangle will be the first bend-point, then nearest point is appended, respectively."
	
	| bendPositionsCopy currentPoint |
	bendPositions ifEmpty: [ ^ self ].
	currentPoint := bendPositions detectMin: [ :point | (aRectangle pointNearestTo: point) dist: point ].
	bendPositionsCopy := bendPositions copyWithout: currentPoint.
	bendPositions := OrderedCollection with: currentPoint.
	[ bendPositionsCopy notEmpty ]
		whileTrue: [ | nearest |
			nearest := bendPositionsCopy detectMin: [ :point | point dist: currentPoint ].
			currentPoint := nearest.
			bendPositionsCopy remove: nearest.
			bendPositions addLast: nearest ].! !

!SGraphEdge methodsFor: 'layout' stamp: 'ag 3/14/2012 14:28:38.615'!
straightenMorph
	
	(morphStraightened ifNil: [ morphStraightened := false ])
		ifFalse: [
			morph straighten.
			morphStraightened := true ].! !

SAbstractGraphEdge subclass: #SPseudoGraphEdge
	instanceVariableNames: 'originalEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SPseudoGraphEdge class methodsFor: 'as yet unclassified' stamp: 'ag 3/14/2012 14:25:29.773'!
forEdge: anEdge from: aNode to: anotherNode
	
	^ self new
		setOriginalEdge: anEdge;
		from: aNode to: anotherNode! !

!SPseudoGraphEdge methodsFor: 'layout' stamp: 'ag 3/30/2012 17:31:03.319'!
applyLayout
	
	self originalEdge applyLayout.! !

!SPseudoGraphEdge methodsFor: 'accessing' stamp: 'ag 3/15/2012 11:12:18.599'!
isPseudoEdge
	
	^ true! !

!SPseudoGraphEdge methodsFor: 'accessing' stamp: 'ag 3/14/2012 14:10:53.471'!
originalEdge
	
	^ originalEdge originalEdge! !

!SPseudoGraphEdge methodsFor: 'accessing' stamp: 'ag 3/30/2012 13:43:05.81'!
pseudoEdgesDo: aBlock
	"Iterate recursively over all contained pseudo-edges. Depth-first."
	
	self representedEdge pseudoEdgesDo: aBlock.
	aBlock value: self.! !

!SPseudoGraphEdge methodsFor: 'accessing' stamp: 'ag 3/15/2012 11:12:28.423'!
representedEdge
	
	^ originalEdge! !

!SPseudoGraphEdge methodsFor: 'accessing' stamp: 'ag 3/14/2012 14:25:37.098'!
setOriginalEdge: anEdge
	
	originalEdge := anEdge.! !

!SGraphElement class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 14:11:51.958'!
buildFrom: anObject
	
	(anObject isKindOf: SGraphElement) ifTrue: [ ^ anObject ].
	^ ((self allSubclasses
		reject: #isAbstract)
		detect: [ :class | 
			class wrapsInstancesOf: anObject class ]
		ifNone: [ self error: 'Cannot insert object into graph: ', anObject ])
			createFrom: anObject! !

!SGraphElement class methodsFor: 'instance creation' stamp: 'ag 2/17/2012 13:10:51.936'!
createFrom: aMorph
	
	^ self basicNew
		morph: aMorph;
		initialize;
		yourself! !

!SGraphElement class methodsFor: 'debugging' stamp: 'ag 6/4/2012 13:19:25.834'!
debugPoint: aPoint in: aMorph
	"Add a small, transient rectangle centered around aPoint. The rectangle will disappear the next time the graph will be layed out."
	
	| newMorph |
	newMorph :=
		(SDebugRectangleMorph new
			extent: 20 asPoint;
			center: aPoint;
			color: Color random;
			yourself).
	(aMorph ownerThatIsA: SClassDiagram)
		addMorph: newMorph.
	^ newMorph! !

!SGraphElement class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:29:33.034'!
isAbstract
	
	^ true! !

!SGraphElement class methodsFor: 'instance creation' stamp: 'ag 2/14/2012 17:56:21.947'!
wrapsInstancesOf: aClass
	
	self subclassResponsibility.! !

!SGraphElement methodsFor: 'layout' stamp: 'ag 2/14/2012 21:54:25.134'!
applyLayout
	
	self subclassResponsibility.! !

!SGraphElement methodsFor: 'debugging' stamp: 'ag 6/4/2012 13:19:49.668'!
debugPoint: aPoint
	
	^ self class debugPoint: aPoint in: self morph! !

!SGraphElement methodsFor: 'debugging' stamp: 'ag 4/2/2012 15:48:43.874'!
debugPoint: aPoint text: aString
	
	| newMorph |
	newMorph := self debugPoint: aPoint.
	newMorph addMorphFront:
		((StringMorph
			contents: aString)
			position: newMorph position + 3 asPoint).! !

!SGraphElement methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:53:21.419'!
morph
	
	^ morph! !

!SGraphElement methodsFor: 'accessing' stamp: 'ag 2/14/2012 21:55:02'!
morph: aMorph
	
	morph := aMorph.! !

!SGraphElement methodsFor: 'layout' stamp: 'ag 2/15/2012 12:53:30.032'!
offsetBy: aPoint
	"Change relevant information to 'move' the element by aPoint."
	
	self subclassResponsibility.! !

!SGraphElement methodsFor: 'accessing' stamp: 'ag 3/30/2012 14:46:29.571'!
subgraphNode
	^ subgraphNode! !

!SGraphElement methodsFor: 'accessing' stamp: 'ag 3/30/2012 14:46:29.6'!
subgraphNode: anObject
	subgraphNode := anObject! !

SGraphElement subclass: #SGraphNode
	instanceVariableNames: 'edges neighborNodes position corneringNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

SGraphNode subclass: #SClassGraphNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SClassGraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:29:21.768'!
isAbstract
	
	^ false! !

!SClassGraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:31:09.861'!
wrapsInstancesOf: aClass
	
	^ aClass isKindOf: SClassMorph class! !

!SClassGraphNode methodsFor: 'accessing' stamp: 'ag 3/30/2012 12:56:47.658'!
containsClass
	
	^ true! !

!SClassGraphNode methodsFor: 'tree layouting' stamp: 'ag 2/15/2012 13:13:35.115'!
getChildrenBasedOn: childCheckerBlock
	
	^ self neighborNodes select: [ :neighbor | childCheckerBlock value: self value: neighbor ]! !

!SClassGraphNode methodsFor: 'accessing' stamp: 'ag 3/30/2012 12:59:16.574'!
highestSuperclassNodeIn: collectionOfNodes
	
	morph visualizedClass allSuperclasses
		reverseDo: [ :class |
			collectionOfNodes
				detect: [ :node | node morph visualizedClass = class ]
				ifFound: [ :node | ^ node ]
				ifNone: [ "continue searching" ] ].
	^ self! !

!SGraphNode class methodsFor: 'graph constants' stamp: 'ag 2/24/2012 00:06:10.849'!
closeNeighbors
	"Return, whether neighbors of a node (or group of nodes) should be placed close to each other, or far away from each other"
	
	^ true! !

!SGraphNode class methodsFor: 'graph constants' stamp: 'ag 3/6/2012 13:45:47.753'!
cornerOrdering
	"This determines in which order neighbors are assigned to corners of their neighbor nodes."
	
	^ self closeNeighbors
		ifTrue: [ { 1. 3. 5. 7. 0. 2. 4. 6 } ] "Use sides of the nodes first, to get a closer packing. Use the corners after."
		ifFalse: [ { 0. 4. 2. 6. 1. 5. 3. 7 } ] "Try to use farthest corners first, then fill up the gaps."! !

!SGraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:27:59.827'!
isAbstract
	
	^ true! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 3/30/2012 16:30:25.768'!
absoluteBounds
	"This method goes up the subgraph-hierarchy, until there is no containing subgraphNode anymore..
	On the way, the relative positions of all SubgraphNodes are added up, to calculate the position of the receiver in the coordinate system the PasteUpMorph."
	
	| bounds |
	bounds := self bounds.
	self subgraphNode ifNil: [ ^ bounds ].
	^ self subgraphNode
		ifNil: [ ^ nil ] "This means, that this node is an element of the outermost graph, so no correct answer can be provided."
		ifNotNilDo: [ :mySubgraphNode |
			bounds translateBy: mySubgraphNode absoluteBounds origin ]! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/17/2012 12:49:45.244'!
addEdge: aGraphEdge
	"aGraphEdge has to connect the receiver with some other node. Memorize the edge and also the other node as a neighbor."
	
	neighborNodes add:
		(self
			caseOf: {
				[ aGraphEdge fromNode ] -> [ aGraphEdge toNode ].
				[ aGraphEdge toNode ] -> [ aGraphEdge fromNode ] }
			otherwise: [ ^ self ]).
	edges add: aGraphEdge.! !

!SGraphNode methodsFor: 'layout' stamp: 'ag 2/23/2012 23:01:26.471'!
applyLayout
	
	morph position: position.! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 3/7/2012 11:31:00.794'!
attach: neighbor toCorner: freeCorner
	
	| neighborCorner corner |
	neighborCorner := freeCorner + 4 \\ 8. "The opposite corner"
	self corner: freeCorner put: neighbor.
	neighbor corner: neighborCorner put: self.
	
	freeCorner even
	ifTrue: [
		"Check the corner left of the new neighbor"
		corner := freeCorner - 1 \\ 8.
		(self corner: corner)
			ifNotNilDo: [ :otherNeighbor |
				otherNeighbor corner: ((corner + 4 \\ 8) - 2 \\ 8) put: neighbor.
				neighbor corner: (neighborCorner + 1 \\ 8) put: otherNeighbor ].
	
		"Check the corner right of the new neighbor"
		corner := freeCorner + 1 \\ 8.
		(self corner: corner)
			ifNotNilDo: [ :otherNeighbor |
				otherNeighbor corner: ((corner + 4 \\ 8) + 2 \\ 8) put: neighbor.
				neighbor corner: (neighborCorner - 1 \\ 8) put: otherNeighbor ] ]
	ifFalse: [
		"Check the corner left of the new neighbor"
		corner := freeCorner - 1 \\ 8.
		(self corner: corner)
			ifNotNilDo: [ :otherNeighbor |
				otherNeighbor corner: ((corner + 4 \\ 8) - 1 \\ 8) put: neighbor.
				neighbor corner: (neighborCorner + 2 \\ 8) put: otherNeighbor ].
	
		"Check the corner right of the new neighbor"
		corner := freeCorner + 1 \\ 8.
		(self corner: corner)
			ifNotNilDo: [ :otherNeighbor |
				otherNeighbor corner: ((corner + 4 \\ 8) + 1 \\ 8) put: neighbor.
				neighbor corner: (neighborCorner - 2 \\ 8) put: otherNeighbor ].
		
		"In the case of attaching neighbor to one of my sides, check also the two adjacent sides."
		"Check the adjacent side left of the new neighbor"
		corner := freeCorner - 2 \\ 8.
		(self corner: corner)
			ifNotNilDo: [ :otherNeighbor |
				otherNeighbor corner: ((corner + 4 \\ 8) - 1 \\ 8) put: neighbor.
				neighbor corner: (neighborCorner + 1 \\ 8) put: otherNeighbor ].
		
		"Check the adjacent side right of the new neighbor"
		corner := freeCorner + 2 \\ 8.
		(self corner: corner)
			ifNotNilDo: [ :otherNeighbor |
				otherNeighbor corner: ((corner + 4 \\ 8) + 1 \\ 8) put: neighbor.
				neighbor corner: (neighborCorner - 1 \\ 8) put: otherNeighbor ] ].! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 2/17/2012 13:34:44.436'!
attractionTo: anotherNode
	"Count the number of edges connecting the receiver with anotherNode."
	
	^ self edges
		inject: 0
		into: [ :attraction :edge |
			((edge fromNode = self and: [ edge toNode = anotherNode ])
			or: [ edge toNode = self and: [ edge fromNode = anotherNode ] ])
				ifTrue: [ attraction + 1 ]
				ifFalse: [ attraction ] ]! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/16/2012 11:50:33.991'!
bounds
	
	^ self position extent: self extent! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 3/14/2012 12:47:58.265'!
center
	
	^ self bounds center! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/19/2012 00:23:09.697'!
checkRemoveNeighbor: aNode
	
	(edges noneSatisfy: [ :edge |
		edge toNode = aNode or: [ edge fromNode = aNode ] ])
			ifTrue: [ neighborNodes remove: aNode ].! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/19/2012 00:13:45.967'!
clipEdge: aGraphEdge
	"This removes aGraphEdge from the receiver and also from the other node it connects to. Can be invoked on either of the two nodes with the same effect."
	
	| removedNeighbor |
	removedNeighbor := neighborNodes detect: [ :node |
		(aGraphEdge fromNode = node or: [ aGraphEdge toNode = node ])
			and: [ node edges includes: aGraphEdge ] ].
	removedNeighbor edges remove: aGraphEdge.
	edges remove: aGraphEdge.
	removedNeighbor checkRemoveNeighbor: self.
	self checkRemoveNeighbor: removedNeighbor.! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:57:06.117'!
containsClass
	
	^ false! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 3/30/2012 13:10:06.899'!
containsSubgraph
	
	^ false! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 2/19/2012 21:15:52.179'!
corner: cornerNum
	"Access corners zero-based to properly apply module-operation when calculating nodes."
	
	^ corneringNodes at: cornerNum + 1! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 4/18/2012 13:13:38.119'!
corner: cornerNum put: aNode
	"Access corners zero-based to properly apply module-operation when calculating nodes."
	
	SClassDiagram debugShowSubgraphs
		ifTrue: [
			(corneringNodes at: cornerNum + 1) ifNotNil: [ self error: 'Overwriting an already assigned corner!!' ] ].
	corneringNodes at: cornerNum + 1 put: aNode.! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 2/16/2012 14:04:06.606'!
corneringNodes
	
	^ corneringNodes! !

!SGraphNode methodsFor: 'debugging' stamp: 'ag 2/23/2012 22:59:49.657'!
debugHighlight: aColor
	"Implemented in a subclass."! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 3/6/2012 12:35:44.586'!
distanceOfCorner: corner1 to: corner2
	
	| dist |
	dist := (corner2 - corner1) abs.
	dist > 4 ifTrue: [
		dist := (corner1 min: corner2) + (7 - (corner1 max: corner2)) + 1 ].
	^ dist! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 12:43:01.586'!
edges
	^ edges! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 12:56:20.391'!
extent
	
	^ morph extent! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 2/24/2012 00:03:32.736'!
freeCorners
	"Return free corners, in a certain sequence."
	
	| freeCorners |
	freeCorners := self class cornerOrdering asOrderedCollection.
	corneringNodes withIndexDo: [ :element :i | element ifNotNil: [ freeCorners remove: i - 1 ] ].
	^ freeCorners! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:18:54.769'!
height
	
	^ self extent y! !

!SGraphNode methodsFor: 'initialization' stamp: 'ag 2/18/2012 21:42:25.059'!
initialize
	
	super initialize.
	edges := Set new.
	neighborNodes := Set new.
	position := 0 @ 0.
	corneringNodes := Array new: 8. "starting from top-left corner, go clockwise. Includes the 4 corners and the 4 centers of the sides."! !

!SGraphNode methodsFor: 'layout' stamp: 'ag 3/30/2012 17:25:59.018'!
layoutNodes
	"Implemented in one subclass."! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 12:43:01.629'!
neighborNodes
	^ neighborNodes! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 3/7/2012 11:00:07.605'!
nextFreeCorner
	"Return the next corner of the receiver where a neighbor should be assigned to."
	
	(corneringNodes anySatisfy: #isNil)
		ifTrue: [ | anyAssignedCorner freeCorners | "There is a free corner available"
			anyAssignedCorner := nil.
			freeCorners := self class cornerOrdering asOrderedCollection.
			corneringNodes withIndexDo: [ :element :i |
				element ifNotNil: [
					anyAssignedCorner ifNil: [ anyAssignedCorner := i - 1 ].
					freeCorners remove: i - 1 ] ].
			false & self class closeNeighbors & anyAssignedCorner notNil ifTrue: [ | result |
				"Ignore the cornerOrdering and return a corner close to another, already assigned corner."
				result := freeCorners first.
				freeCorners do: [ :corner |
					(self distanceOfCorner: corner to: anyAssignedCorner) < (self distanceOfCorner: result to: anyAssignedCorner)
						ifTrue: [ result := corner ] ].
				^ result ].
			^ freeCorners first ].
	^ nil! !

!SGraphNode methodsFor: 'layout' stamp: 'ag 2/15/2012 12:54:23.054'!
offsetBy: aPoint
	
	position := position + aPoint.! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 12:43:01.65'!
position
	^ position! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 12:43:01.659'!
position: anObject
	position := anObject! !

!SGraphNode methodsFor: 'layout' stamp: 'ag 3/30/2012 17:22:50.048'!
prepareEdgeLayout
	
	self edges do: #prepareLayout.! !

!SGraphNode methodsFor: 'corner-oriented layout' stamp: 'ag 2/17/2012 13:37:30.32'!
sortedNeighbors
	"Return my neighbors, sorted by my attraction to them; highly attracted nodes first."
	
	^ (SortedCollection
		sortBlock: [ :node1 :node2 | (self attractionTo: node1) > (self attractionTo: node2) ])
		addAll: neighborNodes;
		yourself! !

!SGraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 13:18:49.438'!
width
	
	^ self extent x! !

SGraphNode subclass: #SSubgraphNode
	instanceVariableNames: 'graph debugHighlightColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SSubgraphNode class methodsFor: 'instance creation' stamp: 'ag 2/18/2012 20:52:45.822'!
createFrom: anObject
	
	(anObject isKindOf: Collection) ifTrue: [ ^ self type: self defaultGraphType withElements: anObject ].
	(anObject isKindOf: SGraph) ifTrue: [ ^ self new graph: anObject; yourself ].
	^ nil! !

!SSubgraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 13:06:31.441'!
defaultGraphType
	
	^ STreeOrientedGraph! !

!SSubgraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 14:21:44.897'!
isAbstract
	
	^ false! !

!SSubgraphNode class methodsFor: 'instance creation' stamp: 'ag 2/18/2012 20:53:04.883'!
type: aGraphClass withElements: aCollectionOfElements
	"Instance creation is allowed from collections of SGraphElements, or of objects, that are converted to SGraphElements."
	
	^ self new
		graph: (
			aGraphClass new
				addElements: (aCollectionOfElements collect: [ :element | SGraphElement buildFrom: element ]);
				yourself);
		yourself! !

!SSubgraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 14:08:45.824'!
wrapsInstancesOf: aClass
	
	^ (aClass isKindOf: Collection class) or: [ aClass isKindOf: SGraph class ]! !

!SSubgraphNode methodsFor: 'layout' stamp: 'ag 3/30/2012 13:01:18.86'!
applyLayout
	"Just until applying the layout, the subgraph has a distinct coordinate-system from its owner.
	The elements are translated back, just in case if the same graph is used again."
	
	graph offsetBy: position.
	debugHighlightColor
		ifNil: [
			graph applyLayout ]
		ifNotNil: [
			graph applyDebugLayout.
			self showDebugHighlight ].
	graph offsetBy: position negated.! !

!SSubgraphNode methodsFor: 'accessing' stamp: 'ag 2/16/2012 11:56:29.423'!
bounds
	
	^ graph bounds translateBy: self position! !

!SSubgraphNode methodsFor: 'accessing' stamp: 'ag 3/30/2012 13:10:41.867'!
containsSubgraph
	
	^ true! !

!SSubgraphNode methodsFor: 'debugging' stamp: 'ag 2/23/2012 23:49:50.017'!
debugHighlight: aColor
	
	debugHighlightColor := aColor.! !

!SSubgraphNode methodsFor: 'accessing' stamp: 'ag 2/16/2012 11:55:56.779'!
extent
	
	^ graph bounds extent! !

!SSubgraphNode methodsFor: 'accessing' stamp: 'ag 2/15/2012 12:38:36.638'!
graph
	^ graph! !

!SSubgraphNode methodsFor: 'accessing' stamp: 'ag 3/30/2012 15:01:03.021'!
graph: anObject
	"This is the initialization routine. Tell all elements in the contained graph, that the receiver is their direct containing subgraphNode."
	
	graph := anObject.
	graph elements do: [ :element | element subgraphNode: self ].! !

!SSubgraphNode methodsFor: 'layout' stamp: 'ag 3/30/2012 17:25:10.053'!
layoutNodes
	"Do not layout the edges here, they have to be laid out, after all the subgraphs
	are finished positioning their nodes."
	
	graph layoutNodes.! !

!SSubgraphNode methodsFor: 'accessing' stamp: 'ag 3/6/2012 15:41:02.082'!
morph
	"Go into subgraphs, until we meet a real morph."
	
	^ graph nodes
		ifEmpty: [ nil ]
		ifNotEmptyDo: [ :nodes | nodes anyOne morph ]! !

!SSubgraphNode methodsFor: 'layout' stamp: 'ag 3/30/2012 17:25:04.252'!
prepareEdgeLayout
	
	super prepareEdgeLayout.
	graph nodes do: #prepareEdgeLayout. "Its ok that this is called multiplt times on the same edge."! !

!SSubgraphNode methodsFor: 'debugging' stamp: 'ag 3/15/2012 11:18:51.043'!
showDebugHighlight
	
	| rect |
	rect := SDebugRectangleMorph new.
	rect
		position: self position;
		extent: self extent;
		color: debugHighlightColor.
	self morph ifNotNilDo: [ :morph | morph owner addMorphFront: rect ].! !

SGraphNode subclass: #STextGraphNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!STextGraphNode class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:29:24.558'!
isAbstract
	
	^ false! !

!STextGraphNode class methodsFor: 'instance creation' stamp: 'ag 3/6/2012 22:01:08.082'!
wrapsInstancesOf: aClass
	
	^ aClass = SStickySourceCodeMorph | (aClass = SNoteMorph)! !

SGraphElement subclass: #SIgnoredGraphElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SIgnoredGraphElement class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 09:44:19.153'!
isAbstract
	
	^ false! !

!SIgnoredGraphElement class methodsFor: 'instance creation' stamp: 'ag 2/15/2012 12:30:24.368'!
wrapsInstancesOf: aClass
	
	^ (aClass isKindOf: SSmartLabelMorph class) | (aClass = SDiagramMorphToolbar)! !

!SIgnoredGraphElement methodsFor: 'layout' stamp: 'ag 2/15/2012 09:45:47.46'!
applyLayout
	"do nothing"
	! !

Object subclass: #SRefactoring
	instanceVariableNames: 'refactorings name showChanges closeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Tools'!

!SRefactoring class methodsFor: 'instance creation' stamp: 'sp 6/8/2012 15:22:18.441'!
execute: aRefactoring

	^self new
		refactorings: {aRefactoring};
		execute;
		yourself.! !

!SRefactoring class methodsFor: 'instance creation' stamp: 'ag 6/23/2012 11:18:24.099'!
execute: aRefactoring onClose: aBlock

	^self new
		refactorings: {aRefactoring};
		closeBlock: aBlock;
		execute;
		yourself.! !

!SRefactoring class methodsFor: 'instance creation' stamp: 'sp 6/8/2012 13:33:21.204'!
executeMultiple: aRefactoringList name: aString

	^self new
		refactorings: aRefactoringList;
		name: aString;
		execute;
		yourself.! !

!SRefactoring class methodsFor: 'instance creation' stamp: 'ag 6/23/2012 11:17:52.791'!
executeMultiple: aRefactoringList name: aString onCancel: aBlock

	^self new
		refactorings: aRefactoringList;
		closeBlock: aBlock;
		name: aString;
		execute;
		yourself.! !

!SRefactoring methodsFor: 'accessing' stamp: 'ag 6/23/2012 11:18:05.9'!
closeBlock
	^closeBlock! !

!SRefactoring methodsFor: 'accessing' stamp: 'ag 6/23/2012 11:17:52.535'!
closeBlock:  aBlock
	closeBlock := aBlock.
! !

!SRefactoring methodsFor: 'execution' stamp: 'sp 7/2/2012 11:05:55.868'!
execute

	| refactoringChanges |
	
	showChanges ifTrue: [
		refactoringChanges := self primitiveExecute.			
		(self hasNestedChanges: refactoringChanges) ifTrue: [	
			SRefactoringChangeBrowser openChange: refactoringChanges onClose: closeBlock.
		] ifFalse: [
			(SRefactoringChange on: refactoringChanges) executeNotifying: [].
			closeBlock ifNotNil: [closeBlock value].
			]  
		
	] ifFalse: [
		refactorings do: [ :refactoring | 
			self setSRefactoringOptions: refactoring.  
			refactoring execute. ].
	].! !

!SRefactoring methodsFor: 'execution' stamp: 'sp 6/22/2012 12:19:14.643'!
hasNestedChanges: aRefactoringChange

	^ (SRefactoringChange on: aRefactoringChange) changes size > 1.! !

!SRefactoring methodsFor: 'initialize-release' stamp: 'sp 6/8/2012 13:14:41.914'!
initialize 

	showChanges := true. "TODO: get from path view prefs"! !

!SRefactoring methodsFor: 'accessing' stamp: 'sp 6/8/2012 13:34:06.576'!
name
	^ name
! !

!SRefactoring methodsFor: 'accessing' stamp: 'sp 6/8/2012 13:34:06.606'!
name: anObject
	name := anObject! !

!SRefactoring methodsFor: 'execution' stamp: 'sp 7/2/2012 11:07:26.871'!
primitiveExecute
	"checks preconditions of refactorings and set our options"

	| refactoringChanges |
	
	self refactorings size > 1 ifTrue: [
		refactoringChanges := CompositeRefactoryChange named: self name.
		self refactorings do: [ :refactoring |
			self setSRefactoringOptions: refactoring.
			refactoring primitiveExecute.
			(self hasNestedChanges: refactoring changes) ifTrue: [
				refactoringChanges addChange: refactoring changes. ].]

	] ifFalse: [
		refactoringChanges := self refactorings first changes.
		self setSRefactoringOptions: self refactorings first.  
		self refactorings first primitiveExecute.
	].  

	^refactoringChanges.! !

!SRefactoring methodsFor: 'accessing' stamp: 'sp 6/8/2012 13:23:13.097'!
refactorings
	^refactorings! !

!SRefactoring methodsFor: 'accessing' stamp: 'sp 6/8/2012 13:23:03.549'!
refactorings: aRefactoringList

	refactorings := aRefactoringList.! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:38:26.636'!
requestImplementorToInline: aCollection
	^ Smalltalk classNamed: (self
		chooseFrom: (aCollection collect: [ :each | each name ])
		title: 'Which implementation should be inlined?')! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:39:59.928'!
requestMethodNameFor: aMethodName
	| string parser pattern |
	string := UIManager default  
		request: 'Method Name:'
		initialAnswer: aMethodName asString.
	parser := RBParser new.
	parser errorBlock: [ :error :position | ^ nil ].
	parser initializeParserWith: string.
	pattern := parser parseMessagePattern.
	^ RBMethodName
		selector: pattern selector
		arguments: pattern argumentNames! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 11:39:04.017'!
requestSelfArgumentName
	"TODO accept canceling"
	^ UIManager default request: 'Enter name for argument to refer to "self" in extracted method'! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 11:37:33.198'!
selectVariableToMoveMethodTo: aSelector class: aClass
	| parseTree nameList | 
	parseTree := aClass parseTreeFor: aSelector.
	parseTree isNil ifTrue: [ 
		parseTree := RBMethodNode 
			selector: #value
			body: (RBSequenceNode statements: #()) ].
	nameList := OrderedCollection new.
	nameList
		addAll: parseTree argumentNames asSortedCollection;
		addAll: aClass allInstanceVariableNames asSortedCollection.
	nameList isEmpty ifTrue: [ self inform: 'No variable to select.'. ^nil.].   
	^ UIManager default 
		chooseFrom: nameList
		values: nameList
		lines: (Array with: parseTree argumentNames size)
		title: 'Select variable to move method into:'! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:48:46.025'!
selectVariableTypesFrom: aCollectionOfTypes selected: aSelectedCollection for: aRefactoring
	| stream result |
	stream := WriteStream on: String new.
	aCollectionOfTypes
		do: [ :each | stream nextPutAll: each name ]
		separatedBy: [ stream cr ].
	result := UIManager default
			multiLineRequest: 'Select classes to move to:'
			centerAt: Sensor cursorPoint
			initialAnswer: stream contents
			answerHeight: 200.
	result isNil
		ifTrue: [ ^ self uiCancellationError ].
	^ (result findTokens: String crlf)
		collect: [ :each | aRefactoring model classFor: (Smalltalk classNamed: each withBlanksTrimmed) ]
		! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:57:12.406'!
setSRefactoringOptions: aRefactoring

	aRefactoring
		setOption: #implementorToInline
		toUse: [ :ref :imps | self requestImplementorToInline: imps ];
		setOption: #methodName
		toUse: [ :ref :string | self requestMethodNameFor: string ];
		setOption: #selfArgumentName
		toUse: [ :ref | self requestSelfArgumentName ];
		setOption: #selectVariableToMoveTo
		toUse: [ :ref :class :selector | self selectVariableToMoveMethodTo: selector class: class ];
		setOption: #variableTypes
		toUse: [ :ref :types :selected | self selectVariableTypesFrom: types selected: selected for: ref ];
		setOption: #extractAssignment
		toUse: [ :ref :string | self shouldExtractAssignmentTo: string ];
		setOption: #inlineExpression
		toUse: [ :ref :string | self shouldInlineExpression: string ];
		setOption: #alreadyDefined
		toUse: [ :ref :class :selector | self shouldOverride: selector in: class ];
		setOption: #useExistingMethod
		toUse: [ :ref :selector | self shouldUseExistingMethod: selector ].
		"set no browser environment for #openBrowser"! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:51:48.576'!
shouldExtractAssignmentTo: aString
	^ self confirm:
		('Do you want to extract the assignment of <1s> at the end of selection?' expandMacrosWith: aString)! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:52:31.853'!
shouldInlineExpression: aString
	^ self confirm: 
		('Do you want to inline <1s>? If not, it will be assigned as a temporary.' expandMacrosWith: aString)! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:53:46.862'!
shouldOverride: aSelector in: aClass 
	^ self confirm: 
		('<1s> is already defined in the <2p> hierarchy. 
		Extracting it to an existing selector may change behavior. 
		Do you wish to use <1s> anyway?' expandMacrosWith: aSelector with: aClass)! !

!SRefactoring methodsFor: 'refactoring options' stamp: 'sp 7/2/2012 10:53:54.897'!
shouldUseExistingMethod: aSelector
	^ self confirm: 
		('Use existing method <1s> instead of creating new method?' expandMacrosWith: aSelector)! !

!SRefactoring methodsFor: 'accessing' stamp: 'sp 6/8/2012 13:13:00.134'!
showChanges
	^ showChanges! !

!SRefactoring methodsFor: 'accessing' stamp: 'sp 6/8/2012 13:13:00.145'!
showChanges: aBoolean
	showChanges := aBoolean.
! !

Object subclass: #SRefactoringChange
	instanceVariableNames: 'change parent changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Tools'!

!SRefactoringChange class methodsFor: 'instance creation' stamp: 'tfel 6/4/2012 14:30:41.508'!
on: aChange

	^ self new
		change: aChange;
		yourself! !

!SRefactoringChange methodsFor: 'private' stamp: 'tfel 6/4/2012 14:35:23.155'!
add: aChange to: aCollection
	| node |
	aChange change changes do: [:each |
		aChange change == each ifFalse: [
			node := (self class on: each) parent: aChange.
			aCollection addLast: node.
			self add: node to: aCollection]].
	^ aCollection! !

!SRefactoringChange methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:13:59.013'!
change
	"Answer the value of change"

	^ change! !

!SRefactoringChange methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:13:59.021'!
change: anObject
	"Set the value of change"

	change := anObject! !

!SRefactoringChange methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:32:05.119'!
changes

	^ changes ifNil: [changes := self add: self to: OrderedCollection new]! !

!SRefactoringChange methodsFor: 'proxying' stamp: 'tfel 6/4/2012 14:21:29.519'!
execute

	^ change execute! !

!SRefactoringChange methodsFor: 'proxying' stamp: 'tfel 6/4/2012 14:21:20.445'!
executeNotifying: aBlock  

	^ change executeNotifying: aBlock  ! !

!SRefactoringChange methodsFor: 'proxying' stamp: 'tfel 6/4/2012 14:38:29.916'!
name

	^ change name! !

!SRefactoringChange methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:13:59.028'!
parent
	"Answer the value of parent"

	^ parent! !

!SRefactoringChange methodsFor: 'accessing' stamp: 'tfel 6/4/2012 14:13:59.035'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!SRefactoringChange methodsFor: 'proxying' stamp: 'tfel 6/4/2012 14:38:35.686'!
printString

	^ change printString! !

PluggablePanelSpec subclass: #SPathViewDiagramSpec
	instanceVariableNames: 'viewAreaMorph miniMap scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SPathViewDiagramSpec commentStamp: 'omg 6/14/2011 14:31:01.408' prior: 0!
A SPathViewDiagramSpec is responsible for drawing the passed viewAreaMorph within a scroller and provide a MiniMap to go with it.!

!SPathViewDiagramSpec methodsFor: 'building' stamp: 'ag 12/4/2011 13:57:24.818'!
buildWith: aBuilder
	| widget |
	widget := super buildWith: aBuilder.
	widget
		addMorph: self scrollPane;
		addMorph: self miniMap.
	^ widget! !

!SPathViewDiagramSpec methodsFor: 'building' stamp: 'ag 12/29/2011 16:40:13.798'!
miniMap
	
	^ miniMap ifNil: [
		miniMap := SMiniMap on: viewAreaMorph in: scrollPane.
		STool setOffsetFrame: (10 asPoint corner: 0 asPoint) in: miniMap.
		viewAreaMorph minimap: miniMap.
		miniMap ]! !

!SPathViewDiagramSpec methodsFor: 'building' stamp: 'ag 12/29/2011 15:22:51.947'!
scrollPane

	^ scrollPane ifNil: [
		scrollPane := SScrollPane forMorph: viewAreaMorph.
		scrollPane borderWidth: 0.
		STool setFrame: (0.01 asPoint corner: 0.99 asPoint) in: scrollPane.
		scrollPane scrollBy: ((viewAreaMorph extent / 2) - (scrollPane scroller extent * 2)) negated.
		scrollPane ]! !

!SPathViewDiagramSpec methodsFor: 'accessing' stamp: 'omg 6/14/2011 14:30:22.321'!
viewAreaMorph: aMorph
	
	viewAreaMorph := aMorph.! !

TextMorph subclass: #SFloatingCodeSnippet
	instanceVariableNames: 'originalMethod selectionInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SFloatingCodeSnippet class methodsFor: 'instance creation' stamp: 'ag 6/28/2012 12:13:07.861'!
forText: aText
	
	^ self new contentsAsIs: aText! !

!SFloatingCodeSnippet class methodsFor: 'instance creation' stamp: 'ag 6/28/2012 12:13:47.379'!
inHand: aHand forText: aText
	
	| morph |
	morph := self new contentsAsIs: aText.
	morph position: aHand position.
	aHand grabMorph: morph.
	^ morph! !

!SFloatingCodeSnippet methodsFor: 'reengineering' stamp: 'ag 6/28/2012 14:22:04.261'!
askUserWhetherComponentRefactoring: aClass
	
	^ self confirm: 'Will the receiver delegate to another instance of ', aClass name, '?'! !

!SFloatingCodeSnippet methodsFor: 'initialization' stamp: 'ag 6/28/2012 15:17:02.023'!
initialize
	
	super initialize.
	self backgroundColor: Color lightGray.! !

!SFloatingCodeSnippet methodsFor: 'reengineering' stamp: 'ag 7/2/2012 14:03:45.849'!
isComponentRefactoring: aClass
	"If the target class is one of the superclasses of our original class, we have to ask the user to know the answer.
	If we are extracting the method-snippet into a totally different class, it has to be a component refactoring."
	
	^ (originalMethod key = aClass) not
		or: [ self askUserWhetherComponentRefactoring: aClass ]! !

!SFloatingCodeSnippet methodsFor: 'accessing' stamp: 'ag 6/28/2012 12:27:03.518'!
originalMethod
	^ originalMethod! !

!SFloatingCodeSnippet methodsFor: 'accessing' stamp: 'ag 6/28/2012 12:27:03.775'!
originalMethod: anObject
	originalMethod := anObject! !

!SFloatingCodeSnippet methodsFor: 'reengineering' stamp: 'sp 7/2/2012 14:34:54.994'!
processReengeneeringInto: aClassMorph
	
	| aClass |
	aClass := aClassMorph visualizedClass.
	self abandon.
	SRefactoring
		execute:
			((self isComponentRefactoring: aClass)
				ifTrue: [
					(SExtractMethodToComponentRefactoring
						extract: selectionInterval
						from: originalMethod value
						in: originalMethod key)
						targetClass: aClass;
						yourself ]
				ifFalse: [
					SExtractMethodRefactoring
						extract: selectionInterval
						from: originalMethod value
						in: originalMethod key
						to: aClass ])! !

!SFloatingCodeSnippet methodsFor: 'accessing' stamp: 'ag 6/28/2012 14:49:54.312'!
selectionInterval
	^ selectionInterval! !

!SFloatingCodeSnippet methodsFor: 'accessing' stamp: 'ag 6/28/2012 14:49:54.351'!
selectionInterval: anObject
	selectionInterval := anObject! !

!SFloatingCodeSnippet methodsFor: 'reengineering' stamp: 'ag 6/28/2012 13:24:44.643'!
wantsReengineeringInto: aClass
	"Allow reengeneering into all classes."
	
	^ true! !

!Rectangle methodsFor: '*Path-View-GraphLayout' stamp: 'ag 3/14/2012 14:01:04.575'!
cornerNearsetTo: aPoint
	"Not the fastest code, but short and readable. Should be rewritten, if a fast calculation is needed."
	
	^ #( topLeft topRight bottomLeft bottomRight )
		detectMin: [ :symbol |
			(self perform: symbol) dist: aPoint ]! !

AddMethodRefactoring subclass: #SAddMethodRefactoring
	instanceVariableNames: 'targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SAddMethodRefactoring methodsFor: 'preconditions' stamp: 'sp 7/5/2012 13:41:44.667'!
preconditions
	| selector method |
	method := RBParser parseMethod: source
				onError: 
					[:string :position | 
					^RBCondition 
						withBlock: [self refactoringError: 'The sources could not be parsed']].
	selector := method selector.
	.
	selector isNil ifTrue: [self refactoringError: 'Invalid source.'].
	
	"we are doing reeingineering, not refactoring especially thus only check if the class itself is not implementing selector already"
	^(RBCondition 
		definesSelector: selector
		in: (self model classFor: class) ) not! !

!RBCondition class methodsFor: '*Path-View-Refactoring-instance creation' stamp: 'tfel 6/26/2012 18:00:04.106'!
hierarchyOf: aClass includes: aSuperclass
	^self new
		type: (Array with: #hierarchyIncludesSuperclass with: aClass with: aSuperclass)
		block: [aClass withAllSubclasses, aClass allSuperclasses includes: aSuperclass]
		errorString: aClass printString , ' cannot meaningfully become a subclass of ' , aSuperclass.! !

NCSmartLabelMorph subclass: #SSmartLabelMorph
	instanceVariableNames: 'connector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

SSmartLabelMorph subclass: #SAssociationLabelMorph
	instanceVariableNames: 'containerType keyType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

!SAssociationLabelMorph class methodsFor: 'instance creation' stamp: 'ag 10/29/2011 15:09:49.69'!
openOn: aConnector targetingClass: aTargetClass
	
	| keyType containerType |
	keyType := containerType := nil.
	aTargetClass isBehavior ifFalse: [
		keyType := aTargetClass typeOfKeys.
		containerType := aTargetClass typeOfContainer ].
	^ (super openOn: aConnector)
		keyType: keyType;
		containerType: containerType;
		yourself! !

!SAssociationLabelMorph methodsFor: 'accessing' stamp: 'ag 10/25/2011 11:23:05.576'!
containerType
	^ containerType! !

!SAssociationLabelMorph methodsFor: 'accessing' stamp: 'ag 10/25/2011 11:23:05.599'!
containerType: anObject
	containerType := anObject! !

!SAssociationLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 11/11/2011 11:51:29.232'!
grabAction
	"If a key-type is present, use it. Else, use the container-type."
	
	| classMorph |
	classMorph := SClassMorph on: (self keyType ifNil: [ self containerType ]).
	SNoteConnector basicNew fromMorph: self toMorph: classMorph. "Don't use openFor:connectedTo:, it assumes an SClassDigaramMorph"
	^ classMorph openInHand; yourself! !

!SAssociationLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 10/29/2011 15:26:17.524'!
hasGrabAction
	"This is beautiful :-)"
	
	^ { containerType. keyType } anySatisfy: #notNil! !

!SAssociationLabelMorph methodsFor: 'accessing' stamp: 'ag 10/25/2011 11:23:05.615'!
keyType
	^ keyType! !

!SAssociationLabelMorph methodsFor: 'accessing' stamp: 'ag 10/25/2011 11:23:05.626'!
keyType: anObject
	keyType := anObject! !

SSmartLabelMorph subclass: #SInheritenceLabelMorph
	instanceVariableNames: 'classCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

!SInheritenceLabelMorph class methodsFor: 'instance creation' stamp: 'ag 10/12/2011 15:22:46.826'!
openOn: aConnector containing: aClassCollection
	
	^ (super openOn: aConnector)
		classCollection: aClassCollection;
		yourself! !

!SInheritenceLabelMorph methodsFor: 'accessing' stamp: 'ag 10/12/2011 15:37:49.551'!
classCollection: anObject
	
	classCollection := anObject.
	classCollection
		ifNotNil: [
			self initializeString: 
				(classCollection
					inject: 'via'
					into: [ :str :c | str, Character cr, c ]) ].! !

!SInheritenceLabelMorph methodsFor: 'accessing' stamp: 'ag 10/25/2011 11:18:18.974'!
classCollectionSize
	
	^ classCollection
		ifNil: [ 0 ]
		ifNotNil: [ classCollection size ]! !

!SInheritenceLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 10/25/2011 11:18:40.222'!
grabAction
	
	^ self openSuperClass:
			(self classCollectionSize = 1
				ifTrue: [ classCollection first ]
				ifFalse: [ 
					(SMultipleChoiceRequest prompt: 'Choose a superclass'
						labels: (classCollection collect: [:c | c name])
						values: classCollection) ])! !

!SInheritenceLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 10/29/2011 15:02:59.748'!
hasGrabAction
	
	^ self classCollectionSize > 0! !

!SInheritenceLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 12/26/2011 15:20:53.871'!
openSuperClass: aClass
	
	| target |
	aClass ifNil: [ ^ nil ].
	self abandon.
	connector abandon.	
	target := SClassMorph on: aClass.
	SInheritanceConnector openFor: (connector sourceMorph) connectedTo: target.		
	SInheritanceConnector openFor: target connectedTo: connector targetMorph.
	target openInHand.
	connector sourceMorph highlightClassMorphs: target klass.
	^ target! !

!SSmartLabelMorph class methodsFor: 'constants' stamp: 'ag 11/11/2011 17:00:04.631'!
hoveredBackground
	
	^ Color blue muchLighter alpha: 0.8! !

!SSmartLabelMorph class methodsFor: 'instance creation' stamp: 'ag 10/28/2011 12:45:48.534'!
openOn: aConnector
	
	| instance |
	instance := self new.
	instance
		align: instance center with: aConnector position;
		attachUnobnoxiouslyTo: aConnector at: aConnector center;
		connector: aConnector.  
	aConnector pasteUpMorphOrWorld addMorphFront: instance. "To make the label grabbable. Morph must delete the label!!"
	aConnector label: instance.
	^ instance! !

!SSmartLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 11/11/2011 16:56:10.33'!
aboutToBeGrabbedBy: aHand
	
	self unhighlight.
	^ self hasGrabAction
		ifTrue: [ self grabAction ]! !

!SSmartLabelMorph methodsFor: 'accessing' stamp: 'fb 6/16/2011 11:47:05.239'!
connector: aConnector

	connector := aConnector ! !

!SSmartLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 10/12/2011 15:28:51.836'!
grabAction
	
	self subclassResponsibility.! !

!SSmartLabelMorph methodsFor: 'event handling' stamp: 'ag 11/11/2011 16:53:05.692'!
handlesMouseOver: anEvent
	
	^ true! !

!SSmartLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 10/12/2011 15:19:08.044'!
hasGrabAction
	"Return true, if the label wants to perform special actions when being grabbed."
	
	^ false! !

!SSmartLabelMorph methodsFor: 'initialization' stamp: 'ag 10/28/2011 12:42:38.919'!
initializeString: aString
	
	self
		string: aString
		wrap: false;
		dieWithInput: true;
		forceTextLocked: true;
		acceptOnCR: false;
		acceptOnFocusLoss: false.! !

!SSmartLabelMorph methodsFor: 'event handling' stamp: 'ag 11/11/2011 16:58:31.474'!
mouseEnter: anEvent
	
	self hasGrabAction ifTrue: [
		self backgroundColor: self class hoveredBackground ].! !

!SSmartLabelMorph methodsFor: 'event handling' stamp: 'ag 11/11/2011 16:56:24.573'!
mouseLeave: anEvent
	
	self unhighlight.! !

!SSmartLabelMorph methodsFor: 'dropping/grabbing' stamp: 'ag 11/11/2011 16:56:33.606'!
unhighlight
	
	self backgroundColor: Color transparent.! !

Notification subclass: #SMultipleChoiceRequest
	instanceVariableNames: 'labels values lines prompt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:40:55.109'!
labels: aCollection

	^ self
		prompt: ''
		labels: aCollection
		values: aCollection
		lines: #()
		! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:42:12.797'!
labels: aCollection lines: anotherCollection

	^ self
		prompt: ''
		labels: aCollection
		values: aCollection
		lines: anotherCollection! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:45:00.439'!
labels: aCollection values: anotherCollection

	^ self
		prompt: '' labels: aCollection values: anotherCollection lines: #()! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:44:54.029'!
labels: aCollection values: anotherCollection lines: anArray

	^ self
		prompt: '' labels: aCollection values: anotherCollection lines: anArray! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:41:19.714'!
new

	self error: ['Use one of my factories to instanciate me'].! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:43:49.589'!
prompt: aString labels: aCollection

	^ self
		prompt: aString labels: aCollection values: aCollection lines: #()! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:44:28.732'!
prompt: aString labels: aCollection lines: anArray

	^ self
		prompt: aString labels: aCollection values: aCollection lines: anArray! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:45:23.565'!
prompt: aString labels: aCollection values: anotherCollection

	^ self
		prompt: aString labels: aCollection values: anotherCollection lines: #()! !

!SMultipleChoiceRequest class methodsFor: 'instance creation' stamp: 'tfel 5/12/2011 14:52:24.161'!
prompt: aString labels: aCollection values: anotherCollection lines: anArray

	^ self basicNew
		initialize;
		setPrompt: aString labels: aCollection values: anotherCollection lines: anArray;
		signal! !

!SMultipleChoiceRequest methodsFor: 'exceptionDescription' stamp: 'tfel 5/12/2011 14:51:27.7'!
defaultAction

	^ self show! !

!SMultipleChoiceRequest methodsFor: 'private' stamp: 'tfel 5/12/2011 14:47:25.757'!
setPrompt: aString labels: aCollection values: anotherCollection lines: anArray

	prompt := aString.
	labels := aCollection.
	values := anotherCollection.
	lines := anArray.! !

!SMultipleChoiceRequest methodsFor: 'handling' stamp: 'fb 5/12/2011 15:54:34.952'!
show

	self resume: (UIManager default
		chooseFrom: labels asArray 
		values: values asArray 
		lines: lines
		title: prompt)! !

Notification subclass: #SVisitorNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Visitors'!

PolygonMorph subclass: #SSelectionMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SSelectionMorph class methodsFor: 'instance creation' stamp: 'ag 8/9/2011 16:45:39.515'!
new
	"Before an instance of this can be used, #initializeAt: has to be called."
	
	^ (super
		vertices: (Array new: 4 withAll: 0@0)
		color: Color transparent
		borderWidth: 1
		borderColor: Color gray)
		dashedBorder:  { 5. 7. Color transparent }! !

!SSelectionMorph class methodsFor: 'instance creation' stamp: 'ag 8/9/2011 16:44:18.663'!
newAt: initialPosition
	
	^ self new initializeAt: initialPosition  ! !

!SSelectionMorph methodsFor: 'selection' stamp: 'ag 8/9/2011 16:46:43.865'!
initializeAt: position
	
	self verticesAt: 1 put: position.
	self verticesAt: 2 put: position + (1@0).
	self verticesAt: 3 put: position + (0@1).
	self verticesAt: 4 put: position + (1@1).! !

!SSelectionMorph methodsFor: 'stepping and presenter' stamp: 'fb 7/5/2011 12:01:52.362'!
step
	| topLeft position |

	topLeft := self vertices at: 1.
	position := self globalPointToLocal: self currentHand position.
	self vertices at: 2 put: (topLeft x @ position y).
	self vertices at: 3 put: position. "bottom right"
	self vertices at: 4 put: (position x @ topLeft y). "top right"
	self computeBounds.! !

!SSelectionMorph methodsFor: 'testing' stamp: 'fb 7/5/2011 13:35:51.537'!
stepTime 
	
	^ 10! !

MCMczWriter subclass: #SPVMczWriter
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Monticello'!

!SPVMczWriter class methodsFor: 'constants' stamp: 'tfel 7/14/2011 12:36:13.111'!
diagramsMember

	^ 'pathViewDiagrams/'! !

!SPVMczWriter class methodsFor: 'testing' stamp: 'tfel 7/14/2011 13:06:14.146'!
fileOut: aVersion onZip: aZip

	^ [self new
		zip: aZip;
		version: aVersion;
		fileOut;
		yourself] on: Error do: [self inform: 'There was an error in ', self class name
								"Avoid not being able to commit"]! !

!SPVMczWriter class methodsFor: 'testing' stamp: 'tfel 6/14/2011 14:43:32.916'!
isRefinementFor: aClass

	^ aClass == MCMczWriter! !

!SPVMczWriter class methodsFor: 'constants' stamp: 'tfel 6/21/2011 15:21:30.434'!
typeHarvestMember

	^ 'typeHarvest'! !

!SPVMczWriter methodsFor: 'actions' stamp: 'tfel 7/14/2011 12:30:02.745'!
fileOut
	| sproject |
	sproject := (SProject projectAt: version package name asSymbol).
	sproject ifNil: [Transcript show: 'No PathProject for ', version package name; cr. ^ self.].
	self
		fileOutTypeHarvest: sproject;
		fileOutDiagrams: sproject.
! !

!SPVMczWriter methodsFor: 'actions' stamp: 'ag 12/12/2011 16:50:39.804'!
fileOutDiagrams: sproject
	
	sproject views do: [:classDiagram | | memberStream |
		memberStream := RWBinaryOrTextStream on: String new.
		classDiagram saveOnStream: memberStream.
		zip	addString: memberStream contents
			as: SPVMczWriter diagramsMember, classDiagram savedName].! !

!SPVMczWriter methodsFor: 'actions' stamp: 'tfel 7/14/2011 12:30:23.963'!
fileOutTypeHarvest: sproject
	| types typesBin |
	types := (sproject typesBucket storeString).
	typesBin := (self serializeInBinary: sproject typesBucket convertToSymbols).
	zip
		addString: types as: SPVMczWriter typeHarvestMember;
		addString: typesBin as: SPVMczWriter typeHarvestMember, '.bin'.
! !

!SPVMczWriter methodsFor: 'accessing' stamp: 'tfel 6/14/2011 15:03:33.102'!
version: aVersion

	version := aVersion.! !

!SPVMczWriter methodsFor: 'accessing' stamp: 'tfel 6/14/2011 15:03:25.995'!
zip: aZipArchive

	zip := aZipArchive.! !

ThumbnailMorph subclass: #SSmoothableThumbnailMorph
	instanceVariableNames: 'smoothing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SSmoothableThumbnailMorph methodsFor: 'display' stamp: 'ag 12/31/2011 10:18:35.101'!
drawMeOn: aCanvas 
	"Method copied from superclass. Only change is to adjust the smoothing-parameter to the magnify:by:smoothing: call to achieve variable thumbnail quality."


	"Draw a small view of a morph in another place.  Guard against infinite recursion if that morph has a thumbnail of itself inside.  Now also works if the thing to draw is a plain Form rather than a morph."

	| viewedMorphBox scale c shrunkForm aWorld aFormOrMorph  |
	self superDrawOn: aCanvas.
	((aFormOrMorph := self formOrMorphToView) isForm) 
		ifTrue: [^self drawForForm: aFormOrMorph on: aCanvas].
	(((aFormOrMorph notNil and: [(aWorld := aFormOrMorph world) notNil]) 
		and: [aWorld ~~ aFormOrMorph or: [lastFormShown isNil]]) 
			and: [RecursionDepth + 1 < RecursionMax]) 
			ifTrue: 
				[RecursionDepth := RecursionDepth + 1.
				viewedMorphBox := aFormOrMorph fullBounds.
			scale :=  self scaleFor: viewedMorphBox in: self innerBounds.
				c := Display defaultCanvasClass extent: viewedMorphBox extent
							depth: aCanvas depth.
				c translateBy: viewedMorphBox topLeft negated
					during: 
						[:tempCanvas | 
						"recursion happens here"
						tempCanvas fullDrawMorph: aFormOrMorph].
				shrunkForm := c form 
							magnify: c form boundingBox
							by: scale
							smoothing: self smoothing.
				lastFormShown := shrunkForm.
				RecursionDepth := RecursionDepth - 1]
			ifFalse: 
				["This branch used if we've recurred, or if the thumbnail views a World that's already been rendered once, or if the referent is not in a world at the moment"
				lastFormShown ifNotNil: [shrunkForm := lastFormShown]].
	shrunkForm ifNotNil: 
			[aCanvas paintImage: shrunkForm
				at: self center - shrunkForm boundingBox center]! !

!SSmoothableThumbnailMorph methodsFor: 'initialization' stamp: 'ag 12/31/2011 10:11:09.021'!
initialize
	
	super initialize.
	smoothing := 1.! !

!SSmoothableThumbnailMorph methodsFor: 'accessing' stamp: 'ag 12/31/2011 09:51:59.855'!
smoothing
	^ smoothing! !

!SSmoothableThumbnailMorph methodsFor: 'accessing' stamp: 'ag 12/31/2011 09:51:59.885'!
smoothing: anObject
	smoothing := anObject! !

!ThumbnailMorph methodsFor: '*Path-View' stamp: 'ag 12/31/2011 10:18:28.924'!
superDrawOn: aCanvas
	"Needed by SSmoothableThumbnailMorph to override drawMeOn:, which required the super-drawOn: method.
	Workaround to get the smoothing: parameter adjustable when drawing the thumbnail."
	
	super drawOn: aCanvas.! !

RectangleMorph subclass: #SClassDiagramMorph
	instanceVariableNames: 'klass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SClassDiagramMorph commentStamp: 'tfel 5/20/2011 09:47:31.539' prior: 0!
A SClassDiagramMorph is a morph to be displayed in a class diagram. All SClassDiagramMorphs have their displayed Class in the instance variable #klass.

They provide hooks for listening to system events (class changes and the like) via the class side methods #interestingSystemEvents and #systemEventHandler.

They provide hooks for mouse event handling via the instance side #mouseActions hook.
!

!SClassDiagramMorph class methodsFor: 'accessing' stamp: 'ag 9/8/2011 13:08:22.795'!
currentTypeBucketFor: aClass
	
	^ SProject current
		ifNil: [ nil ]
		ifNotNilDo: [ :project |
			project typesBucket
				ifNil: [ nil ]
				ifNotNilDo: [ :bucket |
					(bucket includesMemberTypeMapFor: aClass)
						ifTrue: [ bucket ]
						ifFalse: [ nil ] ] ]! !

!SClassDiagramMorph class methodsFor: 'loading/saving' stamp: 'tfel 6/5/2012 16:18:52.198'!
diagramCodeCategory

	^ #'--- PathView Diagram Data ---'! !

!SClassDiagramMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/5/2011 11:42:56.734'!
interestingSystemEvents

	^ #()! !

!SClassDiagramMorph class methodsFor: 'accessing' stamp: 'ag 9/22/2011 13:08:46.955'!
memberTypeFor: aVariableName in: aClass
	
	^ (aClass instVarNames includes: aVariableName) ifTrue: [
		(self currentTypeBucketFor: aClass) 
			ifNotNilDo: [ :typeBucket |
				typeBucket
					memberTypeFor: 
						(aClass instVarIndexFor: aVariableName ifAbsent: nil)
					in: aClass ] ]! !

!SClassDiagramMorph class methodsFor: 'instance creation' stamp: 'ag 9/22/2011 13:08:55.679'!
on: aClass
	
	^ self basicNew
		klass: aClass;
		initialize;
		yourself! !

!SClassDiagramMorph class methodsFor: 'loading/saving' stamp: 'tfel 7/5/2012 16:03:18.916'!
saveToCodeTemplate
	"saveName methodMorphSpecs(class -> selector. topLeft. bottomLeft)
	pinnedMethods(class -> selector) pinnedVariables(class -> selector)"
	^ '
	"------------------------"
	({2} on: {3}) ifNotNilDo: [:classMorph |.
		{1} addMorph: classMorph.
		[{1} openMutex critical: [
		 ', SRestoreVisitor name asString,' restore: classMorph from: {4}]] fork].
	"------------------------"
	'! !

!SClassDiagramMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/5/2011 11:42:59.192'!
systemEventHandler

	self subclassResponsibility.! !

!SClassDiagramMorph methodsFor: 'visiting' stamp: 'tfel 6/12/2012 11:46:43.422'!
accept: aVisitor

	self subclassResponsibility.! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'ag 12/29/2011 12:10:34.01'!
allClassMorphs
	
	^ self diagramParent
		ifNotNilDo: [ :parent | parent classMorphs ifEmpty: [ #() ] ]! !

!SClassDiagramMorph methodsFor: 'converting' stamp: 'tfel 5/24/2011 14:19:41.44'!
asClassDiagramMorph

	^ self! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'ag 9/22/2011 14:05:49.638'!
classDiagramSubmorphs
	
	^ self submorphs select: [ :morph | morph isClassDiagramMorph ]! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'ag 9/8/2011 13:08:32.264'!
currentTypeBucket
	
	^ self class currentTypeBucketFor: klass  ! !

!SClassDiagramMorph methodsFor: 'updating' stamp: 'ag 12/29/2011 11:44:13.9'!
diagramDirty
	"Sent by different morphs on different events, to indicate the diagram, that it has changed.
	The SDiagramMorph itself can only intercept add/remove morph events."
	
	self diagramParent ifNotNilDo: #makeDirty.! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'ag 12/29/2011 11:43:37.008'!
diagramParent
	
	^ self ownerThatIsA: SClassDiagram! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'tfel 5/5/2011 11:39:35.595'!
doubleClick: anEvent

	self runMouseActionFor: #doubleClick.! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'ag 10/12/2011 14:34:19.497'!
globalEventHandler: anEvent
	
	klass = anEvent itemClass
		ifTrue: [ self perform: self class systemEventHandler with: anEvent ].! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'ag 9/22/2011 13:12:02.483'!
handlesMouseDown: anEvent
	
	^ true! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'ag 9/22/2011 13:12:51.928'!
handlesMouseOver: anEvent
	
	^ true! !

!SClassDiagramMorph methodsFor: 'highlighting' stamp: 'ag 9/22/2011 19:36:33.78'!
highlightClassMorphs
	
	^ self highlightClassMorphs: klass  ! !

!SClassDiagramMorph methodsFor: 'highlighting' stamp: 'ag 12/29/2011 11:44:25.745'!
highlightClassMorphs: aClass
	"Pass the message up to the class-diagram, that knows about all the class-morphs in it."
	
	self diagramParent ifNotNilDo: [ :owner | owner highlightClassMorphs: aClass ].! !

!SClassDiagramMorph methodsFor: 'initialization' stamp: 'ag 8/19/2011 12:17:40.221'!
initialize

	super initialize.
	self initializeSystemChangeListening.! !

!SClassDiagramMorph methodsFor: 'initialization' stamp: 'ag 4/18/2012 13:24:50.38'!
initializeSystemChangeListening
	
	self class interestingSystemEvents ifNotEmptyDo: [ :events |
		SystemChangeNotifier uniqueInstance
			notify: self
			ofEvents: events
			using: #globalEventHandler: ].! !

!SClassDiagramMorph methodsFor: 'testing' stamp: 'tfel 7/14/2011 11:52:04.671'!
isClassDiagramMorph

	^ true
! !

!SClassDiagramMorph methodsFor: 'reengeneering' stamp: 'ag 6/13/2012 16:40:29.287'!
isDirectHierarchyNeighbor: newClassMorph
	
	^ newClassMorph visualizedClass superclass == self visualizedClass
		or: [ self visualizedClass superclass == newClassMorph visualizedClass ]! !

!SClassDiagramMorph methodsFor: 'testing' stamp: 'tfel 6/28/2012 13:55:09.458'!
isError

	^ false! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'tfel 5/5/2011 14:13:44.609'!
klass
	^ klass! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'tfel 5/5/2011 14:13:44.628'!
klass: anObject
	klass := anObject! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:17:26.596'!
mouseActions
	"Keys may be
		#click
		#doubleClick
		#rightClick
		#mouseEnter
		#mouseLeave
		#startDrag
		#startShiftDrag
	Values may be selectors (performed on self, when the event happens) or blocks (evaluated with no arguments)"
	
	^ Dictionary new! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'fb 7/5/2011 14:25:23.011'!
mouseDown: anEvent

	anEvent hand waitForClicksOrDrag: self event: anEvent.
	anEvent wasHandled: true! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'tfel 5/5/2011 11:40:49.993'!
mouseEnter: anEvent

	self runMouseActionFor: #mouseEnter.! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'tfel 5/5/2011 11:40:53.83'!
mouseLeave: anEvent

	self runMouseActionFor: #mouseLeave.! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'tfel 5/22/2012 15:05:52.272'!
mouseUp: anEvent

	(anEvent whichButton = anEvent class redButton)
		ifTrue: [^ self runMouseActionFor: #click].
	(anEvent whichButton = anEvent class yellowButton)
		ifTrue: [^ self runMouseActionFor: #rightClick].! !

!SClassDiagramMorph methodsFor: 'updating' stamp: 'ag 12/9/2011 14:57:47.621'!
noteNewOwner: aMorph
	"Update label as soon as we are visible."
	
	self update.! !

!SClassDiagramMorph methodsFor: 'highlighting' stamp: 'ag 9/22/2011 21:32:07.953'!
openNewClassMorph: aClassMorph
	
	self highlightClassMorphs: aClassMorph klass.
	aClassMorph
		highlightFocus;
		openInHand.! !

!SClassDiagramMorph methodsFor: 'reengeneering' stamp: 'ag 6/13/2012 14:58:47.949'!
processReengeneeringInto: newClassMorph
	"This is called from a SClassMorph, when the receiver has been dropped into it.
	Check the reengeneering-conditions and perform the reengeneering, if appropriate.
	Must only be implemented by class-diagram-elements, that actually can perform a reengeneering by being dragged."
	
	self subclassResponsibility.
	"self shouldNotImplement." "If this method is not overridden, that means it is inappropriate..."! !

!SClassDiagramMorph methodsFor: 'reengeneering' stamp: 'ag 6/14/2012 11:50:26.987'!
reengineerWith: aClassMorph ifSuperclass: superclassBlock ifSubclass: subclassBlock
	"Moving method categories only to direct sub-/super-classes.
	See comment in #processReengeneeringInto: of SMethodMorph."
	
	aClassMorph visualizedClass superclass == self visualizedClass
		ifTrue: subclassBlock.
	self visualizedClass superclass == aClassMorph visualizedClass
		ifTrue: superclassBlock.! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'ag 8/26/2011 17:03:10.785'!
runMouseActionFor: aSymbol
	
	(self mouseActions at: aSymbol ifAbsent: [ nil ])
		ifNotNilDo: [ :action |
			action isSymbol
				ifTrue: [ self perform: action ]
				ifFalse: [ action value ] ].! !

!SClassDiagramMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:24:35.639'!
startDrag: anEvent
	
	self
		runMouseActionFor: #mouseLeave;
		runMouseActionFor:   
			(anEvent shiftPressed
				ifTrue: [ #startShiftDrag ]
				ifFalse: [ #startDrag ]).! !

!SClassDiagramMorph methodsFor: 'updating' stamp: 'ag 12/9/2011 14:34:38.651'!
update
	"Update all relevant submorphs"
	
	self classDiagramSubmorphs do: [ :morph | morph update ].
	self updateLabel.! !

!SClassDiagramMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:06:47.936'!
updateLabel
	"Method stub"! !

!SClassDiagramMorph methodsFor: 'accessing' stamp: 'ag 5/3/2012 09:58:43.883'!
visualizedClass
	"Resolves THContainerType to a real Class. If an instance of Behavior is required, this should be used instead of sending #klass.
	In general, the THContainerType acts as a proxy to it's element-type. But sometimes this does not suffice - e.g.
	when checking, if this klass is included in a collection. Then the actual class is needed. Or, when a MethodReference is created for the class."
	
	^ klass isBehavior
		ifTrue: [ klass ]
		ifFalse: [ klass innerTypeOfElements ifNil: [ klass ] ]! !

!SClassDiagramMorph methodsFor: 'reengeneering' stamp: 'ag 6/13/2012 16:12:48.143'!
wantsReengineeringInto: newClassMorph
	"Subclasses, that implement reengeneerings over drag/drop, must return, whether the
	target class-morph is a valid refactoring-target.
	If false is returned, dropping them into newClassMorph will be prevented and the morph will not be highlighted."
	
	^ false! !

!SClassDiagramMorph methodsFor: 'dropping/grabbing' stamp: 'ag 9/22/2011 13:07:26.158'!
wantsToBeDroppedInto: aMorph
	"Avoids diagram-elements to be dropped outside the diagram."
	
	^ (aMorph isKindOf: SClassDiagram) | (aMorph isKindOf: SClassMorph)! !

SClassDiagramMorph subclass: #SEntryMorph
	instanceVariableNames: 'labelMorph classMorph indentationMorph iconMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SEntryMorph commentStamp: 'tfel 5/20/2011 09:52:27.686' prior: 0!
A SEntryMorph is a morph suitable for display in an SExpandableEntryMorph or a SClassDiagramMorph. It has default highlight-on-hover behavior and holds a reference to its containing SClassMorph via #classMorph. This reference is only set in #noteNewOwner:, so it's not available at #initialize time. Additionally, a SEntryMorph can tell whether it #wantsToBeShown. This flag is honored only, if the SEntryMorph is contained in a SExpandableEntryMorph.
!

!SEntryMorph class methodsFor: 'constants' stamp: 'mp 1/23/2011 14:54:44.625'!
borderColor

	^ Color gray! !

!SEntryMorph class methodsFor: 'constants' stamp: 'tfel 4/28/2011 23:02:09.543'!
borderWidth

	^ 1! !

!SEntryMorph class methodsFor: 'constants' stamp: 'mp 1/25/2011 20:47:57.817'!
defaultColor

	^ Color white! !

!SEntryMorph class methodsFor: 'constants' stamp: 'ag 12/10/2011 15:15:54.378'!
highlightBrightness
	
	^ -0.25! !

!SEntryMorph class methodsFor: 'instance creation' stamp: 'ag 12/9/2011 14:42:09.157'!
on: aClass in: aClassMorph
	
	^ self basicNew
		klass: aClass;
		classMorph: aClassMorph;
		initialize;
		yourself! !

!SEntryMorph methodsFor: 'menu' stamp: 'tfel 5/22/2012 15:28:26.478'!
buildMenu: aMenu
	
	^ self! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 9/22/2011 14:19:04.586'!
classMorph

	^ classMorph! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 12/9/2011 14:42:27.869'!
classMorph: aClassMorph

	classMorph := aClassMorph.! !

!SEntryMorph methodsFor: 'event handling' stamp: 'ag 9/22/2011 19:30:30.414'!
clicked
	"Any submorphs pass the click-event to the class-morph to gain the focus."
	
	self classMorph focus.! !

!SEntryMorph methodsFor: 'event handling' stamp: 'ag 12/10/2011 15:08:00.014'!
currentColor
	"This is the non-hovered default color."
	
	^ self class defaultColor! !

!SEntryMorph methodsFor: 'event handling' stamp: 'ag 12/10/2011 15:15:46.647'!
hoverIn
	
	self color: (
		self currentColor
			adjustBrightness: self class highlightBrightness).! !

!SEntryMorph methodsFor: 'event handling' stamp: 'ag 12/10/2011 15:27:02.515'!
hoverOut
	
	self color: self currentColor.! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 12/10/2011 14:38:30.015'!
indentation: aNumber
	
	indentationMorph indentation: aNumber.! !

!SEntryMorph methodsFor: 'initialization' stamp: 'ag 12/28/2011 23:34:18.11'!
initialize
	
	super initialize.
	self
		initializeLayout;
		initializeLabel.! !

!SEntryMorph methodsFor: 'initialization' stamp: 'ag 4/18/2012 15:11:17.521'!
initializeLabel
	
	(self labelCentered
		ifTrue: [
			self addMorph: (labelMorph := StringMorph contents: '') ]
		ifFalse: [
			labelMorph := indentationMorph labelMorph.
			self addMorph: indentationMorph ]).! !

!SEntryMorph methodsFor: 'initialization' stamp: 'ag 12/29/2011 00:04:23.375'!
initializeLayout
	
	indentationMorph := SIndentedLabelMorph new. "This variable is not used by all subclasses... Depending on #labelCentered"
	self
		color: self class defaultColor;
		borderStyle:
				((SSimpleOverlappingBorder new)
						width: self class borderWidth;
						color: self class borderColor);
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom.
	self labelCentered ifTrue: [ self wrapCentering: #center ].! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 15:03:42.702'!
isExpandable
	
	^ false! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 18:04:35.876'!
isPinnable
	
	^ false! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:44:11.597'!
labelCentered
	
	^ false! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:14:00.281'!
labelEmphasis
	"No emphasis by default"
	
	^ 0! !

!SEntryMorph methodsFor: 'menu' stamp: 'tfel 5/22/2012 15:28:09.666'!
menu
	| menu |
	menu := MenuMorph new.
	self buildMenu: menu.
	menu items
		ifNotEmpty: [menu invokeAt: ActiveHand position in: ActiveWorld allowKeyboard: true]
		ifEmpty: [self clicked].! !

!SEntryMorph methodsFor: 'event handling' stamp: 'tfel 5/22/2012 14:47:47.58'!
mouseActions

	^ Dictionary newFrom: {
		#mouseEnter -> #hoverIn.
		#mouseLeave -> #hoverOut.
		#click -> #clicked.
		#rightClick -> #menu }! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 12:17:21.54'!
needsToBeShown
	
	^ false! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 4/18/2012 15:15:04.847'!
removeIcon
	
	iconMorph ifNotNilDo: #abandon.! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 5/11/2012 12:03:21.927'!
setColorIcon: aColor
	
	^ self setIconMorph:
		(aColor asMorph
			extent: 15 asPoint;
			yourself)! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 5/11/2012 12:03:14.267'!
setIcon: anImage
	
	^ self setIconMorph: anImage asMorph! !

!SEntryMorph methodsFor: 'accessing' stamp: 'ag 5/11/2012 12:03:09.959'!
setIconMorph: aMorph
	
	self removeIcon.
	iconMorph := aMorph.
	labelMorph owner
		addMorph: iconMorph
		inFrontOf: labelMorph.
	^ aMorph! !

!SEntryMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:09:12.64'!
startDraggingCopy
	"Create a copy of the receiver and grab it with the hand. This is not called automatically, subclasses call this
	to implement moving parts of the diagram around."
	
	| copy |
	copy := self veryDeepCopy.
	self currentHand grabMorph: copy.! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:13:51.61'!
updateLabel
	
	super updateLabel.
	labelMorph ifNotNil: [
		labelMorph emphasis: self labelEmphasis ].! !

!SEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 14:18:27.997'!
wantsToBeShown
	
	^ true! !

SEntryMorph subclass: #SExpandableEntryMorph
	instanceVariableNames: 'expanded entries needReexpand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SExpandableEntryMorph commentStamp: 'tfel 7/19/2011 14:16:45.156' prior: 0!
A SExpandableEntryMorph is a morph
to hold a list of SEntryMorphs, which
can be expanded and collapsed.
Subclasses must override the #createEntries
method, which is used to lazily create the
entries when they are first needed. The
list with #entries is strictly internal, as
modifications to it will confuse ordering,
association arrows and the like.!

SExpandableEntryMorph subclass: #SClassNameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SClassNameMorph class methodsFor: 'constants' stamp: 'ag 12/9/2011 13:48:30.933'!
expandedByDefault
	
	^ true! !

!SClassNameMorph class methodsFor: 'system event configuration' stamp: 'pt 7/5/2012 13:59:11.368'!
interestingSystemEvents

	^ #('classRenamedEvent:' 'methodAddedEvent:')! !

!SClassNameMorph class methodsFor: 'system event configuration' stamp: 'pt 7/5/2012 14:05:12.906'!
systemEventHandler

	^ #classOrMethodEvent:! !

!SClassNameMorph methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:30:54.229'!
accept: aVisitor

	aVisitor visitClassName: self.
	self entries do: [:e | aVisitor visit: e ].! !

!SClassNameMorph methodsFor: 'reengineering' stamp: 'sp 6/22/2012 15:09:44.633'!
addCategory
	"Present a choice of categories or prompt for a new category name"
	| labels reject lines menuIndex newName |

	labels := OrderedCollection with: 'new...'.
	reject := Set new.
	reject
		addAll: klass organization categories;
		add: ClassOrganizer nullCategory;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	klass allSuperclasses do: [:cls | | cats |
		cls = Object ifFalse: [
			cats := cls organization categories reject:
				 [:cat | reject includes: cat].
			cats isEmpty ifFalse: [
				lines add: labels size.
				labels addAll: cats asSortedCollection.
				reject addAll: cats]]].
	newName := (labels size = 1 or: [
		menuIndex := (UIManager default chooseFrom: labels lines: lines title: 'Add Category').
		menuIndex = 0 ifTrue: [^ self].
		menuIndex = 1])
			ifTrue: [
				UIManager default request: 'Please type new category name'
					initialAnswer: 'category name']
			ifFalse: [
				labels at: menuIndex].
			
	newName isEmpty
		ifTrue: [^ self]
		ifFalse: [newName := newName asSymbol].
	
	klass organization addCategory: newName.
! !

!SClassNameMorph methodsFor: 'reengineering' stamp: 'sp 7/5/2012 13:40:05.728'!
addMethod
	| name category index |
	
	index := UIManager default 
				chooseFrom: {'new...'}, klass organization categories
				title: 'Choose a category'.
	index = 0 ifTrue: [^self].  
	
	category := (index = 1)
					ifTrue: [(UIManager default
								request: 'New Category Name'
								initialAnswer: 'category')
									ifEmpty: [ ^self ].]
					ifFalse: [klass organization categories at: (index-1)].
				
						
	name := (UIManager default
				request: 'New Method Name'
				initialAnswer: 'method')
					ifEmpty: [ ^self ].

	SRefactoring execute: (SAddMethodRefactoring 
								addMethod: name 
								toClass: klass name 
								inProtocols: category).! !

!SClassNameMorph methodsFor: 'reengineering' stamp: 'sp 6/22/2012 11:44:11.71'!
addVariable

	| name type refactoring |
	
	type := UIManager default chooseFrom:{'inst'. 'class'. 'class inst'} values: {#inst. #class. #classinst}.	
	name := (UIManager default
				request: 'New Variable Name'
				initialAnswer: ((type = #instance) ifTrue: ['variable'] ifFalse: ['Variable']) )
					ifEmpty: [ ^self ].

	type = #inst ifTrue: [
			refactoring := AddInstanceVariableRefactoring 
								variable: name class: klass theNonMetaClass.].
	type = #class ifTrue: [
			refactoring := AddClassVariableRefactoring 
								variable: name class: klass theNonMetaClass.].
	type = #classinst ifTrue: [
			refactoring := AddInstanceVariableRefactoring 
								variable: name class: klass theMetaClass.
		].  
	
	SRefactoring execute: refactoring. ! !

!SClassNameMorph methodsFor: 'event handling' stamp: 'tfel 4/28/2011 21:55:44.655'!
browseClass

	klass browse.! !

!SClassNameMorph methodsFor: 'menu' stamp: 'sp 6/8/2012 14:11:43.351'!
buildMenu: aMenu  

	| refactoringMenu |
	aMenu 
		add: 'Rename class' target: self selector: #renameClass;
		add: 'Delete class' target: self selector: #deleteClass.
		
	refactoringMenu := MenuMorph new.
	refactoringMenu
		add: 'Create accessors' target: self selector: #createAccessors;
		add: 'Add variable' target: self selector: #addVariable;
		add: 'Add method' target: self selector: #addMethod;
		add: 'Add category' target: self selector: #addCategory.
	aMenu add: 'more...' subMenu: refactoringMenu.! !

!SClassNameMorph methodsFor: 'event handling' stamp: 'ag 9/22/2011 19:39:19.052'!
classMorphDragged
	"Pass the dragging-event to the class-morph."
	
	self highlightClassMorphs.
	self classMorph runMouseActionFor: #startDrag.! !

!SClassNameMorph methodsFor: 'system events' stamp: 'pt 7/5/2012 14:22:46.05'!
classOrMethodEvent: anEvent
	
	anEvent itemKind = #method
		ifFalse: [ self updateAll. ]
		ifTrue: [ klass methodDict size = 1 ifTrue: [self owner expandMorphs ] ].! !

!SClassNameMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 14:07:44.308'!
createAccessors
	| refactorings |
	
	refactorings := OrderedCollection new.
	refactorings := klass theNonMetaClass instVarNames collect: [ :variable |
		CreateAccessorsForVariableRefactoring 
			variable: variable class: klass theNonMetaClass classVariable: false. ].
	
	SRefactoring 
		executeMultiple: refactorings 
		name: 'Create accessors for', klass name asString.! !

!SClassNameMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 13:47:22.705'!
createEntries
	
	^ SInheritanceMorph on: klass in: self classMorph! !

!SClassNameMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 14:08:26.472'!
deleteClass
	
	(UIManager default confirm: 'Really delete ', klass name asString, '?') ifFalse: [^self].
	
	SRefactoring execute: 
		(RemoveClassRefactoring classNames: {klass name}).! !

!SClassNameMorph methodsFor: 'initialization' stamp: 'ag 12/29/2011 00:06:50.359'!
initializeLayout
	
	super initializeLayout.
	self layoutInset: 3. "Give the title some emphasis"! !

!SClassNameMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:41:18.082'!
labelCentered
	
	^ true! !

!SClassNameMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:14:13.986'!
labelEmphasis
	
	^ (klass hasAbstractMethods
		ifTrue: [TextEmphasis italic]
		ifFalse: [TextEmphasis bold])
			emphasisCode! !

!SClassNameMorph methodsFor: 'event handling' stamp: 'sp 6/4/2012 12:25:13.291'!
mouseActions

	^ super mouseActions
		at: #doubleClick put: #browseClass;
		at: #startDrag put: #classMorphDragged;
		yourself! !

!SClassNameMorph methodsFor: 'reengineering' stamp: 'sp 6/19/2012 16:25:10.178'!
renameClass
	| oldName newName refactoring |
	
	oldName := klass name asString.
	newName := (UIManager default
					request: 'New Class Name'
					initialAnswer: oldName)
						ifEmpty: [^ self].
						
	oldName = newName ifTrue: [^self.].

	refactoring := RenameClassRefactoring
		rename: klass theNonMetaClass
		to: newName.
	SRefactoring execute: refactoring.! !

!SClassNameMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 16:48:36.431'!
showLabels: showLabels
	"Do not hide the class-name. But hide the <extends ClassAbc> label."
	
	self
		showSubmorph: entries first
	 	if: showLabels
		doing: #addMorphBack:.! !

!SClassNameMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:09:34.503'!
updateLabel
	
	super updateLabel.
	labelMorph contents: klass asString.! !

!SExpandableEntryMorph class methodsFor: 'constants' stamp: 'ag 12/9/2011 13:48:13.836'!
expandedByDefault
	
	^ false! !

!SExpandableEntryMorph class methodsFor: 'constants' stamp: 'ag 12/10/2011 14:56:09.371'!
indentationInset
	
	^ 20! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 12:57:51.591'!
addEntry: aMorph
	"Adds the morph as an entry, provided the receiver is expanded and the morph wants to be shown OR aMorph is pinned."
	
	((expanded & aMorph wantsToBeShown) | aMorph needsToBeShown) ifTrue: [
		self addMorphBack: aMorph.
		aMorph show ].! !

!SExpandableEntryMorph methodsFor: 'event handling' stamp: 'ag 12/10/2011 15:35:19.417'!
clicked
	
	super clicked.
	self toggleExpansion.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 4/18/2012 14:56:52.256'!
collapseMorphs
	"Do several things with different kinds of my submorphs."
		
	self entries
		reject: #needsToBeShown thenDo: #delete;
		select: #isPinnable thenDo: #removePinVisualization;
		select: 	[ :each | each needsToBeShown & each isExpandable and: [ each expanded ] ]
			thenDo: [ :each | each toggleExpansion; reexpandLater ];
		do: #hoverOut.
	self updateLabel.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'tfel 4/28/2011 21:47:19.256'!
createEntries

	self subclassResponsibility.! !

!SExpandableEntryMorph methodsFor: 'accessing' stamp: 'ag 6/5/2012 15:32:33.494'!
entries
	
	^ entries ifNil: [
		entries := self createEntries asOrderedCollection.
		entries do: [ :entry | entry privateOwner: self ] ]
		"Set the owner, without adding the entry. This was introduced after a bug, where connectors between a method-morph
		and a source-code-box where added to the world, instead of the diagram-morph, because the two connected morphs had their
		owner-field still set to nil. I know this is hacky, I didnot see another solution.
		This ''strange' state, that the morph is no submorph of its owner-morph, will be fixed, as soon as the morph is expanded once."! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'tfel 2/14/2012 11:07:24.004'!
expandMorphs
	
	expanded := true.
	self entries do: [ :each | 
		self
			removeMorph: each;
			addEntry: each.
		each isExpandable ifTrue: [ each reexpandIfNecessary ].
		each isPinnable ifTrue: [ each updatePinVisualization ] ].
	self entries do: #hoverOut.
	self updateLabel.! !

!SExpandableEntryMorph methodsFor: 'accessing' stamp: 'omg 5/24/2011 11:43:42.789'!
expanded
	^expanded! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 14:38:40.883'!
indentation: aNumber
	
	super indentation: aNumber.
	self entries do: [ :each | each indentation: indentationMorph indentation + self class indentationInset ].! !

!SExpandableEntryMorph methodsFor: 'initialization' stamp: 'ag 3/8/2012 12:08:03.246'!
initialize
	
	super initialize.
	expanded := self class expandedByDefault.
	needReexpand := false.
	expanded ifTrue: [ self updateEntries ].! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'pt 6/27/2012 09:03:53.076'!
isEquivalentTo: anotherExpandableEntry

	"stub. subclasses should implement"
	^ false! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 15:03:47.742'!
isExpandable
	
	^ true! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 12:33:28.018'!
needsToBeShown
	
	^ entries
		ifNotNil: [ entries anySatisfy: #needsToBeShown ] "Recursively search for pinned entries."
		ifNil: [ super needsToBeShown ]! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 3/8/2012 13:25:34.102'!
recursivelyExpandMorphs
	
	self expandMorphs.
	self entries select: #isExpandable thenDo: #recursivelyExpandMorphs.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/29/2011 10:41:11.398'!
recursivelyUpdateExpansion
	
	expanded ifTrue: [ self updateExpansion ].
	self entries select: #isExpandable thenDo: #recursivelyUpdateExpansion.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'sp 6/28/2012 10:30:19.748'!
recursivelyUpdateExpansion: previouslyExpandedEntries
	
	expanded ifTrue: [ self updateExpansion ].
	(self entries select: #isExpandable) do: [:entry |
		previouslyExpandedEntries do: [:prevEntry |
			(entry isEquivalentTo: prevEntry) ifTrue: [
				entry toggleExpansion.
				entry recursivelyUpdateExpansion: prevEntry entries. 
			]  
		]
	].! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 17:50:55.999'!
reexpandIfNecessary
	"Reespand receiver. Only, if receiver has been collapsed, because it could not be just removed, because it contains pinned elements.
	In this special case, we need to toggle expansion."
	
	needReexpand & expanded not ifTrue: [ self toggleExpansion ].
	needReexpand := false.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 15:54:45.031'!
reexpandLater
	"Memorize, that we are only collapsed, because we contain pinned elements and thus cannot be simply removed."
	
	needReexpand := true.
	self entries do: #hoverOut. "Fix bug with highlight-colors"! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/27/2011 17:14:26.777'!
showLabel: showLabels
	"Removed the label if necessary and resize yourself."
	
	^ self
		showSubmorph: indentationMorph
		if: showLabels
		doing: #addMorphFront:! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 17:37:00.11'!
showSubmorph: aSubmorph if: showMorph doing: addBlock
	"addBlock takes self and aSubmorph and has to add aSubmorph to self.
	This method returns nil, if nothing has been changed, returns true if aSubmorph has been added and false if it has been removed."
	
	^ aSubmorph ifNotNil: [
		(aSubmorph owner isNil & showMorph)
			ifTrue: [
				addBlock value: self value: aSubmorph.
				self bounds: (self bounds withHeight: (self bounds height + 15)).
				true ]
			ifFalse: [
		(aSubmorph owner notNil & showMorph not)
			ifTrue: [ | height |
				self removeMorph: aSubmorph.
				"Work around some kind of morphic bug. If all submorphs have just been removed, submorphBounds is updated delayed."
				height := self submorphs ifEmpty: [ 3 ] ifNotEmpty: [ self submorphBounds height - 15 ].
				self bounds: (self submorphBounds withHeight: height).
				false ] ] ]! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/27/2011 17:02:26.904'!
toggleExpansion
	
	expanded := expanded not.
	self
		updateExpansion;
		diagramDirty.! !

!SExpandableEntryMorph methodsFor: 'updating' stamp: 'sp 6/28/2012 09:22:27.935'!
updateAll

	self update; updateEntries.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'sp 6/27/2012 21:25:46.56'!
updateEntries
	"Recreate the entries and add them properly."
	|previouslyExpandedEntries|

	entries ifNil: [
		self indentation: 0.
		self updateExpansion .
		^self].

	previouslyExpandedEntries := entries select: [:e | e isExpandable and: [e expanded ]].
	entries do: #delete.
	entries := nil.
	self indentation: 0.
	self recursivelyUpdateExpansion: previouslyExpandedEntries.! !

!SExpandableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 13:53:42.579'!
updateExpansion
	
	expanded
		ifFalse: [ self collapseMorphs ]
		ifTrue: [ self expandMorphs ].! !

SExpandableEntryMorph subclass: #SExpandableEntryMorphWithSummary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

SExpandableEntryMorphWithSummary subclass: #SBehaviorMorph
	instanceVariableNames: 'eventActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SBehaviorMorph class methodsFor: 'system event configuration' stamp: 'sp 6/28/2012 09:28:54.372'!
interestingSystemEvents

	^ #('categoryRemovedEvent:' 'categoryAddedEvent:' 'categoryRenamedEvent:'
		'methodRemovedEvent:' 'methodAddedEvent:')! !

!SBehaviorMorph class methodsFor: 'system event configuration' stamp: 'tfel 4/30/2011 21:37:20.977'!
systemEventHandler

	^ #categoryChanges:! !

!SBehaviorMorph methodsFor: 'visiting' stamp: 'tfel 6/28/2012 07:02:00.498'!
accept: aVisitor

	aVisitor visitBehavior: self.
	self acceptForEntries: aVisitor.! !

!SBehaviorMorph methodsFor: 'layout and labels' stamp: 'ag 2/15/2012 09:26:02.209'!
allEntries
	"Collect all methods from the category-morphs."
	
	^ entries
		ifNil: [ #() ]
		ifNotNil: [ (entries collect: #allEntries) asArray flatten asOrderedCollection ] "Work around a bug (?) when flattening OrderedCollections. WriteStream tries to create an OrderedCollection with a certain size, wich does not work."! !

!SBehaviorMorph methodsFor: 'layout and labels' stamp: 'ag 7/2/2012 14:14:52.307'!
allEntriesCount
	
	^ self categories inject: 0 into: [ :all :each | all + (self methodCountInCategory: each) ]! !

!SBehaviorMorph methodsFor: 'layout and labels' stamp: 'ag 7/2/2012 14:10:06.028'!
categories
	
	^ klass organization categories
		reject: [ :each | each == self class diagramCodeCategory ]! !

!SBehaviorMorph methodsFor: 'system events' stamp: 'sp 6/28/2012 09:35:03.96'!
categoryChanges: anEvent
	
	anEvent itemKind caseOf: {
		[ #method ] -> [ self updateAll. ]. "A method has been added or removed"
		[ #category ] -> [ " TODO Updating entries not implemented yet" ]. "A category has changed."
	}.! !

!SBehaviorMorph methodsFor: 'layout and labels' stamp: 'ag 7/2/2012 14:09:47.936'!
createEntries
	
	^ self categories
		collect: [ :each | SMethodCategoryMorph on: klass in: classMorph forCategory: each ]! !

!SBehaviorMorph methodsFor: 'initialization' stamp: 'tfel 5/31/2011 13:56:49.471'!
initialize

	super initialize.
	labelMorph emphasis: TextEmphasis italic emphasisCode.! !

!SBehaviorMorph methodsFor: 'layout and labels' stamp: 'pt 6/27/2012 09:28:52.772'!
isEquivalentTo: otherExpandableMorph  
	^ (self class = otherExpandableMorph class) &
	   (self klass = otherExpandableMorph klass) &
	   (self labelString = otherExpandableMorph labelString)! !

!SBehaviorMorph methodsFor: 'layout and labels' stamp: 'ag 4/18/2012 16:55:03.354'!
labelString
	
	^ klass isMeta
		ifTrue: [ 'class methods' ]
		ifFalse: [ 'methods' ]! !

!SBehaviorMorph methodsFor: 'accessing' stamp: 'ag 3/30/2012 11:31:31.807'!
methodMorphFor: aVariableName
	
	self entries
		do: [ :categoryMorph |
			(categoryMorph methodMorphFor: aVariableName)
				ifNotNilDo: [ :morph | ^ morph ] ].
	^ nil! !

!SExpandableEntryMorphWithSummary methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:31:08.283'!
acceptForEntries: aVisitor

	self entries do: [:m |
		aVisitor visit: m.
		self expanded ifFalse: [self addEntry: m]].
	self updateLabel.  ! !

!SExpandableEntryMorphWithSummary methodsFor: 'layout and labels' stamp: 'ag 9/22/2011 15:03:09.535'!
allEntries
	"Return all entries of the receiver, including the entries of expandable entries recursively."
	
	self subclassResponsibility! !

!SExpandableEntryMorphWithSummary methodsFor: 'layout and labels' stamp: 'ag 9/22/2011 15:01:43.574'!
allEntriesCount
	"Return the maximum number of entries, that can appear in the receiver."
	
	self subclassResponsibility! !

!SExpandableEntryMorphWithSummary methodsFor: 'layout and labels' stamp: 'ag 9/22/2011 15:04:02.922'!
labelString
	"Return a labelString, that will be formatted using a single Number, that is the number of further elements, that are hidden,
	when the receiver is collapsed."
	
	self subclassResponsibility! !

!SExpandableEntryMorphWithSummary methodsFor: 'computation' stamp: 'ag 7/2/2012 14:13:36.774'!
methodCountInCategory: aCategory
	
	^ (klass organization listAtCategoryNamed: aCategory) size! !

!SExpandableEntryMorphWithSummary methodsFor: 'layout and labels' stamp: 'ag 4/18/2012 16:59:05.193'!
updateLabel
	
	| formatNumber |
	super updateLabel.
	formatNumber := self allEntriesCount.
	expanded
		ifFalse: [ | pinnedEntries hiddenEntries |
			pinnedEntries := self allEntries select: #needsToBeShown.
			hiddenEntries := formatNumber - pinnedEntries size.
			hiddenEntries = 0
				ifFalse: [ formatNumber := hiddenEntries asString, ' more' ] ].
	labelMorph contents: self labelString, ' (', formatNumber, ')'.! !

!SExpandableEntryMorphWithSummary methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 13:56:14.646'!
wantsToBeShown
	
	^ self allEntriesCount > 0! !

SExpandableEntryMorphWithSummary subclass: #SMethodCategoryMorph
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SMethodCategoryMorph class methodsFor: 'constants' stamp: 'tfel 4/28/2011 23:02:53.335'!
borderWidth

	^ 0! !

!SMethodCategoryMorph class methodsFor: 'system event configuration' stamp: 'sp 6/28/2012 09:35:27.491'!
interestingSystemEvents

	^ #('methodAddedEvent:' 'methodRemovedEvent:' 'methodRecategorizedEvent:'
		'classReorganizedEvent:')! !

!SMethodCategoryMorph class methodsFor: 'instance creation' stamp: 'ag 12/9/2011 14:43:01.271'!
on: aClass in: aClassMorph forCategory: aCategoryName
	
	^ self basicNew
		klass: aClass;
		category: aCategoryName;
		classMorph: aClassMorph;
		initialize;
		yourself! !

!SMethodCategoryMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/1/2011 00:45:29.442'!
systemEventHandler

	^ #methodOrCategoryEvent:! !

!SMethodCategoryMorph methodsFor: 'visiting' stamp: 'tfel 6/28/2012 07:02:32.324'!
accept: aVisitor

	aVisitor visitMethodCategory: self.
	self acceptForEntries: aVisitor.! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'sp 7/5/2012 13:39:57.906'!
addMethod
	| name |
	name := (UIManager default
				request: 'New Method Name'
				initialAnswer: 'method')
					ifEmpty: [ ^self ].

	SRefactoring execute: (SAddMethodRefactoring 
								addMethod: name
								toClass: klass name 
								inProtocols: category).! !

!SMethodCategoryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 14:01:49.284'!
allEntries
	
	^ self entries! !

!SMethodCategoryMorph methodsFor: 'layout and labels' stamp: 'ag 7/2/2012 14:13:09.867'!
allEntriesCount
	
	^ self methodCountInCategory: category! !

!SMethodCategoryMorph methodsFor: 'menu' stamp: 'sp 6/4/2012 13:27:41.69'!
buildMenu: aMenu

	aMenu 
		add: 'Rename category' target: self selector: #renameCategory;
		add: 'Add method' target: self selector: #addMethod.! !

!SMethodCategoryMorph methodsFor: 'accessing' stamp: 'tfel 7/14/2011 13:42:26.526'!
category

	^ category
! !

!SMethodCategoryMorph methodsFor: 'accessing' stamp: 'tfel 4/29/2011 14:30:25.182'!
category: aString

	category := aString! !

!SMethodCategoryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 14:46:10.803'!
createEntries
	
	^ (self klass organization listAtCategoryNamed: category)
		collect: [:each | 
			SMethodMorph on: klass in: classMorph forMethod: each ]! !

!SMethodCategoryMorph methodsFor: 'accessing' stamp: 'pt 6/27/2012 09:06:26.462'!
isEquivalentTo: otherMethodCategoryMorph

  ^ (self class = otherMethodCategoryMorph class) &
     (self category = otherMethodCategoryMorph category) &
     (self klass = otherMethodCategoryMorph klass)! !

!SMethodCategoryMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:30:14.502'!
labelEmphasis
	
	^ (self expanded ifTrue: [ TextEmphasis underlined ] ifFalse: [ TextEmphasis normal ]) emphasisCode! !

!SMethodCategoryMorph methodsFor: 'layout and labels' stamp: 'ag 4/18/2012 16:54:51.12'!
labelString
	
	^ category! !

!SMethodCategoryMorph methodsFor: 'accessing' stamp: 'ag 3/8/2012 13:18:30.251'!
methodMorphFor: aSelector
	
	^ self entries
		detect: [ :morph | morph methodName = aSelector ]
		ifNone: [ nil ]! !

!SMethodCategoryMorph methodsFor: 'system events' stamp: 'ag 12/10/2011 14:44:07.516'!
methodOrCategoryEvent: anEvent
	
	anEvent itemKind = #method
		ifFalse: [
			self flag: #todo. "ClassOrganizer>>#renameCategory:toBe: doesn't send events!!?"
			anEvent isRenamed ifTrue: [category := anEvent newName ] ].
	self updateAll.! !

!SMethodCategoryMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:16:36.849'!
mouseActions
	
	^ super mouseActions
		at: #startShiftDrag put: #startDraggingCopy;
		yourself! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'ag 6/14/2012 11:53:48.088'!
processReengeneeringInto: newClassMorph
	
	self
		reengineerWith: newClassMorph
		ifSuperclass: [ ^ self pullUpMethodCategory ]
		ifSubclass: [ ^ self pushDownMethodCategory ].! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:04:28.569'!
pullUpMethodCategory
	
	SRefactoring execute:
		(PullUpMethodRefactoring 
			pullUp: self selectorsInCategory
			from: self visualizedClass).! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'ag 7/2/2012 13:42:12.953'!
pushDownMethodCategory
	
	SRefactoring execute:
		(SPushDownMethodRefactoring 
			pushDown: self selectorsInCategory
			from: self visualizedClass).! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'sp 6/28/2012 09:37:05.108'!
renameCategory
	
	| oldName newName |
	oldName := category asString.
	newName := (UIManager default request: 'New Category Name' initialAnswer: oldName)
					ifEmpty: [ ^self ].
	newName := newName asSymbol.	
	newName = category ifTrue: [^self].
	
	klass organization renameCategory: category toBe: newName.
	self owner updateAll. "TODO: system event for renaming category not emitted, see SMethodCategoryMorph methodOrCategoryEvent:"! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:06:38.413'!
selectorsInCategory
	
	^ klass organization allMethodSelectors! !

!SMethodCategoryMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:14:12.234'!
wantsReengineeringInto: newClassMorph
	"Reengineering only valid for direct sub-/super-classes."
	
	^ self isDirectHierarchyNeighbor: newClassMorph! !

SExpandableEntryMorphWithSummary subclass: #SStateMorph
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

SStateMorph class
	instanceVariableNames: 'variableAccess'!

SStateMorph class
	instanceVariableNames: 'variableAccess'!

!SStateMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/17/2011 15:49:51.731'!
interestingSystemEvents

	^ #('classModifiedEvent:')! !

!SStateMorph class methodsFor: 'instance creation' stamp: 'ag 12/9/2011 14:55:42.732'!
on: aClass in: aClassMorph type: aSymbol
	"Supported types are #instance, #class and #pool"
	
	^ self basicNew
		klass: aClass;
		classMorph: aClassMorph;
		type: aSymbol;
		initialize;
		yourself! !

!SStateMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/17/2011 15:50:42.622'!
systemEventHandler

	^ #classModified:! !

!SStateMorph class methodsFor: 'accessing' stamp: 'ag 12/9/2011 12:36:15.571'!
variableAccess

	^ variableAccess ifNil: [
		variableAccess := Dictionary newFrom: {
			#class -> #classVarNames.
			#instance -> #instVarNames.
			#pool -> #poolDictionaryNames } ]! !

!SStateMorph methodsFor: 'visiting' stamp: 'tfel 6/28/2012 07:02:22.782'!
accept: aVisitor

	aVisitor visitState: self.
	self acceptForEntries: aVisitor.! !

!SStateMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 14:59:11.359'!
addVariable

	| name refactoring |
	
	name := (UIManager default
				request: 'New Variable Name'
				initialAnswer: ((type = #instance) ifTrue: ['variable'] ifFalse: ['Variable']) )
					ifEmpty: [ ^self ].

	type = #instance ifTrue: [
			refactoring := AddInstanceVariableRefactoring 
				variable: name class: klass.
	]  ifFalse: [
			refactoring := AddClassVariableRefactoring 
				variable: name class: klass.
	].
	
	SRefactoring execute: refactoring.! !

!SStateMorph methodsFor: 'layout and labels' stamp: 'ag 9/22/2011 15:11:32.815'!
allEntries
	
	^ self entries! !

!SStateMorph methodsFor: 'layout and labels' stamp: 'ag 9/22/2011 15:11:42.695'!
allEntriesCount
	
	^ self variables size! !

!SStateMorph methodsFor: 'menu' stamp: 'sp 6/5/2012 10:50:00.021'!
buildMenu: aMenu

	aMenu 
		add: 'Add variable' target: self selector: #addVariable.! !

!SStateMorph methodsFor: 'system events' stamp: 'sp 6/4/2012 16:47:48.176'!
classModified: anEvent

	self updateAll.! !

!SStateMorph methodsFor: 'layout and labels' stamp: 'sp 6/8/2012 14:50:25.565'!
createEntries
	
	^ self variables collect: [:each | 
		SInstVarMorph on: klass in: classMorph forVariable: each withType: type ]! !

!SStateMorph methodsFor: 'initialization' stamp: 'ag 12/9/2011 14:55:47.977'!
initialize
	
	super initialize.
	labelMorph emphasis: TextEmphasis italic emphasisCode.! !

!SStateMorph methodsFor: 'layout and labels' stamp: 'ag 4/18/2012 16:54:44.007'!
labelString

	^
	(klass isMeta ifTrue: [ 'class ' ] ifFalse: [ '' ]),
	(klass isMeta not & type ~= #instance ifTrue: [ type ] ifFalse: [ '' ] ),
	'variables'! !

!SStateMorph methodsFor: 'accessing' stamp: 'tfel 6/7/2011 14:49:01.872'!
type: aSymbol

	type := aSymbol.! !

!SStateMorph methodsFor: 'accessing' stamp: 'ag 3/30/2012 11:21:09.761'!
variableMorphFor: aSymbol
	
	^ self entries
		detect: [ :instVarMorph | instVarMorph variableName = aSymbol ]
		ifNone: [ nil ]! !

!SStateMorph methodsFor: 'layout and labels' stamp: 'tfel 6/7/2011 14:45:32.045'!
variables

	^ (self class variableAccess at: type) value: klass! !

SExpandableEntryMorph subclass: #SImplementationMorph
	instanceVariableNames: 'instanceBehaviorMorph classBehaviorMorph instanceStateMorph classStateMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SImplementationMorph class methodsFor: 'constants' stamp: 'ag 9/22/2011 15:22:28.423'!
borderWidth
	
	^ 0! !

!SImplementationMorph class methodsFor: 'constants' stamp: 'ag 12/9/2011 13:48:57.482'!
expandedByDefault
	
	^ true! !

!SImplementationMorph class methodsFor: 'system event configuration' stamp: 'sp 6/4/2012 16:19:00.417'!
interestingSystemEvents

	^ #('classModifiedEvent:')! !

!SImplementationMorph class methodsFor: 'system event configuration' stamp: 'sp 6/4/2012 16:19:13.189'!
systemEventHandler

	^ #classModified:! !

!SImplementationMorph methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:34:35.424'!
accept: aVisitor

	aVisitor visitImplementation: self.
	self entries do: [:m | aVisitor visit: m ].! !

!SImplementationMorph methodsFor: 'system events' stamp: 'sp 6/4/2012 16:47:55.873'!
classModified: anEvent

	self updateAll.! !

!SImplementationMorph methodsFor: 'layout and labels' stamp: 'ag 3/30/2012 11:18:07.338'!
createEntries
	"Added with addMorphBack:, so reverse makes sure that the last in the list stays last"
	
	^ {
		instanceStateMorph := SStateMorph on: klass in: classMorph type: #instance.
		classStateMorph := SStateMorph on: klass in: classMorph type: #class.
		SStateMorph on: klass in: classMorph type: #pool.
		instanceBehaviorMorph := SBehaviorMorph on: klass in: classMorph.
		SStateMorph on: klass class in: classMorph type: #instance.
		classBehaviorMorph := SBehaviorMorph on: klass class in: classMorph }
			asOrderedCollection! !

!SImplementationMorph methodsFor: 'initialization' stamp: 'ag 9/22/2011 15:19:44.297'!
initializeLabel
	"Do nothing, no label is wanted here."! !

!SImplementationMorph methodsFor: 'accessing' stamp: 'ag 3/30/2012 11:33:00.311'!
methodMorphFor: association
	"class -> variableName"
	
	^ ({ instanceBehaviorMorph. classBehaviorMorph }
		select: #notNil)
		detect: [ :morph | morph klass = association key ]
		ifFound: [ :morph | morph methodMorphFor: association value ]
		ifNone: [ nil ]! !

!SImplementationMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:34:54.674'!
showLabels: showLabels
	
	showLabels
		ifTrue: [
			self recursivelyUpdateExpansion ]
		ifFalse: [
			self entries select: #expanded thenDo: #collapseMorphs ].
	self entries do: [ :each | each showLabel: showLabels ].! !

!SImplementationMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 13:13:00.447'!
toggleExpansion
	"no-op; this morph cannot be collapsed, is always expanded."! !

!SImplementationMorph methodsFor: 'layout and labels' stamp: 'sp 6/4/2012 16:29:42.429'!
updateEntries
	
	super updateEntries.
	"Recursively set indentation after all morphs have been created. As this morph has no label, start indentation only at submorphs. Kind of a hack."
	self indentation: self class indentationInset negated.
	
	"If there are absolutely no entries in this class, collapse me. Special case for 'empty' classes."
	(self entries noneSatisfy: #wantsToBeShown)
		ifTrue: [ self height: 0 ].! !

!SImplementationMorph methodsFor: 'accessing' stamp: 'ag 3/30/2012 11:32:51.609'!
variableMorphFor: association
	"class -> selector"
	
	^ ({ instanceStateMorph. classStateMorph }
		select: #notNil)
		detect: [ :morph | morph klass = association key ]
		ifFound: [ :morph | morph variableMorphFor: association value ]
		ifNone: [ nil ]! !

SEntryMorph subclass: #SInheritanceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SInheritanceMorph class methodsFor: 'constants' stamp: 'tfel 4/28/2011 23:03:14.68'!
borderWidth

	^ 0! !

!SInheritanceMorph class methodsFor: 'system event configuration' stamp: 'sp 6/4/2012 15:32:08.131'!
interestingSystemEvents

	^ #('classModifiedEvent:')! !

!SInheritanceMorph class methodsFor: 'system event configuration' stamp: 'tfel 7/14/2011 14:33:15.507'!
systemEventHandler

	^ #classModified:! !

!SInheritanceMorph methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:24:38.679'!
accept: aVisitor

	aVisitor visitInheritance: self.! !

!SInheritanceMorph methodsFor: 'menu actions' stamp: 'ag 12/10/2011 15:37:30.355'!
browseClass
	
	klass superclass browse.! !

!SInheritanceMorph methodsFor: 'system events' stamp: 'ag 12/10/2011 15:16:40.988'!
classModified: anEvent
	
	anEvent isModified ifTrue: [ self update ].! !

!SInheritanceMorph methodsFor: 'initialization' stamp: 'ag 12/29/2011 10:29:22.963'!
initialize
	
	super initialize.
	labelMorph fontName: 'DejaVu Sans' size: 8.! !

!SInheritanceMorph methodsFor: 'layout and labels' stamp: 'ag 12/28/2011 23:24:49.97'!
labelCentered
	"We dont have any label, but we want centered laytout."
	
	^ true! !

!SInheritanceMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:16:14.084'!
labelEmphasis
	
	^ TextEmphasis bold emphasisCode! !

!SInheritanceMorph methodsFor: 'event handling' stamp: 'tfel 5/10/2011 14:25:35.825'!
mouseActions

	^ super mouseActions
		at: #startDrag put: #openSuperClass;
		at: #doubleClick put: #browseClass;
		yourself! !

!SInheritanceMorph methodsFor: 'menu actions' stamp: 'ag 12/10/2011 15:41:23.979'!
openSuperClass
	
	| target |
	klass superclass isNil ifTrue: [^ self].
	target := SClassMorph on: klass superclass.
	SInheritanceConnector openFor: self classMorph connectedTo: target.
	self openNewClassMorph: target.! !

!SInheritanceMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:09:21.038'!
updateLabel
	
	super updateLabel.
	labelMorph contents: '<<extends>> ', klass superclass asString.! !

SEntryMorph subclass: #SPinnableEntryMorph
	instanceVariableNames: 'pinned pinStateVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

SPinnableEntryMorph subclass: #SInstVarMorph
	instanceVariableNames: 'variableName type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SInstVarMorph class methodsFor: 'constants' stamp: 'tfel 4/28/2011 23:03:23.371'!
borderWidth

	^ 0! !

!SInstVarMorph class methodsFor: 'instance creation' stamp: 'sp 6/8/2012 14:49:55.265'!
on: aClass in: aClassMorph forVariable: aVariableName withType: type
	
	^ self basicNew
		klass: aClass;
		classMorph: aClassMorph;
		type: type;
		variableName: aVariableName;
		initialize;
		yourself! !

!SInstVarMorph methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:32:12.363'!
accept: aVisitor

	aVisitor visitInstVar: self.
	classMorph pasteUpMorphOrWorld allConnections
		select: [:connection | connection sourceMorph == self]
		thenDo: [:connection | aVisitor visit: connection ].
	self updateLabel.! !

!SInstVarMorph methodsFor: 'user class selection' stamp: 'ag 12/6/2011 15:44:43.044'!
askForClass
	
	^ self userSelectedContainerClass: 'type'! !

!SInstVarMorph methodsFor: 'event handling' stamp: 'omg 6/7/2011 14:27:03.474'!
browseVariable

	self getClass browse.! !

!SInstVarMorph methodsFor: 'menu' stamp: 'sp 7/2/2012 11:19:23.394'!
buildMenu: aMenu

	aMenu 
		add: 'Rename variable' target: self selector: #renameVariable;
		add: 'Create accessors' target: self selector: #createAccessors;
		add: 'Delete variable' target: self selector: #deleteVariable.! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 14:53:09.948'!
createAccessors

	SRefactoring execute: (CreateAccessorsForVariableRefactoring 
								variable: variableName 
								class: klass 
								classVariable: (type = #instance ifTrue: [false] ifFalse: [true])).! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 15:00:48.468'!
deleteVariable

	| refactoring |
	
	(UIManager default confirm: 'Really delete ', variableName, '?') ifFalse: [^self].

	self flag: #TODO.
	"FIX: sometimes the diagram will not update... classModifiedEvent is not triggered"
	type = #instance ifTrue: [
				 refactoring := RemoveInstanceVariableRefactoring 
								remove: variableName
								from: klass.
	] ifFalse: [ refactoring := RemoveClassVariableRefactoring
								variable: variableName
								class: klass ].

	SRefactoring execute: refactoring.! !

!SInstVarMorph methodsFor: 'menu actions' stamp: 'tfel 7/3/2012 15:26:27.289'!
getClass
	
	^ self getClassFromTypeHarvest 
		ifNil: [self askForClass]
		ifNotNilDo: [:class |
			(class isKindOf: THContainerType) ifTrue: [
				class typeOfContainer isDictionary ifTrue: [
					class typeOfKeys ifNil: [
						class typeOfKeys: (self userSelectedContainerClass: 'key-type')]].
				class typeOfElements ifNil: [
					class typeOfElements: (self userSelectedContainerClass: 'value-type')]].
			class]! !

!SInstVarMorph methodsFor: 'menu actions' stamp: 'ag 9/8/2011 13:41:24.629'!
getClassFromTypeHarvest
	
	^ self class memberTypeFor: variableName in: self klass! !

!SInstVarMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:16:56.638'!
mouseActions
	
	^ super mouseActions
		at: #startDrag put: #openTypeMorph;
		at: #doubleClick put: #browseVariable;
		at: #startShiftDrag put: #startDraggingCopy;
		yourself! !

!SInstVarMorph methodsFor: 'menu actions' stamp: 'tfel 7/5/2012 13:51:04.944'!
openInstVarAssociationTo: newClassMorph
	"The connection used to start directly from the InstVarMorph itself, but that lead to problems with the Connector-library.
	When the InstVarMorph was collapsed (e.g. using the Toggle Labels button), the connectors would loose the correct starting point and 
	jump to a random point in the diagram."
	
	SAssociationConnector
		openFor: self classMorph
		connectedTo: newClassMorph
		variableName: variableName
		variableType: type.! !

!SInstVarMorph methodsFor: 'event handling' stamp: 'ag 11/22/2011 16:53:03.185'!
openTypeMorph
	
	self getClass ifNotNilDo: [ :cl |
		(SClassMorph on: cl) ifNotNilDo: [ :newClassMorph |
			self
				openInstVarAssociationTo: newClassMorph;
				openNewClassMorph: newClassMorph ] ].! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'ag 6/14/2012 11:51:40.163'!
processReengeneeringInto: newClassMorph
	"Moving a variable is only allowed to the direct super-/subclass to map directly to the available Refactoring-classes."
	
	self
		reengineerWith: newClassMorph
		ifSuperclass: [ ^ self pullUpVariableDeclaration ]
		ifSubclass: [ ^ self pushDownVariableDeclaration ].! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:00:48.797'!
pullUpVariableDeclaration
	
	self
		refactorClassVariable: PullUpClassVariableRefactoring
		instanceVariable: PullUpInstanceVariableRefactoring.! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:00:29.879'!
pushDownVariableDeclaration
	
	self
		refactorClassVariable: PushDownClassVariableRefactoring
		instanceVariable: PushDownInstanceVariableRefactoring.! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:00:06.011'!
refactorClassVariable: classVarRefactoringClass instanceVariable: instanceVarRefactoringClass
	
	| refactoringClass |
	refactoringClass :=
		self type == #class
			ifTrue: [ classVarRefactoringClass ]
			ifFalse: [ 
		self type == #instance
			ifTrue: [ instanceVarRefactoringClass ]
			ifFalse: [ ^ self ] ].
	SRefactoring execute:
		(refactoringClass
			variable: self variableName
			class: self visualizedClass).! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 14:52:30.521'!
renameVariable

	| newName refactoring |
	
	newName := (UIManager default
					request: 'New Variable Name'
					initialAnswer: variableName asString)
						ifEmpty: [ ^self ].
	newName = variableName ifTrue: [^self]  .
	
	type = #instance ifTrue: [
			   refactoring := RenameInstanceVariableRefactoring 
								rename: variableName
								to: newName
								in: klass
	] ifFalse: [ refactoring := RenameClassVariableRefactoring
								rename: variableName
								to:  newName 
								in: klass ].

	SRefactoring execute: refactoring.! !

!SInstVarMorph methodsFor: 'accessing' stamp: 'tfel 6/12/2012 15:09:35.991'!
type

	^ type! !

!SInstVarMorph methodsFor: 'accessing' stamp: 'sp 6/8/2012 14:47:05.009'!
type: aSymbol

	type := aSymbol.! !

!SInstVarMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:07:30.793'!
updateLabel
	
	| variableType |
	super updateLabel.
	variableType := self getClassFromTypeHarvest.
	(variableType isNil or: [variableType isBehavior]) ifFalse: [ | vT |
		vT := variableType.
		variableType := vT typeOfContainer asString, '<'.
		vT typeOfKeys ifNotNilDo: [:t | variableType := variableType, t, ', '].
		variableType := variableType, vT typeOfElements, '>'].
	labelMorph contents: variableName, (variableType ifNil: [' : ?'] ifNotNil: [' : ', variableType]).! !

!SInstVarMorph methodsFor: 'user class selection' stamp: 'ag 11/23/2011 10:36:27.848'!
userSelectedClass: aString
	
	| allClasses |
	allClasses := Class allSubInstances.
	^ (SMultipleChoiceRequest
		prompt: 'Choose a ', aString, '. Choose a Association/Collection/Dictionary type as Container type.'
		labels: (allClasses collect: #name)
		values: allClasses)! !

!SInstVarMorph methodsFor: 'user class selection' stamp: 'ag 11/23/2011 10:49:36.474'!
userSelectedContainerClass: aMessage
	
	^ (self userSelectedClass: aMessage) ifNotNilDo: [ :type |
		((type isKindOf: LookupKey class) or: [ type isKindOf: Dictionary class ])
			ifTrue: [ | container |
				"key-value-class"
				container := THContainerType new typeOfContainer: type.
				container typeOfKeys: ((self userSelectedContainerClass: 'key-type') ifNil: [ ^ nil ]).
				container typeOfElements: ((self userSelectedContainerClass: 'value-type') ifNil: [ ^ nil ]).
				container ]
		ifFalse: [
			(type isKindOf: Collection class)
				ifTrue: [ | container | 
					"collection-class"
					container  := THContainerType new typeOfContainer: type.
					container typeOfElements: ((self userSelectedContainerClass: 'element-type') ifNil: [ ^ nil ]).
					container ]
				ifFalse: [ "normal class" type ] ] ]! !

!SInstVarMorph methodsFor: 'accessing' stamp: 'fb 5/10/2011 14:45:36.992'!
variableName 
	^ variableName ! !

!SInstVarMorph methodsFor: 'accessing' stamp: 'tfel 4/29/2011 13:48:05.34'!
variableName: aString

	variableName := aString.! !

!SInstVarMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:14:21.778'!
wantsReengineeringInto: newClassMorph
	"Reengineering only valid for direct sub-/super-classes."
	
	^ self isDirectHierarchyNeighbor: newClassMorph! !

!SInstVarMorph methodsFor: 'event handling' stamp: 'ag 6/13/2012 14:50:29.406'!
wantsToBeDroppedInto: aMorph
	"Variables can be dropped into classes, that are either super- or sub-classes of the original class."
	
	^ aMorph isClassDiagramMorph
		and: [ | targetClass |
			targetClass := aMorph classMorph visualizedClass.
			(targetClass allSuperclasses includes: self visualizedClass)
			or: [ self visualizedClass allSuperclasses includes: targetClass ] ]! !

SPinnableEntryMorph subclass: #SMethodMorph
	instanceVariableNames: 'methodName sourceCodePopup highlightedColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SMethodMorph class methodsFor: 'constants' stamp: 'tfel 4/28/2011 23:03:02.215'!
borderWidth

	^ 0! !

!SMethodMorph class methodsFor: 'instance creation' stamp: 'ag 12/9/2011 14:46:55.912'!
on: aClass in: aClassMorph forMethod: aMethodName
	
	^ self basicNew
		klass: aClass;
		classMorph: aClassMorph;
		methodName: aMethodName;
		initialize;
		yourself! !

!SMethodMorph methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:32:40.384'!
accept: aVisitor

	aVisitor visitMethod: self.
	classMorph pasteUpMorphOrWorld allConnections
		select: [:connection | connection sourceMorph == self]
		thenDo: [:connection | aVisitor visit: connection ].
	self updateLabel.! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'sp 6/27/2012 22:18:16.812'!
addParameter
	| initializer newSelector initialAnswer |
	initialAnswer := methodName numArgs = 0 
		ifTrue: [ methodName , ':' ]
		ifFalse: [ methodName ].
	newSelector := UIManager default
		request: 'Enter new selector:'
		initialAnswer: initialAnswer.
	newSelector isEmpty ifTrue: [ ^ nil ].
	initializer := UIManager default 
		request: 'Enter default value for parameter:'
		initialAnswer: 'nil'.
	initializer isEmpty ifTrue: [ ^ nil ].
	
	SRefactoring execute: (AddParameterRefactoring
								addParameterToMethod: methodName asSymbol
								in: klass
								newSelector: newSelector asSymbol
								initializer: initializer)! !

!SMethodMorph methodsFor: 'event handling' stamp: 'ag 10/12/2011 14:53:09.411'!
browseMethod
	
	SystemBrowser default == OBSystemBrowserAdaptor
		ifTrue: [
			OBCodeBrowser defaultBrowserClass 
				openOnClass: self visualizedClass "Avoid passing THContainerType"
				selector: methodName asSymbol ]
		ifFalse: [
			Browser openBrowser
				setClass: self visualizedClass "Avoid passing THContainerType"
				selector: methodName asSymbol ].! !

!SMethodMorph methodsFor: 'menu' stamp: 'sp 6/4/2012 12:36:57.961'!
buildMenu: aMenu
	| refactoringMenu |
	aMenu
		add: 'Rename method' target: self selector: #renameMethod;
		add: 'Delete method' target: self selector: #deleteMethod.

	refactoringMenu := MenuMorph new.
	refactoringMenu
		add: 'Add parameter' target: self selector: #addParameter;
		add: 'Remove parameter' target: self selector: #removeParameter;
		add: 'Inline parameter' target: self selector: #inlineParameter.
	aMenu add: 'more...' subMenu: refactoringMenu.
! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'sp 6/27/2012 22:17:31.087'!
confirmRenameMethod

	| answer sends count |
	sends := SystemNavigation default allCallsOn: methodName.
	
	(count := sends size) = 0
		ifTrue: [^1 "no senders -- let renaming happen without warning"].    
	(count = 1 and: [sends first actualClass == klass 
				and: [sends first methodSymbol == methodName ]])
		ifTrue: [^ 1 "only sender is itself"].

	answer := UIManager default 
			chooseFrom: #(	'Rename, and all its senders'
							'Rename, and only rename message sends within package'							
					            'Rename, but without renaming message sends'
							'Rename, then browse senders'
							'Don''t rename, but show me those senders'
							'Forget it -- do nothing -- sorry I asked')
			title: 'This message has ', count printString, 'senders'.  

	answer = 5 ifTrue: [
		SystemNavigation default
			browseMessageList: sends
			name: 'Senders of ' , methodName ].

	answer = 0 ifTrue: [answer := 5 "no answer treated as cancel"].
	^answer min: 5.! !

!SMethodMorph methodsFor: 'accessing' stamp: 'ag 4/18/2012 15:03:33.294'!
currentColor
	
	^ highlightedColor ifNil: [ super currentColor ]! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'sp 6/22/2012 14:38:52.917'!
deleteMethod

	| confirmation |
	(UIManager default confirm: 'Really delete ', methodName, '?') ifFalse: [^self].

	confirmation := SystemNavigation default confirmRemovalOf: methodName on: klass.
	confirmation = 3
		ifTrue: [^ self].
		
	klass removeSelector: methodName.		
	confirmation = 2
		ifTrue: [SystemNavigation default browseAllCallsOn: methodName.]! !

!SMethodMorph methodsFor: 'accessing' stamp: 'ag 4/18/2012 15:02:19.453'!
highlightedColor
	
	^ highlightedColor! !

!SMethodMorph methodsFor: 'accessing' stamp: 'ag 5/2/2012 15:13:25.654'!
highlightedColor: aColor
	"If this color is set, the method-entry will always have this color, disregarding whether it is pinned or not.
	Not that this is called highlightEDcolor, not highlightColor, as highlightColor is already defined in Morph.
	Set this to nil to enable default coloring."
	
	highlightedColor := aColor.
	self color: aColor.! !

!SMethodMorph methodsFor: 'event handling' stamp: 'ag 12/12/2011 11:03:50.495'!
hoverIn
	
	super hoverIn.
	sourceCodePopup ifNil: [
		sourceCodePopup := SSourceCodePopup
			on: self
			withMethod: methodName
			in: self visualizedClass ].
	sourceCodePopup appear.! !

!SMethodMorph methodsFor: 'event handling' stamp: 'ag 12/10/2011 15:30:25.294'!
hoverOut
	
	super hoverOut.
	sourceCodePopup ifNotNil: [ sourceCodePopup morphUnhovered ].! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 15:05:15.349'!
inlineParameter
	| arguments |
	arguments := (RBParser new
						initializeParserWith: ((klass >> methodName) getSource);
						parseMessagePattern) argumentNames.
	SRefactoring execute: (InlineParameterRefactoring
								removeParameter: (UIManager default 
										chooseFrom: arguments values: arguments)
								in: klass
								selector: methodName asSymbol)! !

!SMethodMorph methodsFor: 'accessing' stamp: 'tfel 7/14/2011 13:47:15.522'!
methodName

	^ methodName
! !

!SMethodMorph methodsFor: 'accessing' stamp: 'tfel 4/29/2011 14:33:37.812'!
methodName: aString

	methodName := aString.! !

!SMethodMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:17:05.428'!
mouseActions

	^ super mouseActions
		at: #startDrag put: #openMethod;
		at: #doubleClick put: #browseMethod;
		at: #startShiftDrag put: #startDraggingCopy;
		yourself! !

!SMethodMorph methodsFor: 'event handling' stamp: 'ag 3/8/2012 13:15:11.082'!
openMethod
	
	self openMethodMorph openInHand.! !

!SMethodMorph methodsFor: 'event handling' stamp: 'ag 3/8/2012 13:15:01.288'!
openMethodMorph
	
	^ (SStickySourceCodeMorph on: methodName in: self visualizedClass)
		connectTo: self! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'ag 6/14/2012 11:52:13.937'!
processReengeneeringInto: newClassMorph
	"For now, moving a method is only allowed to direct sub/super-classes, to map better
	to the available refactorings (PullUp/PushDown-Method).
	The MoveMethodRefactoring seems to have another purpose, than one would expect in this context."
	
	self
		reengineerWith: newClassMorph
		ifSuperclass: [ ^ self pullUpMethod ]
		ifSubclass: [ ^ self pushDownMethod ].! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:04:07.002'!
pullUpMethod
	
	SRefactoring execute:
		(PullUpMethodRefactoring 
			pullUp: { self methodName }
			from: self visualizedClass).! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'ag 7/2/2012 13:42:22.108'!
pushDownMethod
	
	SRefactoring execute:
		(SPushDownMethodRefactoring 
			pushDown: { self methodName }
			from: self visualizedClass).! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'sp 6/8/2012 15:04:40.36'!
removeParameter
	| arguments |
	arguments := (RBParser new
						initializeParserWith: ((klass >> methodName) getSource);
						parseMessagePattern) argumentNames.
	
	SRefactoring execute: (RemoveParameterRefactoring
								removeParameter: (UIManager default 
														chooseFrom: arguments values: arguments)
								in: klass
								selector: methodName asSymbol).! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'sp 6/27/2012 22:16:52.348'!
renameMethod
	| answer oldMethodName newMethodName oldArguments argumentPermutation senders |
	
	answer := self confirmRenameMethod.	
	(answer = 5) ifTrue: [^self].
	(answer = 1) ifTrue: [senders := #all].
	(answer = 2) ifTrue: [senders := #package].
	(answer = 3 or: [answer = 4]) ifTrue: [senders := #none].
	
	oldArguments := 
		(RBParser parseMethod: (klass methodHeaderFor: methodName)) argumentNames.
	oldMethodName := RBMethodName selector: methodName arguments: oldArguments.
	
	(newMethodName := UIManager default 
								request: 'New Method Name (do not rename parameter!!)'
								initialAnswer: oldMethodName printString) ifEmpty: [ ^ self ].
	newMethodName := RBParser parseMethod: newMethodName.
	newMethodName selector = oldMethodName selector
		ifTrue: [^self].    

	argumentPermutation := newMethodName arguments collect: 
								[ :each | oldArguments indexOf: each token value ].
	
	SRefactoring execute: (SRenameMethodRefactoring
								renameMethod: methodName asSymbol
								in: klass
								to: newMethodName selector
								permutation: argumentPermutation
								withSenders: senders).
								
	answer = 4 ifTrue: [
		SystemNavigation default browseAllCallsOn: methodName ].  ! !

!SMethodMorph methodsFor: 'layout and labels' stamp: 'ag 12/12/2011 11:20:47.889'!
update
	
	super update.
	sourceCodePopup ifNotNil: [ sourceCodePopup updateParentMorph ].! !

!SMethodMorph methodsFor: 'layout and labels' stamp: 'ag 12/10/2011 16:07:25.486'!
updateLabel
	
	super updateLabel.
	labelMorph contents: methodName.! !

!SMethodMorph methodsFor: 'reengineering' stamp: 'ag 6/13/2012 16:14:35.375'!
wantsReengineeringInto: newClassMorph
	"Reengineering only valid for direct sub-/super-classes."
	
	^ self isDirectHierarchyNeighbor: newClassMorph! !

!SPinnableEntryMorph class methodsFor: 'constants' stamp: 'ag 12/10/2011 16:03:20.725'!
pinnedColor
	
	^ Color lightCyan duller duller duller paler paler "^^"! !

!SPinnableEntryMorph methodsFor: 'event handling' stamp: 'ag 9/22/2011 19:32:17.492'!
clicked
	
	super clicked.
	self togglePin.! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 12/10/2011 16:03:36.367'!
currentColor
	
	^ pinned & pinStateVisible
		ifTrue: [ self class pinnedColor ]
		ifFalse: [ super currentColor ]! !

!SPinnableEntryMorph methodsFor: 'initialization' stamp: 'ag 12/10/2011 15:21:54.338'!
initialize
	
	super initialize.
	pinned := false.	
	pinStateVisible := true.
	self listDirection: #leftToRight.
	klass isMeta ifTrue: [
		labelMorph emphasis: TextEmphasis underlined emphasisCode ].! !

!SPinnableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 18:04:28.215'!
isPinnable
	
	^ true! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 9/22/2011 12:59:41.821'!
isPinned

	^ pinned! !

!SPinnableEntryMorph methodsFor: 'layout and labels' stamp: 'ag 12/9/2011 12:45:00.824'!
needsToBeShown
	
	^ pinned! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 12/10/2011 15:29:03.467'!
pin
	
	pinned := true.
	self updatePinVisualization.! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 4/18/2012 14:57:00.237'!
removePinVisualization
	"We have no pin icon anymore, color code the line."
	
	self visualizePinState: false.! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 9/22/2011 18:43:01.877'!
togglePin
	
	pinned
		ifTrue: [ self unpin ]
		ifFalse: [ self pin ].! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 12/10/2011 15:28:59.929'!
unpin
	
	pinned := false.
	self updatePinVisualization.! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 4/18/2012 14:57:14.792'!
updatePinVisualization
	
	pinned 
		ifTrue: [ ^ self visualizePinState: true ]
		ifFalse: [ ^ self removePinVisualization ]! !

!SPinnableEntryMorph methodsFor: 'pinning' stamp: 'ag 12/10/2011 15:24:52.738'!
visualizePinState: aBoolean
	
	pinStateVisible := aBoolean.
	self hoverIn. "Update the color"! !

SClassDiagramMorph subclass: #SMorphWithToolbar
	instanceVariableNames: 'toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

SMorphWithToolbar subclass: #SClassMorph
	instanceVariableNames: 'menuMorph classSideMorph highlightColor oldHighlightColor layoutMovementVector nameMorph implementationMorph'
	classVariableNames: 'AutoAncestorDepth AutoBuildConnections AutoBuildDynamicConnections AutoBuildStaticConnections'
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

SClassMorph class
	instanceVariableNames: 'keyMap'!

!SClassMorph commentStamp: 'tfel 5/20/2011 09:48:56.854' prior: 0!
A SClassMorph is the container for a Class. It displays a SClassNameMorph and a SImplementationMorph within itself. It draws a custom halo and reacts to keyboard events when active.
!

SClassMorph class
	instanceVariableNames: 'keyMap'!

!SClassMorph class methodsFor: 'preferences' stamp: 'ag 12/29/2011 11:25:48.425'!
autoAncestorDepth
	<preference: 'Auto ancestor depth'
		category: 'Path View'
		description: 'When automatically adding superclass relationships to a class morph, this denotes the (maximum) number of levels up the inheritance chain we walk'
		type: #Number>
	^ AutoAncestorDepth ifNil: [ AutoAncestorDepth := 1 ]! !

!SClassMorph class methodsFor: 'preferences' stamp: 'tfel 7/7/2011 16:25:34.881'!
autoAncestorDepth: aNumber
	
	AutoAncestorDepth := aNumber.! !

!SClassMorph class methodsFor: 'preferences' stamp: 'ag 12/29/2011 11:25:16.654'!
autoBuildConnections
	<preference: 'Build connections automatically'
		category: 'Path View'
		description: 'When a view is opened with one or more morphs or a morph is added to an open view, ask for whether the connections (inheritance and associations) with other classes should be opened. When the new morph is the first on the diagram, other class-morphs will be opened to connect to. If other morphs already are in the diagram, only the connections to these morphs will be opened (if there will be no connections, the query-dialog will be skipped completely).'
		type: #Boolean>
	^ AutoBuildConnections ifNil: [ AutoBuildConnections := true ]! !

!SClassMorph class methodsFor: 'preferences' stamp: 'ag 12/29/2011 11:23:52.628'!
autoBuildConnections: aBoolean
	
	^ AutoBuildConnections := aBoolean! !

!SClassMorph class methodsFor: 'constants' stamp: 'ag 9/9/2011 10:56:27.468'!
backgroundColor

	^ Color transparent! !

!SClassMorph class methodsFor: 'constants' stamp: 'mp 1/7/2011 16:56:05.617'!
borderColor

	^ Color gray: 0.5! !

!SClassMorph class methodsFor: 'constants' stamp: 'mp 1/7/2011 16:35:44.016'!
borderWidth

	^ 0! !

!SClassMorph class methodsFor: 'known transfer types' stamp: 'tfel 4/28/2011 18:08:56.71'!
browserTransferType

	^ #dragTransferPlus! !

!SClassMorph class methodsFor: 'morph conversion' stamp: 'sp 6/22/2012 16:13:57.283'!
canBeConverted: aMorph
	
	^ aMorph dragTransferType 
		caseOf: {
			[ self classMorphTransferType ] -> [ true ].
			[ self omniBrowserTransferType ] -> [ aMorph passenger isClassNode ].
		}
		otherwise: [ 
			(aMorph respondsTo: #passenger) 
			and: [ aMorph passenger isBehavior ] ] "Anything that carries a class is good to go"! !

!SClassMorph class methodsFor: 'constants' stamp: 'omg 7/14/2011 12:05:00.591'!
classMorphPadding
	"The padding when automatically adding classes"
	^ 30
! !

!SClassMorph class methodsFor: 'known transfer types' stamp: 'tfel 4/28/2011 18:25:08.733'!
classMorphTransferType

	^ #SClassMorph! !

!SClassMorph class methodsFor: 'instance creation' stamp: 'ag 9/22/2011 19:03:34.056'!
commonSuperclassOf: aClassArray
	
	^ (aClassArray
			inject: aClassArray first allSuperclasses
			into: [:sub :c | c allSuperclasses intersection: sub])
				first! !

!SClassMorph class methodsFor: 'morph conversion' stamp: 'ag 9/22/2011 13:33:34.824'!
fromMorph: aMorph
	"May only be called, if canBeConverted: aMorph has returned true. No further checks are performed here."
	
	^ aMorph dragTransferType 
		caseOf: {
			[ self classMorphTransferType ] -> [ aMorph ].
			[ self omniBrowserTransferType ] -> [ self on: aMorph passenger theClass ].
		}
		otherwise: [ self on: aMorph passenger ]! !

!SClassMorph class methodsFor: 'constants' stamp: 'ag 9/22/2011 21:19:58.697'!
highlightColor
	"Colors of superclasses will be rendered based on this color, by subtracting from the alpha value."
	
	^ Color blue alpha: 0.3! !

!SClassMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/20/2011 09:09:00.949'!
interestingSystemEvents

	^ #('classModifiedEvent:' 'classRemovedEvent:')! !

!SClassMorph class methodsFor: 'constants' stamp: 'ag 9/22/2011 19:02:38.343'!
keyMap
	"keyMap := nil"
	
	^ keyMap ifNil: [ | shiftDistance |
		shiftDistance := [ :evt | evt shiftPressed ifTrue: [10] ifFalse: [1] ].
		keyMap := Dictionary newFrom: {
			Character delete -> [:this | this dismissViaHalo].
			Character arrowUp -> [:this :evt | this top: this top - (shiftDistance value: evt)].
			Character arrowDown -> [:this :evt | this top: this top + (shiftDistance value: evt)].
			Character arrowLeft -> [:this :evt | this left: this left - (shiftDistance value: evt)].
			Character arrowRight -> [:this :evt | this left: this left + (shiftDistance value: evt)]
		} ]! !

!SClassMorph class methodsFor: 'known transfer types' stamp: 'tfel 4/28/2011 18:08:28.641'!
omniBrowserTransferType

	^ #OmniBrowser! !

!SClassMorph class methodsFor: 'instance creation' stamp: 'ag 11/11/2011 11:26:37.442'!
on: aClass
	
	(self = SContainerClassMorph | aClass isBehavior) ifFalse: [ ^ SContainerClassMorph on: aClass ].
	(aClass isCollection and: [ aClass size > 1 ]) ifTrue: [ ^ SClassMorph onList: aClass ].
	^ super on: aClass! !

!SClassMorph class methodsFor: 'instance creation' stamp: 'ag 10/25/2011 10:04:53.837'!
onList: aClassArray
	
	| withCommonSuperclass |
	withCommonSuperclass := { self commonSuperclassOf: aClassArray }
									addAll: aClassArray;
									yourself.
	^ self on: (SMultipleChoiceRequest
				prompt: 'Choose class'
				labels: (withCommonSuperclass collect: [:c | c name asString])
				values: withCommonSuperclass
				lines: #(1))! !

!SClassMorph class methodsFor: 'system event configuration' stamp: 'tfel 5/20/2011 09:09:09.671'!
systemEventHandler

	^ #classModified:! !

!SClassMorph methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:30:38.759'!
accept: aVisitor

	aVisitor visitClass: self.
	{nameMorph. classSideMorph. implementationMorph}
		select: #notNil
		thenDo: [:m | aVisitor visit: m].
	self pasteUpMorphOrWorld allConnections
		select: [:connection | connection sourceMorph == self]
		thenDo: [:connection | aVisitor visit: connection ].! !

!SClassMorph methodsFor: 'dropping/grabbing' stamp: 'ag 6/28/2012 12:24:17.849'!
acceptDroppingMorph: aMorph event: anEvent
	
	(aMorph isKindOf: SFloatingCodeSnippet)
		ifTrue: [ aMorph processReengeneeringInto: self ]
		ifFalse: [
			aMorph isClassMorph
				ifTrue: [ self mergeOtherClassMorph: aMorph ]
				ifFalse: [ aMorph processReengeneeringInto: self ] ].! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 9/22/2011 19:26:56.007'!
addClassCommentAsNote
	
	^ self addNote
		extent: 300@300;
		setText: self klass comment! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 8/19/2011 11:27:09.425'!
addNote
	
	| target |
	target := SNoteMorph new.
	SNoteConnector openFor: self connectedTo: target.
	^ target openInHand! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:45:46.17'!
applyForceFrom: otherMorphs
	
	self vector: 
		(self vector + "Add the new vector to the old"
		(self totalForceFrom: otherMorphs))
		* SClassDiagram damping.! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 12/26/2011 15:20:53.879'!
attractionFrom: connection
	"attraction-force = -distance * attraction-constant.
	First, get the other morph from the connection. This is multiplied with the direction to get a vector."
	
	| otherMorph vector |
	otherMorph := self == connection targetMorph
		ifTrue: [ connection sourceMorph isClassDiagramMorph ifTrue: [ connection sourceMorph classMorph ] ifFalse: [ connection sourceMorph ] ]
		ifFalse: [ connection targetMorph ].
	vector := self vectorTo: otherMorph.
	^ vector normalized negated * vector r * SClassDiagram attractionConstant! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 1/15/2012 21:51:12.106'!
browseClassHierarchy
	
	self visualizedClass browseHierarchy.! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 12/27/2011 17:07:18.6'!
changeColor
	
	super changeColor.
	self diagramDirty.! !

!SClassMorph methodsFor: 'auto connectors' stamp: 'ag 12/29/2011 12:32:57.95'!
checkOpenConnectors: openClassMorphs
	
	^ self class autoBuildConnections
	and: [ "Check, whether we could actually open any connectors."
		openClassMorphs size = 1
			ifTrue: [ "First class-morph -> Just need to have a superclass or any info on any instance-variable."
				self visualizedClass superclass notNil
				or: [ self instanceVariableTypes notEmpty ] "TODO mindestens info ber eine instanz-var" ]
			ifFalse: [ "Other morphs already present. Check, whether we could connect to any of them."
				(self superclassMorphIn: openClassMorphs) notNil
				or: [ self klass allSubclasses anySatisfy: [ :class | openClassMorphs anySatisfy: [ :morph | morph visualizedClass = class ] ] ]
				or: [ self instanceVariableTypes anySatisfy: [ :class | openClassMorphs anySatisfy: [ :morph | morph visualizedClass = class ] ] ] ] ]
	and: [ UIManager default confirm: 'Automatically create connections?' ]! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 5/23/2012 11:22:41.681'!
chooseSubclass
	
	^ SMultipleChoiceRequest
		prompt: 'Choose a subclass'
		labels: (klass subclasses collect: #name), { 'Create new subclass...' }
		values: klass subclasses, { self newSubclassMarker }! !

!SClassMorph methodsFor: 'event handling' stamp: 'sp 6/4/2012 15:48:43.737'!
classModified: anEvent

	anEvent isRemoved ifTrue: [ self dismissViaHalo ].
	anEvent isModified
		ifTrue: [
			self connections do: #update.
			self update ].! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 12/27/2011 16:32:04.67'!
classMorph
	
	^ self! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.831'!
classSideMorph
	"Answer the value of classSideMorph"

	^ classSideMorph! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.84'!
classSideMorph: anObject
	"Set the value of classSideMorph"

	classSideMorph := anObject! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 5/23/2012 11:44:32.099'!
createNewSubclass
	
	| name |
	name := self uniqueClassnameBasedOn: #SubclassOf, self klass name.
	(AddClassRefactoring
		addClass: name
		superclass: self klass
		subclasses: {}
		category: self klass category)
			execute.
	^ Smalltalk at: name! !

!SClassMorph methodsFor: 'dropping/grabbing' stamp: 'tfel 4/28/2011 18:24:38.511'!
dragTransferType

	^ self class classMorphTransferType! !

!SClassMorph methodsFor: 'drawing' stamp: 'ag 9/22/2011 19:15:18.948'!
drawSubmorphsOn: aCanvas

	| theCanvas |
	theCanvas := SColorMappingCanvas on: aCanvas.
	theCanvas mapping: [ :aColor |
		(aColor = self class backgroundColor)
			ifTrue: [
				self isHighlighted
					ifTrue: [ highlightColor ]
					ifFalse: [ self color ] ]
			ifFalse: [
				aColor ]].
	^ super drawSubmorphsOn: theCanvas! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 12/27/2011 16:33:05.393'!
elementClassMorph
	
	^ self! !

!SClassMorph methodsFor: 'actions' stamp: 'ag 3/8/2012 13:25:52.64'!
expandMorphs
	"This must be done before toggleLabels, to ensure that all subentries of all morphs are intialized correctly."
	
	implementationMorph recursivelyExpandMorphs.! !

!SClassMorph methodsFor: 'event handling' stamp: 'ag 12/26/2011 13:03:41.607'!
focus
	
	self currentHand newKeyboardFocus: self.
	self highlightClassMorphs.
	self changed: #classMorphSelected.! !

!SClassMorph methodsFor: 'event handling' stamp: 'ag 9/22/2011 19:22:03.068'!
handleKeystroke: anEvent
	"Handle the keystroke using the class-side keyMap.
	This may contain characters or key strings. Blocks can take self and the event as arguments"
	
	{ anEvent keyCharacter. anEvent keyString }
		anySatisfy: [ :key |
			(self class keyMap
				at: key
				ifPresent: [ :block | 
					block valueWithEnoughArguments: { self . anEvent }.
					true ]
				ifAbsent: [ false ]) ].! !

!SClassMorph methodsFor: 'dropping/grabbing' stamp: 'ag 9/21/2011 19:34:37.359'!
handlesMouseOverDragging: anEvent
	
	^ true! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 8/19/2011 11:29:18.863'!
hasSubclasses
	
	^ self klass subclasses notEmpty! !

!SClassMorph methodsFor: 'highlighting' stamp: 'ag 12/27/2011 17:06:54.68'!
highlight: aColor
	
	highlightColor := aColor.
	self changed.! !

!SClassMorph methodsFor: 'highlighting' stamp: 'ag 9/22/2011 21:20:39.119'!
highlightFocus
	"Highlight the receiiver, as if it had the focus."
	
	self highlight: self class highlightColor.! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:02:51.712'!
implementationMorph
	"Answer the value of implementationMorph"

	^ implementationMorph ifNil: [implementationMorph := SImplementationMorph 
																on: klass in: self]! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.907'!
implementationMorph: anObject
	"Set the value of implementationMorph"

	implementationMorph := anObject! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 12/29/2011 11:04:57.854'!
inheritanceConnectorSource
	"For normal class-morphs, inheritance-connectors connect to the morph directly."
	
	^ self! !

!SClassMorph methodsFor: 'initialization' stamp: 'ag 12/29/2011 12:23:51.026'!
initialize
	
	super initialize.
	self
		borderWidth: 0;
		color: self class backgroundColor;
		highlight: nil;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		rubberBandCells: true;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		
		initializeSubMorphs.! !

!SClassMorph methodsFor: 'initialization' stamp: 'mp 3/7/2012 18:02:28.663'!
initializeSubMorphs
	
	self 
		addMorph: self nameMorph;
		addMorphBack: self implementationMorph.! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 12/29/2011 12:30:51.312'!
instanceVariableTypes
	
	^ self currentTypeBucket
		ifNil: [ #() ]
		ifNotNilDo: [ :typeBucket | | classes |
			classes := OrderedCollection new.
			klass allInstVarNames withIndexDo: [ :name :idx |
				(typeBucket memberTypeFor: idx in: klass)
					ifNotNilDo: [ :class | classes add: class ] ].
			classes ]! !

!SClassMorph methodsFor: 'associations' stamp: 'ag 4/18/2012 16:04:26.325'!
isAssociatedWith: classMorph overVariable: varName
	
	| type |
	type := self class memberTypeFor: varName in: klass.
	^ type notNil
		and: 
			[ ((type = classMorph klass)
			or: [ type isBehavior not and: [ type innerTypeOfElements = classMorph klass ] ]) ]! !

!SClassMorph methodsFor: 'testing' stamp: 'ag 12/29/2011 11:08:11.584'!
isClassMorph 
	
	^ true! !

!SClassMorph methodsFor: 'highlighting' stamp: 'ag 9/22/2011 19:54:34.068'!
isHighlighted
	
	^ highlightColor notNil! !

!SClassMorph methodsFor: 'testing' stamp: 'ag 4/19/2012 14:07:36.02'!
isSuperClassOf: aMorph
	
	^ (aMorph isKindOf: SClassMorph)
		and: [ self klass allSubclasses includes: aMorph visualizedClass ]! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:44:53.999'!
kineticEnergy
	"e = m * v squared"
	
	^ self velocity squared * self mass! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.865'!
layoutMovementVector
	"Answer the value of layoutMovementVector"

	^ layoutMovementVector! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.874'!
layoutMovementVector: anObject
	"Set the value of layoutMovementVector"

	layoutMovementVector := anObject! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:25:24.205'!
mass
	"The mass of a class-morph is based on it's extent. This is just an estimating formula,
	as there is no real physical equivalent for this."
	
	^ (self extent x * self extent y) sqrt / 180! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.814'!
menuMorph
	"Answer the value of menuMorph"

	^ menuMorph! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.823'!
menuMorph: anObject
	"Set the value of menuMorph"

	menuMorph := anObject! !

!SClassMorph methodsFor: 'dropping/grabbing' stamp: 'ag 12/27/2011 11:07:27.897'!
mergeOtherClassMorph: aMorph
	
	aMorph connections do: [ :each | each mergeFrom: aMorph to: self ].
	self focus.
	aMorph abandon.! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 3/8/2012 13:13:08.681'!
methodMorphFor: association
	"class -> selector"
	
	^ self implementationMorph methodMorphFor: association! !

!SClassMorph methodsFor: 'event handling' stamp: 'tfel 5/22/2012 14:36:08.678'!
mouseActions
	
	^ super mouseActions
		at: #click put: #focus;
		yourself! !

!SClassMorph methodsFor: 'event handling' stamp: 'ag 6/23/2012 15:05:01.042'!
mouseEnterDragging: anEvent
	"Highlight this class-morph, if the dragged morph could be dropped into it.
	We store the current highlight, to restore it after the mouse leaves us."
	
	anEvent hand submorphs ifNotEmptyDo: [ :submorphs |
		(self wantsDroppedMorph: submorphs first event: anEvent)
			ifTrue: [ 
				oldHighlightColor := highlightColor.
				self highlight: (Color yellow alpha: 0.2) ] ].! !

!SClassMorph methodsFor: 'event handling' stamp: 'ag 6/13/2012 16:43:17.81'!
mouseLeaveDragging: anEvent
	
	oldHighlightColor
		ifNil: [ self removeHighlight ]
		ifNotNil: [
			self highlight: oldHighlightColor.
			oldHighlightColor := nil ].! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:44:35.788'!
moveInside: aRectangle
	"Use the current movement-vector to change the receiver's position.
	Make sure to keep the new position inside aRectangle."
	
	self position: 
		((self position + self vector)
			adhereTo: (aRectangle insetOriginBy: 0 cornerBy: self extent)).! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:02:14.424'!
nameMorph
	"Answer the value of nameMorph"

	^ nameMorph ifNil: [nameMorph := SClassNameMorph on: self visualizedClass in: self]! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.89'!
nameMorph: anObject
	"Set the value of nameMorph"

	nameMorph := anObject! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 12/29/2011 11:59:56.457'!
nearestMorphIn: collectionOfMorphs
	
	^ collectionOfMorphs detectMin: [ :each | each center dist: self center ]! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 5/23/2012 11:05:37.903'!
newSubclassMarker
	"Return-value of #chooseSubclass, when a new subclass should be created.
	For simple usage of SMultipleChoiceRequest."
	
	^ #NewSubclassMarker! !

!SClassMorph methodsFor: 'submorphs-accessing' stamp: 'ag 9/22/2011 21:13:38.301'!
noteNewOwner: aMorph
	"I have just been added as direct submorph to aMorph."
	
	super noteNewOwner: aMorph.
	self addDependent: aMorph.! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.848'!
oldHighlightColor
	"Answer the value of oldHighlightColor"

	^ oldHighlightColor! !

!SClassMorph methodsFor: 'accessing' stamp: 'mp 3/7/2012 18:01:28.857'!
oldHighlightColor: anObject
	"Set the value of oldHighlightColor"

	oldHighlightColor := anObject! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 2/16/2012 13:52:26.108'!
openAncestors
	"Automatically opens ancestors. How many is configurable in the preferences.
	No layouting is done, the new morphs are simply placed beside the old one"
	
	| currentClass currentMorph |
	currentClass := klass ifNil: [ ^ self ].
	currentMorph := self.
	(self pasteUpMorphOrWorld class == SClassDiagram) ifTrue: [
		self class autoAncestorDepth timesRepeat: [ | newMorph |
			(currentClass := currentClass superclass) 
				ifNil: [ ^ self ]
				ifNotNil: [
					newMorph := self pasteUpMorphOrWorld
						openClassMorphFor: currentClass
						nextTo: currentMorph
						positionedBy: [ :target |
							target align: target topCenter with: currentMorph topCenter.
							target bottom: currentMorph top - self class classMorphPadding ].
					currentMorph openInheritenceConnectionsWith: newMorph.
					currentMorph := newMorph ] ] ].! !

!SClassMorph methodsFor: 'associations' stamp: 'ag 7/5/2012 11:01:39.361'!
openAssociationConnectionsTo: classMorph
	"Open all association-connectors directed from the receiver to classMorph.
	Return all newly opened connectors."
	
	classMorph = self ifTrue: [ ^ OrderedCollection new ].
	^ (klass allInstVarNames asOrderedCollection withIndexCollect: [ :name :idx |
		(self isAssociatedWith: classMorph overVariable: name) ifTrue: [
			(self variableMorphFor: self visualizedClass -> name)
				ifNotNilDo: [ :variableMorph |
					variableMorph openInstVarAssociationTo: classMorph ] ] ])
	reject: #isNil! !

!SClassMorph methodsFor: 'associations' stamp: 'ag 8/19/2011 10:21:18.13'!
openAssociationConnectionsWith: classMorph
	
	^ self openAssociationConnectionsWithAll: { classMorph }! !

!SClassMorph methodsFor: 'associations' stamp: 'ag 4/18/2012 15:29:31.909'!
openAssociationConnectionsWithAll: collectionOfClassMorphs
	"Open all association-connectors from the receiver to any of the ClassMorphs in collectionOfClassMorphs and backwards.
	Return a collection of all new opened associations."
	
	^ collectionOfClassMorphs
		gather: [ :each |
			(each openAssociationConnectionsTo: self)
			addAll: (self openAssociationConnectionsTo: each);
			yourself ]! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 4/18/2012 15:33:13.161'!
openAssociations
	"Automatically opens direct associations.
	No layouting is done, the new morphs are simply placed below the old one."
	
	self currentTypeBucket ifNotNilDo: [ :typeBucket | | classMorphs |
		classMorphs := OrderedCollection new.
		klass allInstVarNames withIndexDo: [:name :idx | | class |
			class := typeBucket memberTypeFor: idx in: klass.
			class ifNotNil: [
				classMorphs addLast: (self pasteUpMorphOrWorld
					openClassMorphFor: class
					nextTo: self
					positionedBy: [ :newMorph | 
						newMorph topLeft: (self right  + (self class classMorphPadding * 3)) @
								(classMorphs
									ifEmpty: [self top]
									ifNotEmpty: [classMorphs last bottom + self class classMorphPadding]) ] ) ] ].
		self openAssociationConnectionsWithAll: classMorphs ].! !

!SClassMorph methodsFor: 'associations' stamp: 'ag 8/19/2011 11:33:38.079'!
openInheritenceConnectionsWith: classMorph
	"Open all super- and sub-class connections from the receiver to any of the ClassMorphs in collectionOfClassMorphs"
	
	^ self openInheritenceConnectionsWithAll: { classMorph }! !

!SClassMorph methodsFor: 'associations' stamp: 'ag 2/16/2012 13:46:07.143'!
openInheritenceConnectionsWithAll: collectionOfClassMorphs
	"Open all super- and sub-class connections from the receiver to any of the ClassMorphs in collectionOfClassMorphs.
	Only one super-class-morph is connected, but multiple sub-class-morphs."
	
	| selfMorph |
	selfMorph := self elementClassMorph.
	(self superclassMorphIn: collectionOfClassMorphs) ifNotNilDo: [ :morph |
			SInheritanceConnector openFor: selfMorph connectedTo: morph ].
	
	"Do not open connections to subclasses. The subclasses will open their own superclass-connections."
"	(collectionOfClassMorphs select: [ :each | klass allSubclasses includes: each visualizedClass ])
		do: [ :subClassMorph |
			SInheritanceConnector openFor: subClassMorph connectedTo: selfMorph ]."! !

!SClassMorph methodsFor: 'actions' stamp: 'ag 3/30/2012 11:56:20.126'!
openMethod: association
	"class -> selector"
	
	^ (self methodMorphFor: association)
		ifNotNilDo: [ :morph | | method |
			method := morph openMethodMorph.
			self owner addMorph: 
				(method
					position: self position;
					yourself).
			method ].! !

!SClassMorph methodsFor: 'loading/saving' stamp: 'tfel 6/5/2012 15:10:12.024'!
openMethodMorphs: methodSpecs

	methodSpecs do: [:spec || mm |
		mm := self openMethod: spec first.
		mm
			ifNil: [self flag: #tfel. "TODO: show warning or something"]
			ifNotNil: [mm bounds: (spec second corner: spec third)]].! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 7/2/2012 15:29:19.747'!
openSubClass
	
	| subclass |
	subclass := self chooseSubclass.
	subclass = self newSubclassMarker ifTrue: [ subclass := self createNewSubclass ].
	subclass ifNotNil: [ | connector target |
		target := SClassMorph on: subclass.
		self openNewClassMorph: target.
		connector := SInheritanceConnector openFor: target connectedTo: self inheritanceConnectorSource.
		self addDependent: connector ].! !

!SClassMorph methodsFor: 'auto connectors' stamp: 'ag 12/29/2011 12:13:08.332'!
optionallyOpenConnectors
	
	| classMorphs |
	classMorphs := self allClassMorphs.
	(self checkOpenConnectors: classMorphs) ifTrue: [
		classMorphs size = 1
			ifTrue: [ self openAssociations; openAncestors ]
			ifFalse: [
				self
					openInheritenceConnectionsWithAll: classMorphs;
					openAssociationConnectionsWithAll: classMorphs ] ].! !

!SClassMorph methodsFor: 'actions' stamp: 'ag 3/30/2012 11:16:31.826'!
pinAllVariables
	
	| klass |
	klass := self visualizedClass theNonMetaClass.
	klass allInstVarNames do: [ :varName | self pinVariable: klass -> varName asSymbol ].
	klass := klass theMetaClass.
	klass allInstVarNames do: [ :varName | self pinVariable: klass -> varName asSymbol ].! !

!SClassMorph methodsFor: 'actions' stamp: 'ag 3/8/2012 13:13:47.14'!
pinMethod: association
	"class -> selector"
	
	(self methodMorphFor: association) ifNotNilDo: #pin.! !

!SClassMorph methodsFor: 'loading/saving' stamp: 'tfel 6/5/2012 15:10:40.249'!
pinMethods: methodSpecs

	methodSpecs do: [:spec | self pinMethod: spec].! !

!SClassMorph methodsFor: 'actions' stamp: 'ag 3/30/2012 11:34:47.604'!
pinVariable: association
	"class -> symbol (name of variable, class to support instance- and class-side variables)"
	
	(self variableMorphFor: association) ifNotNilDo: #pin.! !

!SClassMorph methodsFor: 'loading/saving' stamp: 'tfel 6/5/2012 15:10:55.913'!
pinVariables: varSpecs

	varSpecs do: [:spec | self pinVariable: spec].! !

!SClassMorph methodsFor: 'loading/saving' stamp: 'tfel 6/5/2012 19:03:44.771'!
pinnedMethodSpecs

	^ self allMorphs
		select: [:m | ((m respondsTo: #isPinned) and: [m isPinned])
					and: [m isKindOf: SMethodMorph]]
		thenCollect: [:m | m klass -> m methodName]! !

!SClassMorph methodsFor: 'loading/saving' stamp: 'tfel 6/5/2012 18:52:04.645'!
pinnedVariableSpecs

	^ self allMorphs
		select: [:m | ((m respondsTo: #isPinned) and: [m isPinned])
					and: [m isKindOf: SInstVarMorph]]
		thenCollect: [:m | m klass -> m variableName]! !

!SClassMorph methodsFor: 'printing' stamp: 'ag 12/29/2011 11:02:08.668'!
printOn: stream
	
	super printOn: stream.
	stream
		nextPut: $<;
		nextPutAll: klass name;
		nextPut: $>.! !

!SClassMorph methodsFor: 'highlighting' stamp: 'ag 9/22/2011 20:47:48.914'!
removeHighlight
	"No self changed here."
	
	highlightColor := nil.
	self changed.! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:26:28.475'!
repulsionFrom: otherMorph  
	"repulsion-force = repulsion-constant * mass1 * mass2 / distance squared"
	"This value is multiplied with the direction to get the vector."
	
	| vector |
	vector := self vectorTo: otherMorph.
	^ vector normalized
		* (SClassDiagram repulsionConstant
		* otherMorph mass
		* self mass
		/ vector r squared)! !

!SClassMorph methodsFor: 'loading/saving' stamp: 'tfel 7/5/2012 14:48:49.279'!
saveToCodeFor: aDiagramParameterName
	| code storedProperties compilationClass type morphClass |
	storedProperties := (SStoreVisitor store: self)
							ifNil: [self error]
							ifNotNilDo: [:s | s storeString].
	klass isBehavior
		ifTrue: [compilationClass := klass theMetaClass.
				morphClass := SClassMorph]
		ifFalse: [compilationClass := klass typeOfContainer.
				morphClass := SContainerClassMorph].
	type := klass storeString.
	code := self class saveToCodeTemplate
				format: {aDiagramParameterName. morphClass. type. storedProperties}.
	^ code! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 12/29/2011 10:42:07.836'!
showLabels: showLabels
	"Pass the message to nestes class-morphs / implementation-morphs / classname-morphs."
	
	self classDiagramSubmorphs do: [ :each | each showLabels: showLabels ].! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 3/8/2012 12:32:00.301'!
superclassMorphIn: collectionOfMorphs
	"Find the morph in collectionOfMorphs, that represents the best match for a superclass-connection for the receiver.
	If no such morph can be found, return nil."
	
	| currentSuperclass |
	currentSuperclass := self visualizedClass.
	^ [ currentSuperclass := currentSuperclass superclass ]
		whileNotNil: [
			"Go up the inheritence chain to the first class, that is represented by at least one morph in the diagram."
			(collectionOfMorphs select: [ :morph |
				morph visualizedClass == currentSuperclass ])
					ifNotEmptyDo: [ :superclassMorphs |
						^ superclassMorphs ifNotEmpty: [ self nearestMorphIn: superclassMorphs ] ] ]! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 5/23/2012 11:06:29.48'!
toolbarButtons
	"label, selector, position, condition"
	
	^ super toolbarButtons, #(
		(#arrowStop090Icon #openAncestors #top #toolbarButtonAlwaysEnabled)
		(#arrowCurveIcon #openAssociations #right #toolbarButtonAlwaysEnabled)
		(#arrowSwitch270Icon #openSubClass #bottom #toolbarButtonAlwaysEnabled "#hasSubclasses")
		(#layersStackIcon #browseClassHierarchy #top #toolbarButtonAlwaysEnabled)
		(#balloonBuzzLeftIcon #changeColor #top #toolbarButtonAlwaysEnabled)
		(#stickyNoteIcon #addClassCommentAsNote #right #toolbarButtonAlwaysEnabled)
		(#stickyNotePlusIcon #addNote #right #toolbarButtonAlwaysEnabled)
	)! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 11/11/2011 11:55:51.165'!
totalAttractionForce
	
	| totalForce |
	totalForce := 0@0.
	self connections
		reject: [ :connection | false ]
		thenDo: [ :connection |
			totalForce := totalForce + (self attractionFrom: connection) ].
	^ totalForce! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 18:56:21.15'!
totalForceFrom: otherMorphs
	"Calculate the force on morph, based on other morphs repulsing it and connections attracting it."
	
	^ (self totalRepulsionForceFrom: (otherMorphs copyWithout: self))
		+ self totalAttractionForce! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 18:04:00.175'!
totalRepulsionForceFrom: otherMorphs  
	
	^ otherMorphs
		inject: 0@0
		into: [ :totalForce :otherMorph | totalForce + (self repulsionFrom: otherMorph) ]! !

!SClassMorph methodsFor: 'toolbar' stamp: 'ag 5/23/2012 11:45:52.63'!
uniqueClassnameBasedOn: baseName
	
	| name number |
	name := baseName asSymbol.
	number := 1.
	[ Smalltalk includesKey: name ]
		whileTrue: [
			name := (baseName, number asString) asSymbol.
			number := number + 1 ].
	^ name! !

!SClassMorph methodsFor: 'accessing' stamp: 'ag 3/30/2012 11:14:08.824'!
variableMorphFor: association
	"class -> selector"
	
	^ self implementationMorph variableMorphFor: association! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 17:33:13.941'!
vector
	
	^ layoutMovementVector
		ifNil: [ layoutMovementVector := 0@0 ]! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 17:31:11.898'!
vector: aPoint
	
	layoutMovementVector := aPoint.! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:21:45.495'!
vectorTo: otherMorph
	"Pretty hacky: if receiver or otherMorph are grabbed by the hand,
	transpose their position to be inside the ClassDiagramMorph. Assumes, that the handmorph can only have one submorph."
	
	| center1 center2 result |
	center1 := self center.
	center2 := otherMorph center.
	self owner notNil & otherMorph owner notNil ifTrue: [
		self owner isHandMorph ifTrue: [ center1 := center1 - otherMorph pasteUpMorph boundsInWorld topLeft ].
		otherMorph owner isHandMorph ifTrue: [ center2 := center2 - self pasteUpMorph boundsInWorld topLeft ] ].
	result := center1 - center2.
	result = (0@0) ifTrue: [ result := 0.1 @ 0.1 ]. "Fake small vector to avoid zero-divide when calling #normalized on the result."
	^ result! !

!SClassMorph methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 17:40:50.638'!
velocity
	
	^ self vector r! !

!SClassMorph methodsFor: 'dropping/grabbing' stamp: 'ag 6/28/2012 12:24:05.433'!
wantsDroppedMorph: aMorph event: anEvent

	^ 
	((aMorph isKindOf: SClassDiagramMorph) 
		and: [ aMorph isClassMorph not ] "Reengeneering is taking place."
		and: [ aMorph wantsReengineeringInto: self ])
	or:
	((aMorph isKindOf: SFloatingCodeSnippet) and: [ aMorph wantsReengineeringInto: self ])
	or:
	((aMorph isKindOf: SClassMorph)
		and: [
			self klass = aMorph klass
			or: [ self klass = aMorph visualizedClass ] "Allow dropping container-types into the according regular types, but not vice-versa!!"
			or: [ self isSuperClassOf: aMorph ] ])! !

SClassMorph subclass: #SContainerClassMorph
	instanceVariableNames: 'embeddedClassMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SContainerClassMorph class methodsFor: 'constants' stamp: 'ag 11/11/2011 11:37:30.91'!
embeddedBorderColor
	
	^ Color lightGray lighter! !

!SContainerClassMorph class methodsFor: 'constants' stamp: 'ag 11/11/2011 11:36:25.8'!
embeddedBorderWidth
	
	^ 5! !

!SContainerClassMorph methodsFor: 'visiting' stamp: 'sp 7/5/2012 13:53:02.824'!
accept: aVisitor

	aVisitor visitContainerClass: self.
	self pasteUpMorphOrWorld allConnections
		select: [:connection | connection sourceMorph == self]
		thenDo: [:connection | aVisitor visit: connection ].! !

!SContainerClassMorph methodsFor: 'accessing' stamp: 'ag 12/27/2011 16:32:57.094'!
elementClassMorph
	
	^ embeddedClassMorph elementClassMorph! !

!SContainerClassMorph methodsFor: 'toolbar' stamp: 'ag 12/29/2011 11:04:45.105'!
inheritanceConnectorSource
	"For normal class-morphs, inheritence-connectors connect to the morph directly."
	
	^ embeddedClassMorph! !

!SContainerClassMorph methodsFor: 'initialization' stamp: 'ag 12/9/2011 14:59:12.964'!
initializeSubMorphs
	
	self 
		addMorph: (SClassNameMorph on: self klass typeOfContainer in: self);
		addMorphBack: 
			(embeddedClassMorph := (SEmbeddedClassMorph
				on: self klass typeOfElements)
				borderWidth: self class embeddedBorderWidth;
				borderColor: self class embeddedBorderColor;
				yourself).! !

SClassMorph subclass: #SEmbeddedClassMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SEmbeddedClassMorph methodsFor: 'event handling' stamp: 'ag 11/11/2011 11:39:06.818'!
mouseActions
	
	^ super mouseActions
		removeKey: #startDrag ifAbsent: [];
		yourself! !

!SEmbeddedClassMorph methodsFor: 'toolbar' stamp: 'ag 11/11/2011 11:12:48.894'!
toolbarButtons
	
	^ nil! !

!SMorphWithToolbar methodsFor: 'toolbar' stamp: 'ag 8/26/2011 16:56:24.217'!
closeToolbar
	
	toolbar ifNotNil: [ toolbar disappear ].! !

!SMorphWithToolbar methodsFor: 'submorphs-add/remove' stamp: 'ag 8/26/2011 16:56:34.755'!
delete
	
	self closeToolbar.
	super delete.! !

!SMorphWithToolbar methodsFor: 'toolbar' stamp: 'ag 8/26/2011 13:50:55.151'!
hasBeenHovered
	
	toolbar ifNotNil: [ toolbar appear ].! !

!SMorphWithToolbar methodsFor: 'toolbar' stamp: 'ag 8/19/2011 17:03:49.928'!
hasBeenUnhovered
	
	toolbar ifNotNil: [ toolbar morphUnhovered ].! !

!SMorphWithToolbar methodsFor: 'initialization' stamp: 'ag 8/19/2011 12:18:00.414'!
initialize
	
	super initialize.
	self initializeToolbar.! !

!SMorphWithToolbar methodsFor: 'initialization' stamp: 'tfel 5/22/2012 12:33:18.964'!
initializeToolbar

	| buttons |
	buttons := self toolbarButtons.
	(buttons notNil and: [ buttons notEmpty ]) ifTrue: [
		toolbar := SDiagramMorphToolbar on: self.
		buttons do: [ :each |
			toolbar addButton: ((UiFugueIcons perform: each first) asMorph)
					model: self
					action: each second
					enabled: each fourth
					edge: each third ] ].! !

!SMorphWithToolbar methodsFor: 'event handling' stamp: 'ag 8/26/2011 16:58:44.467'!
mouseActions
	
	^ super mouseActions
		at: #startDrag put: [
			self closeToolbar.
			self currentHand grabMorph: self ];
		at: #mouseEnter put: #hasBeenHovered;
		at: #mouseLeave put: #hasBeenUnhovered;
		yourself! !

!SMorphWithToolbar methodsFor: 'toolbar' stamp: 'ag 12/12/2011 11:08:16.564'!
noteNewOwner: aMorph
	
	super noteNewOwner: aMorph.
	toolbar ifNotNil: [ toolbar updateParentMorph ].! !

!SMorphWithToolbar methodsFor: 'accessing' stamp: 'ag 1/16/2012 17:05:53.091'!
resizingDragging
	
	^ resizingDragging ifNil: [ resizingDragging := false ]! !

!SMorphWithToolbar methodsFor: 'accessing' stamp: 'ag 1/16/2012 17:05:33.822'!
resizingDragging: anObject
	resizingDragging := anObject! !

!SMorphWithToolbar methodsFor: 'accessing' stamp: 'ag 1/16/2012 17:06:46.619'!
resizingRectangle
	
	^ resizingRectangle ifNil: [ resizingRectangle :=
		RectangleMorph new
			borderWidth: 2;
			borderColor: Color black;
			color: Color transparent;
			yourself ]! !

!SMorphWithToolbar methodsFor: 'accessing' stamp: 'ag 1/16/2012 17:05:34.146'!
resizingRectangle: anObject
	resizingRectangle := anObject! !

!SMorphWithToolbar methodsFor: 'toolbar' stamp: 'ag 8/19/2011 12:20:48.493'!
toolbarButtonAlwaysEnabled
	"For toolbar-buttons-specs, to specify, that a button is always there."
	
	^ true! !

!SMorphWithToolbar methodsFor: 'toolbar' stamp: 'ag 1/16/2012 17:10:44.581'!
toolbarButtons
	"A collection of collections containing symbols.
	label, selector, position, condition"
	
	^ #(
		(#crossButtonIcon #dismissViaHalo #left #toolbarButtonAlwaysEnabled)
	)! !

SMorphWithToolbar subclass: #SNoteMorph
	instanceVariableNames: 'contentText textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SNoteMorph commentStamp: 'ag 8/5/2011 15:35:33.362' prior: 0!
A SNoteMorph is a transparent morph holding an instance of NCNoteMorph.
NCNoteMorph cannot be used directly, because we want to use the halo-mechanism of SClassDiagramMorph
(inheriting from it and overriding #toolbarButtons).
!

SNoteMorph subclass: #SExclamationMark
	instanceVariableNames: 'exclamation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SExclamationMark class methodsFor: 'instance creation' stamp: 'tfel 6/26/2012 17:01:34.223'!
withText: aString from: aMorph
	| inst |
	inst := self new
		setText: aString;
		yourself.
	aMorph pasteUpMorphOrWorld addMorph: inst.
	^ inst! !

!SExclamationMark methodsFor: 'initialization' stamp: 'tfel 6/26/2012 17:04:30.08'!
initialize

	super initialize.
	klass := ProtoObject.
	exclamation := ('!!' asMorph
						font: ((StrikeFont defaultSized: 32)
								emphasis: TextEmphasis bold);
						color: Color red).
	self
		addMorph: exclamation;
		color: Color white darker;
		listDirection: #leftToRight.
	exclamation := exclamation addFlexShell.
	exclamation scale: 5.! !

!SExclamationMark methodsFor: 'testing' stamp: 'tfel 6/28/2012 13:58:30.385'!
isError

	^ true! !

!SNoteMorph methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:25:22.444'!
accept: aVisitor

	aVisitor visitNote: self.! !

!SNoteMorph methodsFor: 'accessing' stamp: 'ag 1/15/2012 22:34:20.596'!
contentText
	^ contentText! !

!SNoteMorph methodsFor: 'accessing' stamp: 'ag 1/16/2012 16:39:15.146'!
contentText: anObject
	"This does not set the displayed text!! Use setText: instead."
	
	contentText := anObject! !

!SNoteMorph methodsFor: 'drawing' stamp: 'ag 1/15/2012 22:26:21.394'!
drawOn: aCanvas
	"This method is copied from NCNoteMorph to have the yellow note-style."
	
	| triangleSize triangleCorners |
	triangleSize := 12.
	triangleCorners := { (self position + (triangleSize@0)) . (self position + (0@triangleSize)) . (self position + (triangleSize@triangleSize)) }.

	aCanvas fillRectangle: (triangleCorners first extent: ((self width - triangleSize) @ triangleSize)) color: self color.
	aCanvas fillRectangle: (triangleCorners second corner: self bottomRight) color: self color.
	aCanvas fillRectangle: (bounds origin extent: triangleSize @ triangleSize) color: Color transparent.

	aCanvas drawPolygon: triangleCorners color: self color borderWidth: 0 borderColor: self color.
	
	aCanvas isShadowDrawing ifTrue: [ ^self ].
	aCanvas drawPolygon: { triangleCorners first .
	self topRight - (self borderWidth@0).
	self bottomRight - (self borderWidth@self borderWidth).
	self bottomLeft - (0 @ self borderWidth).
	triangleCorners second } fillStyle: Color transparent borderWidth: self borderWidth borderColor: self borderColor.
! !

!SNoteMorph methodsFor: 'initialization' stamp: 'ag 1/17/2012 11:21:06.349'!
initialize
	
	super initialize.
	self
		color: (Color r: 0.972 g: 0.972 b: 0.5);
		layoutPolicy: TableLayout new;
		layoutInset: 10;
		borderWidth: 1;
		borderColor: Color black;
		listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		initializeTextMorph;
		addMorph: textMorph.! !

!SNoteMorph methodsFor: 'initialization' stamp: 'ag 1/16/2012 16:42:07.288'!
initializeTextMorph
	
	textMorph := (PluggableTextMorph new
		on: self
		text: #contentText
		accept: #contentText:
		readSelection: nil
		menu: nil)
		font: Preferences standardCodeFont;
		borderColor: Color lightGray;
		borderWidth: 1;
		color: Color transparent;
		hShowScrollBar;
		yourself.! !

!SNoteMorph methodsFor: 'text' stamp: 'ag 1/16/2012 16:41:29.034'!
setText: aString
	
	contentText := aString.
	textMorph setText: textMorph getText.
	self changed: #contentText.! !

SMorphWithToolbar subclass: #SStickySourceCodeMorph
	instanceVariableNames: 'sourceCodeMorph lines partner syntaxHighlightingLocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SStickySourceCodeMorph class methodsFor: 'instance creation' stamp: 'ag 8/26/2011 16:33:55.844'!
on: aSelector in: aClass
	
	^ self new
		initializeWith: aSelector in: aClass;
		yourself! !

!SStickySourceCodeMorph methodsFor: 'visiting' stamp: 'tfel 6/12/2012 12:25:26.598'!
accept: aVisitor

	aVisitor visitStickySourceCode: self.! !

!SStickySourceCodeMorph methodsFor: 'connections' stamp: 'ag 9/22/2011 18:58:35.627'!
attachConstraint: aConstraint to: aMorph at: aDirection
	
	| targets |
	targets := Dictionary newFrom: {
		#top -> [:m | m topCenter ] .
		#bottom -> [:m | m bottomCenter]
	}.
	aConstraint attachTo: aMorph at: ((targets at: aDirection) value: aMorph).! !

!SStickySourceCodeMorph methodsFor: 'accessing' stamp: 'ag 3/30/2012 12:02:08.628'!
color: aColor
	
	super color: aColor.
	sourceCodeMorph color: aColor.! !

!SStickySourceCodeMorph methodsFor: 'connections' stamp: 'ag 12/26/2011 14:11:56.086'!
connectTo: aMethodMorph
	
	partner := aMethodMorph.
	lines ifNotNil: [ lines do: #abandon ].
	lines := OrderedCollection
		with: (
			(SNoteConnector openFor: partner connectedTo: self)
				constraints
					with: { self. partner classMorph }
					do: [ :c :m | self attachConstraint: c to: m at: #top ]).! !

!SStickySourceCodeMorph methodsFor: 'toolbar' stamp: 'ag 3/30/2012 11:53:50.98'!
ensureLockSyntaxHighlighting
	
	syntaxHighlightingLocked
		ifFalse: [ self toggleLockSyntaxHighlighting ].! !

!SStickySourceCodeMorph methodsFor: 'toolbar' stamp: 'ag 1/15/2012 21:59:56.961'!
hasBeenHovered
	
	super hasBeenHovered.
	syntaxHighlightingLocked ifFalse: [ sourceCodeMorph enableSyntaxHighlighting ].! !

!SStickySourceCodeMorph methodsFor: 'toolbar' stamp: 'ag 1/15/2012 22:00:04.252'!
hasBeenUnhovered
	
	super hasBeenUnhovered.
	syntaxHighlightingLocked ifFalse: [ sourceCodeMorph disableSyntaxHighlighting ].! !

!SStickySourceCodeMorph methodsFor: 'initialization' stamp: 'ag 3/30/2012 12:08:51.939'!
initializeWith: aSelector in: aClass
	
	sourceCodeMorph := SSourceCodeMorph on: aSelector in: aClass.
	syntaxHighlightingLocked := false.
	super color: Color transparent. "Use super to avoid setting the color of sourceCodeMorph."
	self
		ensureLockSyntaxHighlighting; "Enable by default."
		addMorphFront: sourceCodeMorph;
		extent: sourceCodeMorph extent.! !

!SStickySourceCodeMorph methodsFor: 'accessing' stamp: 'tfel 6/12/2012 13:28:21.125'!
partner

	^ partner! !

!SStickySourceCodeMorph methodsFor: 'toolbar' stamp: 'ag 1/15/2012 21:59:33.387'!
toggleLockSyntaxHighlighting
	
	syntaxHighlightingLocked := syntaxHighlightingLocked not.
	syntaxHighlightingLocked
		ifTrue: [ sourceCodeMorph enableSyntaxHighlighting ]
		ifFalse: [ sourceCodeMorph disableSyntaxHighlighting ]! !

!SStickySourceCodeMorph methodsFor: 'toolbar' stamp: 'ag 1/16/2012 17:03:28.57'!
toolbarButtons
	
	^ super toolbarButtons, #(
		(#asteriskYellowIcon #toggleLockSyntaxHighlighting #top #toolbarButtonAlwaysEnabled)
	)! !

RectangleMorph subclass: #SDebugRectangleMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-GraphLayout'!

!SDebugRectangleMorph commentStamp: 'ag 2/23/2012 23:05:20.743' prior: 0!
Just a tagging subclass to remove all these debug-rectangles from the diagram-area.!

RectangleMorph subclass: #SDirtyFrame
	instanceVariableNames: 'classDiagram'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SDirtyFrame class methodsFor: 'instance creation' stamp: 'tfel 7/4/2011 10:14:22.957'!
new

	self error: 'Use #on:'! !

!SDirtyFrame class methodsFor: 'instance creation' stamp: 'tfel 7/4/2011 10:14:59.237'!
on: aClassDiagram

	^ self basicNew
		classDiagram: aClassDiagram;
		initialize;
		yourself! !

!SDirtyFrame methodsFor: 'accessing' stamp: 'tfel 7/4/2011 10:15:32.531'!
classDiagram: aMorph

	classDiagram := aMorph.! !

!SDirtyFrame methodsFor: 'initialization' stamp: 'tfel 7/4/2011 10:20:59.81'!
initialize

	super initialize.
	classDiagram addDependent: self.
	self
		color: Color transparent;
		borderColor: Color red;
		hide.! !

!SDirtyFrame methodsFor: 'updating' stamp: 'tfel 7/4/2011 10:34:05.188'!
update: action

	(#(isDirty) includes: action) ifTrue: [
		classDiagram isDirty ifTrue: [self show] ifFalse: [self hide]].
! !

RectangleMorph subclass: #SSourceCodeMorph
	instanceVariableNames: 'klass selector definitionPanel model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SSourceCodeMorph class methodsFor: 'constants' stamp: 'ag 8/26/2011 14:06:26.593'!
defaultExtent

	^ 400@200! !

!SSourceCodeMorph class methodsFor: 'constants' stamp: 'ag 8/26/2011 14:06:43.912'!
layoutInset

	^ 8! !

!SSourceCodeMorph class methodsFor: 'instance creation' stamp: 'ag 8/26/2011 14:03:27.463'!
on: aSelector in: aClass

	^ self basicNew
		selector: aSelector asSymbol;
		klass: aClass;
		initialize;
		yourself
		! !

!SSourceCodeMorph methodsFor: 'accessing' stamp: 'ag 6/28/2012 12:02:09.169'!
codeSelection
	
	^ definitionPanel textMorph selection! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 8/26/2011 14:03:27.424'!
disableSyntaxHighlighting

	definitionPanel styler: nil.
	definitionPanel setText: definitionPanel getText! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 8/26/2011 14:04:40.405'!
enableSyntaxHighlighting
	
	definitionPanel useDefaultStyler.
	definitionPanel setText: definitionPanel getText.! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 6/28/2012 14:48:00.901'!
handleMouseDown: evt
	"Shift pressed, we have a selection, and started dragging the selected code part.
	Create a morph showing the grabbed code, attach it to the hand."
	
	(SFloatingCodeSnippet
		inHand: evt hand
		forText: self codeSelection)
		originalMethod: klass -> selector;
		selectionInterval: definitionPanel textMorph editor selectionInterval.
	evt wasHandled: true.! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 6/28/2012 15:34:04.967'!
handlesMouseDown: evt
	"We handle the mouse-event only, if it is the start of a reengeneering drag'n'drop.
	Shift has to be pressed, and the click has to be inside an existing selection.
	We set the event as handled, to prevent the TextMorph to change the selection."
	
	^ evt shiftPressed
		and: [ self codeSelection notNil ]
		and: [ self codeSelection size > 0 ]
		and: [ "Check, whether the click was inside the selected part of the code."
			definitionPanel textMorph editor paragraph selectionRects
				anySatisfy: [ :each |
					each containsPoint:
						(definitionPanel textMorph globalPointToLocal: evt hand position) ] ]
		and: [ evt wasHandled: true. true ]! !

!SSourceCodeMorph methodsFor: 'initialization' stamp: 'ag 6/18/2012 11:43:33.791'!
initialize
	
	| font extent |
	super initialize.
	font := Preferences standardCodeFont.
	extent := self class defaultExtent x @
				(self class defaultExtent y 
				min: (font pointSize * 2 * 
					(MethodReference class: klass selector: selector) sourceCode lineCount + 20)).
	self
		color: Color gray;
		extent: extent;
		layoutPolicy: TableLayout new;
		layoutInset: self class layoutInset;
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		initializeCodeHolder: font extent: extent;
		initializeSystemChangeListening.! !

!SSourceCodeMorph methodsFor: 'initialization' stamp: 'ag 6/18/2012 11:34:02.045'!
initializeCodeHolder: aFont extent: aPoint
	
	model := SDefinitionModel new.
	model setClass: klass andSelector: selector asSymbol.
	definitionPanel := SPluggableTextMorphPlus new.
	definitionPanel useDefaultStyler.
	definitionPanel 
		on: model 
		text: #contents 
		accept: #contents:
		readSelection: nil 
		menu: nil.
	definitionPanel 
		font: aFont;
		getColorSelector: nil;
		borderColor: Color lightGray;
		borderWidth: 1;
		color: Color white;
		extent: (aPoint - (self class layoutInset * 2)).
	self addMorphFront: definitionPanel.
	definitionPanel textMorph addDependent: self. "To receive #update:with:"! !

!SSourceCodeMorph methodsFor: 'initialization' stamp: 'ag 6/18/2012 11:43:54.81'!
initializeSystemChangeListening
	
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfChange: #Modified
		using: #updateMethod:.! !

!SSourceCodeMorph methodsFor: 'accessing' stamp: 'ag 8/26/2011 14:05:47.985'!
klass
	^ klass! !

!SSourceCodeMorph methodsFor: 'accessing' stamp: 'ag 8/26/2011 14:05:47.997'!
klass: anObject
	klass := anObject! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:33:03.465'!
methodTypesLabelFor: aWord
	"Method copied from SBrowser, with slight changes. Need refactoring, see implementors."
	
	| method temps index type |
	self flag: #ag. self flag: #mpe.
	(SProject current allClasses includes: self klass instanceSide)
		ifTrue: [
			method := self klass >> self selector.
			temps := method methodNode arguments, method methodNode temporaries.
			temps ifNotEmpty: [
				temps := temps collect: [:each | each name].
				index := temps indexOf: aWord.
				index = 0
					ifFalse: [SProject current typesBucket 
								ifNil: [^ 'Run type harvester first'].
						type := (SProject current typesBucket 
									tempTypeAt: index in: method).
						type 
							ifNil: [^ 'No type available']
							ifNotNil: [^ type asString]]].
			(self selector asString beginsWith: aWord)
				ifTrue: [SProject current typesBucket 
							ifNil: [^ 'Run type harvester first'].
					type := (SProject current typesBucket 
								returnTypeFor: method).
					type 
						ifNil: [^ '^ No type available']
						ifNotNil: [^ '^ ', type asString]]].
	^ ''! !

!SSourceCodeMorph methodsFor: 'accessing' stamp: 'ag 8/26/2011 14:03:27.438'!
selector
	^ selector! !

!SSourceCodeMorph methodsFor: 'accessing' stamp: 'ag 8/26/2011 14:03:27.443'!
selector: anObject
	selector := anObject! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:32:51.341'!
update: aWord with: aTextMorph
	"This is originally copied from SBrowser, with parts removed/flattened. The main redundant part is copied in #methodTypesLabelFor:.
	 Want to enable the feature to show types of local variables, arguments, etc also to the code-boxes in the path-view.
	The code-boxes are already of type SPluggableTextMorphPlus, we only need to add this part of the mechanism."
	
	aTextMorph labelMorph createLabelMorph: (self methodTypesLabelFor: aWord).! !

!SSourceCodeMorph methodsFor: 'event handling' stamp: 'ag 6/18/2012 11:48:52.615'!
updateMethod: event
	
	event itemSelector = self selector
		ifTrue: [ model changed: #contents ].! !

NCAAConnectorMorph subclass: #SConnector
	instanceVariableNames: 'sourceMorph targetMorph toolbar label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

SConnector subclass: #SAssociationConnector
	instanceVariableNames: 'variableName variableType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

!SAssociationConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:14:42.527'!
arrowTypes
	
	^ { #simpleXArrow . #basicArrow1 }! !

!SAssociationConnector class methodsFor: 'instance creation' stamp: 'ag 7/5/2012 11:25:16.754'!
existingConnectorFrom: source to: target variableName: aString
	
	^ super
		existingConnectorFrom: source
		to: target
		satisfying: [ :connector | connector variableName = aString ]! !

!SAssociationConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:14:28.724'!
instanceName
	
	^ 'Association'! !

!SAssociationConnector class methodsFor: 'instance creation' stamp: 'tfel 7/5/2012 13:50:54.422'!
openFor: sourceMorph connectedTo: targetMorph variableName: aString variableType: aSymbol
	
	^ (self existingConnectorFrom: sourceMorph to: targetMorph variableName: aString)
		ifNil: [
			(self pvtCreateFor: sourceMorph to: targetMorph)
				variableName: aString;
				variableType: aSymbol;
				addRoleLabel ]! !

!SAssociationConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:00:25.329'!
simpleXArrow
	| x1 x2 x3 x4 |
	x1 := self xElement.
	x2 := x1 * (1@ -1).
	x3 := x1 * (-1@ -1).
	x4 := x1 * (-1@1).
	
^(NCLineArrowGlyph withContours: ((Array new: 4) at: 1 put: x1; at: 2 put: x2; at: 3 put: x3; at: 4 put: x4; yourself)) 
	offset: 0@0.6;
	defaultScale: 3.0;
	yourself! !

!SAssociationConnector class methodsFor: 'arrows' stamp: 'fb 5/19/2011 13:58:45.548'!
xElement
	^ { 0.1@0.0 . 
	0.1@ 0.0 . -0.4@ -0.5 . -0.4@ -0.5 .  
	-0.5@ -0.4 . -0.5@ -0.4 . -0.5@ -0.4 .  
	0.0@0.1 . 0.0@0.1 . 0.0@0.1 .  
	0.1@0.0 . 0.1@0.0
	 }.! !

!SAssociationConnector methodsFor: 'visiting' stamp: 'tfel 6/12/2012 14:53:50.981'!
accept: aVisitor

	aVisitor visitAssociationConnection: self.! !

!SAssociationConnector methodsFor: 'updating' stamp: 'ag 4/18/2012 16:19:31.616'!
addRoleLabel
	
	| targetClass |
	targetClass :=
		(SClassMorph memberTypeFor: self variableName in: sourceMorph visualizedClass)
			ifNil: [ self targetMorph visualizedClass ].
	(self labelClass
		openOn: self
		targetingClass: targetClass)
		initializeString: (self roleLabelString: targetClass).! !

!SAssociationConnector methodsFor: 'updating' stamp: 'ag 12/27/2011 11:24:59.763'!
isConsistent
	
	^ super isConsistent
		and: [ self sourceMorph visualizedClass allInstVarNames includes: self variableName ]! !

!SAssociationConnector methodsFor: 'updating' stamp: 'ag 7/5/2012 11:32:39.187'!
isDuplicateOf: connector
	"These criteria are duplicated on the class-side, in
	existingConnectorFrom: to: variableName: . Don't see a way to merge these two versions."
	
	^ (super isDuplicateOf: connector) and: [ self variableName = connector variableName ]! !

!SAssociationConnector methodsFor: 'updating' stamp: 'tfel 6/26/2012 18:33:10.153'!
isValid
	
	^ ((sourceMorph klass instVarNames includes: variableName)
		or: [ targetMorph klass instVarNames includes: variableName ])! !

!SAssociationConnector methodsFor: 'connectors-labels' stamp: 'ag 12/26/2011 13:19:47.005'!
labelClass
	
	^ SAssociationLabelMorph! !

!SAssociationConnector methodsFor: 'connectors-labels' stamp: 'ag 11/11/2011 11:38:07.498'!
roleLabelString: aClass
	
	| parts result |
	parts := OrderedCollection with: self variableName.
	aClass isBehavior
			ifTrue: [ parts add: '[0..1]' ]
			ifFalse: [
				parts add: (aClass typeOfContainer = Association ifTrue: '[0..1]' ifFalse: '[0..*]').
				aClass typeOfKeys ifNotNilDo: [ :keyClass | parts add: '<', keyClass, '>' ] ].
	result := ''.
	parts
		do: [ :part | result := result, part ]
		separatedBy: [ result := result, (result size > 15 ifTrue: [ '\' ] ifFalse: [ ' ' ]) ].
	^ result withCRs! !

!SAssociationConnector methodsFor: 'updating' stamp: 'ag 12/26/2011 15:17:37.228'!
update
	
	((sourceMorph klass instVarNames includes: variableName)
		or: [ targetMorph klass instVarNames includes: variableName ])
			ifFalse: [ self color: Color red ].! !

!SAssociationConnector methodsFor: 'accessing' stamp: 'ag 12/26/2011 15:17:37.225'!
variableName
	
	^ variableName ifNil: [ sourceMorph variableName ]! !

!SAssociationConnector methodsFor: 'accessing' stamp: 'tfel 7/12/2011 14:31:32.905'!
variableName: aString

	variableName := aString! !

!SAssociationConnector methodsFor: 'accessing' stamp: 'tfel 7/5/2012 13:51:24.069'!
variableType
	"Answer the value of variableType"

	^ variableType! !

!SAssociationConnector methodsFor: 'accessing' stamp: 'tfel 7/5/2012 13:51:24.078'!
variableType: anObject
	"Set the value of variableType"

	variableType := anObject! !

!SConnector class methodsFor: 'instance creation' stamp: 'ag 12/26/2011 15:39:19.398'!
allClassMorphsFrom: source or: target
	
	^ ((source ownerThatIsA: SClassDiagram) ifNil: [ target ownerThatIsA: SClassDiagram ])
		ifNotNilDo: #classMorphs
		ifNil: [ #() ]! !

!SConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:16:28.066'!
arrowTypes
	
	self subclassResponsibility! !

!SConnector class methodsFor: 'instance creation' stamp: 'ag 7/5/2012 11:25:42.158'!
existingConnectorFrom: source to: target
	
	^ self existingConnectorFrom: source to: target satisfying: [ :connector | true ]! !

!SConnector class methodsFor: 'instance creation' stamp: 'ag 7/5/2012 11:28:21.941'!
existingConnectorFrom: source to: target satisfying: aBlock
	"Ugly access to all classMorphs in the current diagram, see comment in #openFor:connectedTo:.
	aBlock can be used to inject additional conitions, which might be necessary for certain subclasses."
	
	(self allClassMorphsFrom: source or: target)
		do: [ :classMorph |
			(classMorph connections
				detect: [ :each |
					each class = self
					and: [ each sourceMorph == source ]
					and: [ each targetMorph == target ]
					and: [ aBlock value: each ] ]
				ifNone: [ "continue searching" ])
				ifNotNilDo: [ :found | ^ found ] "Only one of this kind should exist, this mechanism should ensure this." ].
	^ nil! !

!SConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:07:11.451'!
initializeArrowDictionary
	
	super initializeArrowDictionary.
	self allSubclasses do: [ :cl | (cl class organization listAtCategoryNamed: 'arrows') do: [ :sym |
		(sym endsWith: #Arrow)
			ifTrue: [ ArrowGlyphs at: sym put: (cl perform: sym) ] ] ].! !

!SConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:16:33.356'!
instanceName
	
	self subclassResponsibility! !

!SConnector class methodsFor: 'instance creation' stamp: 'ag 7/5/2012 11:24:41.124'!
openFor: anEntryOrClassMorph connectedTo: aMorph
	"Centrally and generically avoid creating doubled connectors. Not the best programming style, but connectors
	are created throughout the system and it would be hard to do that in a controlled fashion."
	
	^ (self existingConnectorFrom: anEntryOrClassMorph to: aMorph)
		ifNil: [ self pvtCreateFor: anEntryOrClassMorph to: aMorph ]! !

!SConnector class methodsFor: 'instance creation' stamp: 'ag 6/4/2012 16:44:33.903'!
pvtCreateFor: source to: target
	
	^ self basicNew
		sourceMorph: source;
		targetMorph: target;
		initialize;
		yourself! !

!SConnector methodsFor: 'visiting' stamp: 'tfel 6/12/2012 14:52:36.012'!
accept: aVisitor

	self subclassResponsibility.! !

!SConnector methodsFor: 'menus' stamp: 'fb 4/28/2011 14:18:22.869'!
addBasicArrowMenuItemsTo: aMenu event: evt
	"do nothing, user shall not be able to change the arrow behavior by default"
! !

!SConnector methodsFor: 'event handling' stamp: 'ag 6/4/2012 13:04:41.086'!
allowsDetachmentOfConstraint: constraint

	^ false! !

!SConnector methodsFor: 'accessing' stamp: 'ag 6/4/2012 16:15:27.464'!
attachToNewTarget: aMorph
	"This is not a simple accessor, but does all necessary work to attach to a new target-morph."
	
	^ self fromMorph: sourceMorph toMorph: aMorph! !

!SConnector methodsFor: 'toolbar' stamp: 'ag 9/7/2011 12:14:09.673'!
closeToolbar
	
	toolbar ifNotNil: [ toolbar disappear ].! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/26/2011 17:20:13.391'!
connectFinishTo: newTarget
	
	targetMorph := newTarget.
	^ self
		existingDuplicateOrSelfFrom: sourceMorph
		ifSelf: [ super connectFinishTo: newTarget ]! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/26/2011 17:20:49.973'!
connectStartTo: newStart
	
	sourceMorph := newStart.
	^ self
		existingDuplicateOrSelfFrom: targetMorph
		ifSelf: [ super connectStartTo: newStart ]! !

!SConnector methodsFor: 'initialization' stamp: 'ag 7/2/2012 14:56:37.774'!
defaultColor
	
	^ Color black! !

!SConnector methodsFor: 'submorphs-add/remove' stamp: 'ag 10/12/2011 15:41:34.577'!
delete
	
	label ifNotNil: [ label delete ].
	self closeToolbar.
	super delete.! !

!SConnector methodsFor: 'accessing' stamp: 'ag 12/29/2011 12:26:15.813'!
diagramParent
	
	^ self ownerThatIsA: SClassDiagram! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/26/2011 17:15:17.164'!
existingDuplicateIn: connectors
	
	^ connectors
		detect: [ :each | (each == self) not and: [ each isDuplicateOf: self ] ]
		ifNone: [ nil ]! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/26/2011 17:20:26.605'!
existingDuplicateOrSelfFrom: aMorph ifSelf: aBlock
	"Ensure only the duplicate or receiver exists. Abandon receiver, if necessary, return leftover connector."
	
	^ (self existingDuplicateIn: aMorph connections)
		ifNil: [ aBlock value. self ]
		ifNotNilDo: [ :duplicate |
			self abandon.
			duplicate ]! !

!SConnector methodsFor: 'initialization' stamp: 'ag 6/5/2012 15:33:17.156'!
fromMorph: fromMorph toMorph: toMorph
	
	sourceMorph := fromMorph.
	targetMorph := toMorph.
	^ super fromMorph: fromMorph toMorph: toMorph! !

!SConnector methodsFor: 'accessing' stamp: 'ag 6/4/2012 16:33:18.658'!
graphSourceMorph
	
	^ sourceMorph classMorph! !

!SConnector methodsFor: 'accessing' stamp: 'ag 6/4/2012 16:33:29.739'!
graphTargetMorph
	
	^ targetMorph classMorph! !

!SConnector methodsFor: 'initialization' stamp: 'ag 7/2/2012 15:22:08.807'!
initialize
	
	super initialize.
	self
		initializeToolbar;
		beSmoothCurve;
		arrowNames: self class arrowTypes;
		name: self class instanceName;
		fromMorph: sourceMorph toMorph: targetMorph. "This redundantly sets the two fields again."! !

!SConnector methodsFor: 'initialization' stamp: 'tfel 5/22/2012 12:33:41.19'!
initializeToolbar

	| buttons |
	buttons := self toolbarButtons.
	(buttons notNil and: [ buttons notEmpty ]) ifTrue: [
		toolbar := SDiagramMorphToolbar on: self.
		buttons do: [ :each |
			toolbar addButton: ((UiFugueIcons perform: each first) asMorph)
					model: self
					action: each second
					enabled: each fourth
					edge: each third  ] ].! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/27/2011 11:27:36.864'!
isConsistent
	
	^ (self sourceMorph == self targetMorph) not! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/26/2011 17:07:37.744'!
isDuplicateOf: connector
	"These criteria are duplicated on the class side in existingConnectorFrom:to:.
	Dont see a possibility to merge this."
	
	^ connector class = self class & 
		(self sourceMorph == connector sourceMorph) & 
		(self targetMorph == connector targetMorph)! !

!SConnector methodsFor: 'testing' stamp: 'tfel 6/28/2012 13:55:26.366'!
isError

	^ false! !

!SConnector methodsFor: 'validation' stamp: 'tfel 6/26/2012 18:30:41.483'!
isValid

	^ true! !

!SConnector methodsFor: 'structure' stamp: 'tfel 5/20/2011 11:48:45.243'!
jumpToWorld
	"Ignore"! !

!SConnector methodsFor: 'accessing' stamp: 'ag 10/12/2011 15:41:51.364'!
label: aLabel
	
	label := aLabel.! !

!SConnector methodsFor: 'connectors-labels' stamp: 'ag 12/26/2011 13:19:52.12'!
labelClass
	
	^ SSmartLabelMorph! !

!SConnector methodsFor: 'updating' stamp: 'ag 12/27/2011 11:19:35.207'!
mergeFrom: old to: new
	"This strongly assumes that either source or target morph of receiver is the old parameter!!"
	
	((self sourceMorph = old)
		ifTrue: [ self connectStartTo: new ]
		ifFalse: [ self connectFinishTo: new ])
		ifNotNilDo: [ :newConnector |
			newConnector == self
				ifTrue: [ self restoreConsistency ]
				ifFalse: [ self abandon ] ]! !

!SConnector methodsFor: 'event handling-overrides' stamp: 'ag 9/8/2011 14:03:14.871'!
mouseDownInConnected: anEvent
	"Connectors-library has some kind of own event-handling-mechanism. Most normal morphic-events don't work,
	must catch this special event.
	The normal mouseLeave: does work though."
	
	toolbar ifNotNil: [ toolbar appear ].
	super mouseDownInConnected: anEvent.  ! !

!SConnector methodsFor: 'event handling-overrides' stamp: 'ag 6/4/2012 13:02:37.888'!
mouseLeave: anEvent
	
	toolbar ifNotNil: [ toolbar morphUnhovered ].
	super mouseLeave: anEvent.! !

!SConnector methodsFor: 'accessing' stamp: 'ag 9/9/2011 12:07:57.001'!
noteNewOwner: aMorph
	
	super noteNewOwner: aMorph.
	toolbar ifNotNil: [ toolbar updateParentMorph ].! !

!SConnector methodsFor: 'updating' stamp: 'ag 1/4/2012 09:17:21.105'!
restoreConsistency
	"Return true, if any action has been taken to restore consistency. For subclass-overrides to know if anything else has to be done."
	
	| result |
	result := self isConsistent not.
	result ifTrue: [ self abandon ].
	^ result! !

!SConnector methodsFor: 'protected-policy' stamp: 'mp 3/20/2013 11:45:40.504'!
setCorrectOwnerForConnections: connections
	"Try to fix adding the receiver to the wrong owner. Would occur when the FIRST morph in connections
	has no owner -- the receiver would be added to the world, instead of the owner of the SECOND morph."
	
	super setCorrectOwnerForConnections:
		((connections select: [ :each | each owner class == SClassDiagram ]) ifEmpty: [ connections ]).! !

!SConnector methodsFor: 'accessing' stamp: 'ag 12/26/2011 15:17:37.238'!
sourceClass

	^ sourceMorph classMorph klass
! !

!SConnector methodsFor: 'accessing' stamp: 'ag 12/26/2011 15:20:53.861'!
sourceMorph
	
	^ sourceMorph ! !

!SConnector methodsFor: 'accessing' stamp: 'ag 12/26/2011 15:21:08.066'!
sourceMorph: anObject

	sourceMorph := anObject! !

!SConnector methodsFor: 'event handling-overrides' stamp: 'ag 6/4/2012 13:02:45.978'!
startDrag: anEvent
	
	self closeToolbar.
	super startDrag: anEvent.! !

!SConnector methodsFor: 'stepping and presenter' stamp: 'ag 7/2/2012 14:57:10.793'!
step
	
	self constraints do: [:each | each hasAnyInputs ifFalse: [ ^ self delete ]].
	self isValid
		ifTrue: [self color = self defaultColor ifFalse: [self color: self defaultColor]]
		ifFalse: [self color = Color red ifFalse: [self color: Color red]]! !

!SConnector methodsFor: 'stepping and presenter' stamp: 'ag 7/2/2012 16:29:00.865'!
stepTime
	"Use a long step-time, because some computation is happening in the step-method,
	especially in the step-method of the SInheritanceConnector."
	
	^ 1500! !

!SConnector methodsFor: 'accessing' stamp: 'ag 9/22/2011 14:19:04.655'!
targetClass

	^ targetMorph classMorph klass
! !

!SConnector methodsFor: 'accessing' stamp: 'ag 6/4/2012 16:30:37.567'!
targetClassmorph
	
	^ targetMorph classMorph! !

!SConnector methodsFor: 'accessing' stamp: 'fb 6/14/2011 14:31:02.31'!
targetMorph

	^ targetMorph ! !

!SConnector methodsFor: 'accessing' stamp: 'fb 5/10/2011 13:50:46.203'!
targetMorph: anObject
	targetMorph := anObject! !

!SConnector methodsFor: 'toolbar' stamp: 'ag 9/7/2011 12:14:09.783'!
toolbarButtonAlwaysEnabled
	"For toolbar-buttons-specs, to specify, that a button is always there."
	
	^ true! !

!SConnector methodsFor: 'toolbar' stamp: 'ag 9/7/2011 12:14:28.052'!
toolbarButtons
	"A collection of collections containing symbols.
	label, selector, position, condition"
	
	^#(
		(#crossButtonIcon #dismissViaHalo #left #toolbarButtonAlwaysEnabled)
	).! !

!SConnector methodsFor: 'updating' stamp: 'tfel 7/19/2011 14:22:09.958'!
update
	"Stub"! !

SConnector subclass: #SInheritanceConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

!SInheritanceConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:18:35.783'!
arrowTypes
	
	^#( noArrow bigOpenArrow )! !

!SInheritanceConnector class methodsFor: 'arrows' stamp: 'fb 5/31/2011 11:37:23.732'!
bigOpenArrow
	| a |
	a := { 0.0@0.0 . 0.0@0.0 . -0.5@0.0 . 
	-0.5@0.0 . -0.5@0.0 . 0.0@ -1.0 . 
	0.0@ -1.0 . 0.0@ -1.0 . 0.5@0.0 . 
	0.5@0.0 . 0.5@0.0 . 0.0@0.0 }.
	^(NCLineArrowGlyph withContours: (
		(Array new: 2) at: 1 put: a; at: 2 put:  (a + (0.0@0.33) * 0.6 - (0.0@0.33));
		yourself
	)) offset: 0@1.0;
	defaultScale: 3.5;
	yourself! !

!SInheritanceConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:19:03.348'!
instanceName
	
	^ 'Generalization'! !

!SInheritanceConnector methodsFor: 'visiting' stamp: 'tfel 6/12/2012 14:53:42.143'!
accept: aVisitor

	aVisitor visitInheritanceConnection: self.! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'ag 6/4/2012 13:09:13.251'!
allowsDetachmentOfConstraint: constraint
	"Allow detachment of the line-end, to refactor the class-hierarchy."
	
	^ constraint == self constraints last! !

!SInheritanceConnector methodsFor: 'initialization' stamp: 'ag 7/2/2012 14:56:28.48'!
defaultColor
	
	^ self getClassesInBetween
		ifNotEmpty: [ Color gray ]
		ifEmpty: [ super defaultColor ]! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'tfel 6/26/2012 18:20:47.686'!
exitDraggingEnd
	
	| newSuperclassMorph |
	newSuperclassMorph := self hoveredClassMorph.
	newSuperclassMorph :=
		(self superclassRefactoringAllowed: newSuperclassMorph)
			ifFalse: [ targetMorph ]
			ifTrue: [ self refactorSuperclassTo: newSuperclassMorph rollbackTo: targetMorph ].
	
	"The refactoring will happen asynchronously. Meanwhile, keep the arrow attached to the new selected super-class."
	newSuperclassMorph
		ifNil: [ self abandon ]
		ifNotNil: [ self attachToNewTarget: newSuperclassMorph ].
	super exitDraggingEnd.! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'ag 6/23/2012 11:11:29.713'!
findMorphFor: aClass
	
	^ (self ownerThatIsA: SClassDiagram)
		ifNotNilDo: [ :diagram | diagram classMorphFor: aClass nearestTo: sourceMorph center ]
		ifNil: [ nil ]! !

!SInheritanceConnector methodsFor: 'initialization' stamp: 'ag 12/26/2011 15:17:37.22'!
getClassesInBetween
	| superClass subClass result |
	superClass := targetMorph visualizedClass.
	subClass := sourceMorph visualizedClass. "Because of collection-lookup below"
	result := OrderedCollection new.
	
	(superClass allSubclasses includes: subClass) ifTrue: [
		| current |
		current := subClass superclass.		
		[ current = superClass ] whileFalse: [
			result add: current.
			current := current superclass ] ].
	^ result! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'ag 6/4/2012 15:29:40.528'!
hoveredClassMorph
	
	^ self hoveredClassMorphs
		ifEmpty: nil
		ifNotEmptyDo: #first! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'ag 6/4/2012 15:26:06.653'!
hoveredClassMorphs
	
	| lineEndPosition |
	lineEndPosition := self lineEndPosition.
	^ self owner submorphsSatisfying: [ :submorph |
		(submorph isKindOf: SClassMorph) and: [
			submorph boundsInWorld containsPoint: lineEndPosition ] ]! !

!SInheritanceConnector methodsFor: 'initialization' stamp: 'ag 12/26/2011 13:15:18.945'!
initialize

	super initialize.
	self initializeLabel.! !

!SInheritanceConnector methodsFor: 'initialization' stamp: 'ag 7/2/2012 16:21:29.739'!
initializeLabel
	"Update the label, if necessary."
	
	| classesInBetween |
	classesInBetween := self getClassesInBetween.
	label notNil ~= classesInBetween notEmpty
		ifTrue: [
			label
				ifNil: [ self labelClass openOn: self containing: classesInBetween ]
				ifNotNil: [ label abandon ] ].! !

!SInheritanceConnector methodsFor: 'validation' stamp: 'ag 7/2/2012 14:54:25.868'!
isValid

	^ self sourceMorph isClassMorph
		and: [self targetMorph isClassMorph]
		and: [self sourceMorph visualizedClass withAllSuperclasses includes: self targetMorph visualizedClass]! !

!SInheritanceConnector methodsFor: 'initialization' stamp: 'ag 10/25/2011 11:12:47.677'!
labelClass
	
	^ SInheritenceLabelMorph! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'ag 6/4/2012 15:26:29.382'!
lineEndPosition
	
	^ self constraints last boundsInWorld center! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'tfel 6/26/2012 18:24:09.444'!
refactorSuperclassTo: newSuperclassMorph rollbackTo: originalSuperclassMorph
	"Prompt the user with the refactoring-details. After the details-windows is closed, check, whether the super-class
	has actually changed, and update the inheritance connector based on the new system-state."
	
	| oldSuperclass newSuperclass |
	newSuperclass := newSuperclassMorph visualizedClass.
	oldSuperclass := sourceMorph visualizedClass superclass.
	SRefactoring
		execute: (SChangeSuperclassRefactoring
			reparentClass: sourceMorph visualizedClass
			from: oldSuperclass
			to: newSuperclass)
		onClose: [ | realNewSuperclass |
			realNewSuperclass := sourceMorph visualizedClass superclass. "Check again now, after refactoring."
			(realNewSuperclass ~= oldSuperclass)
				ifFalse: [ ^ originalSuperclassMorph ]
				ifTrue: [ "The refactoring has been correctly accepted."
					^ newSuperclass = realNewSuperclass
						ifTrue: [ newSuperclassMorph ]
						ifFalse: [ "Find a completely new superclass-morph... Will return nil, if none found."
							self findMorphFor: realNewSuperclass ] ] ].! !

!SInheritanceConnector methodsFor: 'updating' stamp: 'ag 12/27/2011 11:29:56.635'!
restoreConsistency
	
	super restoreConsistency
		ifFalse: [ "Recreate the connector to make sure."
			self abandon.
			(self targetMorph isSuperClassOf: self sourceMorph)
				ifTrue: [ SInheritanceConnector openFor: self sourceMorph connectedTo: self targetMorph ] ].
	^ true! !

!SInheritanceConnector methodsFor: 'as yet unclassified' stamp: 'ag 7/2/2012 16:18:37.621'!
step
	
	super step.
	self initializeLabel.! !

!SInheritanceConnector methodsFor: 'reengineering' stamp: 'ag 6/23/2012 12:53:16.232'!
superclassRefactoringAllowed: newSuperclassMorph
	
	^ newSuperclassMorph notNil
		and: [ newSuperclassMorph ~~ targetMorph ]
		and: [ newSuperclassMorph klass ~= targetMorph klass ]! !

SConnector subclass: #SNoteConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Connector'!

!SNoteConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:18:14.433'!
arrowTypes
	
	^ #( noArrow noArrow )! !

!SNoteConnector class methodsFor: 'arrows' stamp: 'ag 12/26/2011 13:19:19.513'!
instanceName
	
	^ 'Note'! !

!SNoteConnector methodsFor: 'visiting' stamp: 'ag 7/2/2012 11:33:05.292'!
accept: aVisitor

	aVisitor visit: self targetMorph.! !

!SNoteConnector methodsFor: 'accessing' stamp: 'ag 6/4/2012 16:42:33.514'!
graphTargetMorph
	"The target-morphs of this connector are not class or method-morphs and are layouted directly."
	
	^ targetMorph! !

!SNoteConnector methodsFor: 'initialization' stamp: 'ag 12/26/2011 13:18:00.692'!
initialize
	
	super initialize.
	self flag: #ag. "When dashed line for smooth-curve is implemented, remove sending beStraightSegments here."
	self
		dashedLine: true;
		beStraightSegments. "Remove being smooth-curve, as it is not implemented for dashed lines."! !

PushDownMethodRefactoring subclass: #SPushDownMethodRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SPushDownMethodRefactoring methodsFor: 'preconditions' stamp: 'ag 7/2/2012 13:36:16.593'!
preconditions
	"The same preconditions like in the super-class, but remove the need 
	to have an abstract class as source."
	
	| condition |
	condition := selectors inject: RBCondition empty
				into: 
					[:cond :each | 
					cond & (RBCondition definesSelector: each in: class) 
						& (RBCondition subclassesOf: class referToSelector: each) not].
	^ condition! !

MCVersionMerger subclass: #SPVVersionMerger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Monticello'!

!SPVVersionMerger class methodsFor: 'as yet unclassified' stamp: 'tfel 6/14/2011 14:55:08.008'!
isRefinementFor: aClass

	^ aClass == MCVersionMerger! !

!SPVVersionMerger class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 12:52:23.975'!
mergeDiagramsIn: aVersion for: sproject
	| diagrams |
	(diagrams := aVersion refinements
								at: SPVMczWriter diagramsMember
								ifAbsent: [])
		ifNil: [Transcript show: 'No diagrams in ', aVersion printString; cr. ^ self].
	diagrams do: [:diagram |
		(sproject viewNamed: diagram savedName)
			ifNil: [sproject addViewNamed: diagram savedName with: diagram]
			ifNotNil: [(self confirm: 'Load new diagram ', diagram savedName, '?')
						ifTrue: [sproject
								addViewNamed: diagram 
								savedName with: diagram]]].
! !

!SPVVersionMerger class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 12:48:13.225'!
mergeTypeHarvestIn: aVersion for: sproject
	| typeHarvest |
	(typeHarvest := aVersion refinements
								at: SPVMczWriter typeHarvestMember
								ifAbsent: [])
		ifNil: [Transcript show: 'No type harvest in ', aVersion printString; cr. ^ self].
	(sproject typesBucket = typeHarvest) ifFalse: [
		sproject typesBucket explore. typeHarvest explore.  
		(self confirm: 'Should I replace type harvest information for ', sproject, '?')
			ifTrue: [sproject typesBucket: typeHarvest]].
! !

!SPVVersionMerger class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 12:49:11.141'!
mergeVersion: aVersion
	| sproject |
	(sproject := SProject projectAt: aVersion package name asSymbol) ifNil: [^ self].
	self
		mergeTypeHarvestIn: aVersion for: sproject;
		mergeDiagramsIn: aVersion for: sproject.
! !

ExtractMethodRefactoring subclass: #SExtractMethodRefactoring
	instanceVariableNames: 'targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SExtractMethodRefactoring class methodsFor: 'as yet unclassified' stamp: 'sp 7/2/2012 14:40:49.764'!
extract: anInterval from: aSelector in: aClass to: aTargetClass
	^self new
		extract: anInterval
		from: aSelector
		in: aClass
		to: aTargetClass! !

!SExtractMethodRefactoring methodsFor: 'transforming' stamp: 'sp 7/2/2012 14:49:20.713'!
extract: anInterval from: aSelector in: aClass to: aTargetClass
	targetClass := self classObjectFor: aTargetClass.
	class := self classObjectFor: aClass.
	selector := aSelector.
	extractionInterval := anInterval.! !

!SExtractMethodRefactoring methodsFor: 'transforming' stamp: 'sp 7/2/2012 14:15:21.926'!
getNewMethodName
	| newSelector methodName newMethodName |
	methodName := RBMethodName new.
	methodName arguments: parameters.
	
	[newMethodName := self requestMethodNameFor: methodName.
	newMethodName isNil 
		ifTrue: [^nil].
	newSelector := newMethodName selector.
	(self checkMethodName: newSelector in: class) 
		ifFalse: 
			[self refactoringWarning: newSelector , ' is not a valid selector name.'.
			newSelector := nil].
	(class hierarchyDefinesMethod: newSelector asSymbol) 
		ifTrue: 
			[(self shouldOverride: newSelector in: class) ifFalse: [newSelector := nil]].
	newSelector isNil] 
			whileTrue: [].
	parameters := newMethodName arguments asOrderedCollection.
	^newSelector asSymbol! !

!SExtractMethodRefactoring methodsFor: 'transforming' stamp: 'sp 7/2/2012 14:50:12.587'!
transform
	| existingSelector target newName |
	target := targetClass ifNil: [class] ifNotNil: [targetClass].
	existingSelector := self existingSelector.
	self nameNewMethod: (existingSelector isNil 
				ifTrue: [(newName := self getNewMethodName)
							ifNil: [^self]
							ifNotNil: [newName] ]
				ifFalse: [existingSelector]).
	existingSelector isNil 
		ifTrue: 
			[target compile: extractedParseTree newSource
				withAttributesFrom: (class methodFor: selector)].
	class compileTree: modifiedParseTree! !

MCMczReader subclass: #SPVMczReader
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Monticello'!

!SPVMczReader class methodsFor: 'testing' stamp: 'tfel 6/14/2011 14:43:21.106'!
isRefinementFor: aClass

	^ aClass == MCMczReader! !

!SPVMczReader class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 13:13:57.636'!
refineVersion: aVersion fromZip: aZip
	
	[self new
		version: aVersion;
		zip: aZip;
		load] on: Error do: [self inform: 'There was an error in ', self class name
							"Avoid not being able to commit"]! !

!SPVMczReader methodsFor: 'actions' stamp: 'tfel 7/14/2011 11:53:42.173'!
load
	
	self
		loadTypeHarvest;
		loadDiagrams.
! !

!SPVMczReader methodsFor: 'actions' stamp: 'tfel 7/14/2011 13:13:13.984'!
loadDiagrams
	| diagramsBin diagrams |
	(diagramsBin := zip membersMatching: (SPVMczWriter diagramsMember, '*')) ifNil: [^ self].
	diagrams := OrderedCollection new.
	diagramsBin do: [:d |
		diagrams add: ([SClassDiagram loadFromStream: d contentStream]
							on: Error
							do: [:err | self inform: 'Error loading a stored path view diagram'. nil])].
	version refinements
		at: SPVMczWriter diagramsMember
		put: diagrams.
! !

!SPVMczReader methodsFor: 'actions' stamp: 'tfel 7/14/2011 11:53:31.905'!
loadTypeHarvest
	| typeHarvestBin typeHarvest bucket |
	(typeHarvestBin := zip memberNamed: SPVMczWriter typeHarvestMember, '.bin') ifNil: [^ self].
	(typeHarvest := zip memberNamed: SPVMczWriter typeHarvestMember) ifNil: [^ self].
	[bucket := (DataStream on: typeHarvestBin contentStream) next.
	 bucket := bucket ifNotNil: [bucket convertToTypes]]
					on: Error
					do: [:err | bucket := nil].
	bucket ifNil: [[bucket := Compiler evaluate: typeHarvest]
					on: Error
					do: [:err | ^ self inform: 'Error loading stored type information.']].
	version refinements
		at: SPVMczWriter typeHarvestMember
		put: bucket.

! !

!SPVMczReader methodsFor: 'accessing' stamp: 'tfel 6/14/2011 15:42:20.414'!
version: aVersion

	version := aVersion.! !

!SPVMczReader methodsFor: 'accessing' stamp: 'tfel 6/14/2011 15:42:11.438'!
zip: aZip

	zip := aZip.! !

ColorMappingCanvas subclass: #SColorMappingCanvas
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SColorMappingCanvas methodsFor: 'drawing' stamp: 'ag 8/19/2011 13:45:15.224'!
fillRoundRect: rectangle radius: number fillStyle: style
	"Explicit support for SDiagramMorphToolbarPanel >> #drawOn:"
	
	^ myCanvas fillRoundRect: rectangle radius: number fillStyle: style! !

!SColorMappingCanvas methodsFor: 'private' stamp: 'ag 9/30/2011 12:53:04.995'!
mapColor: aColor
	
	^ mapping
		ifNil: [ aColor ]
		ifNotNil: [ mapping value: aColor ]! !

!SColorMappingCanvas methodsFor: 'accessing' stamp: 'tfel 5/31/2011 13:01:22.482'!
mapping
	^ mapping! !

!SColorMappingCanvas methodsFor: 'accessing' stamp: 'tfel 5/31/2011 13:01:22.501'!
mapping: anObject
	mapping := anObject! !

MCVersionLoader subclass: #SPVVersionLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Monticello'!

!SPVVersionLoader class methodsFor: 'as yet unclassified' stamp: 'tfel 6/14/2011 14:54:38.168'!
isRefinementFor: aClass

	^ aClass == MCVersionLoader! !

!SPVVersionLoader class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 12:47:21.815'!
loadDiagramsIn: aVersion for: sproject
	| diagrams |
	(diagrams := aVersion refinements
								at: SPVMczWriter diagramsMember
								ifAbsent: [])
		ifNil: [Transcript show: 'No diagrams in ', aVersion printString; cr. ^ self].
	diagrams do: [:diagram |
		sproject addViewNamed: diagram savedName with: diagram].
! !

!SPVVersionLoader class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 12:45:34.981'!
loadTypeHarvestIn: aVersion for: sproject
	| typeHarvest |
	(typeHarvest := aVersion refinements
								at: SPVMczWriter typeHarvestMember
								ifAbsent: [])
		ifNil: [Transcript show: 'No type harvest in ', aVersion printString; cr. ^ self].
	(sproject typesBucket = typeHarvest) ifFalse: [
		sproject typesBucket: typeHarvest].
! !

!SPVVersionLoader class methodsFor: 'as yet unclassified' stamp: 'tfel 7/14/2011 12:45:21.823'!
loadVersion: aVersion
	| sproject |
	(sproject := SProject projectAt: aVersion package name asSymbol) ifNil: [^ self].
	self
		loadTypeHarvestIn: aVersion for: sproject;
		loadDiagramsIn: aVersion for: sproject.
! !

SPMMenuMorph subclass: #SPVMenuMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SPVMenuMorph methodsFor: 'event handling' stamp: 'mp 1/26/2011 10:13:54.814'!
handlesMouseOver: anEvent

	^ false! !

!ClassDescription methodsFor: '*Path-View' stamp: 'fb 5/5/2011 12:03:07.869'!
hasAbstractMethods 
	| aSet |
	aSet := IdentitySet new.
	self withAllSuperclasses do: [ :aClass |
		aClass methodDict keysAndValuesDo: [ :selector :compiledMethod |
  			(aSet includes: selector)				
   				ifFalse: [compiledMethod isAbstract
      						ifTrue: [^ true]
							ifFalse: [aSet add: selector]
						]
					
     		]
	].
	^ false! !

!ClassDescription methodsFor: '*Path-View' stamp: 'tfel 7/22/2011 11:48:53.97'!
poolDictionaryNames
	^ self sharedPools collect: [:ea | self environment keyAtIdentityValue: ea]! !

ClassRefactoring subclass: #SChangeSuperclassRefactoring
	instanceVariableNames: 'class newSuperclass category oldSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SChangeSuperclassRefactoring class methodsFor: 'instance creation' stamp: 'tfel 6/26/2012 18:08:02.594'!
model: aRBSmalltalk reparentClass: aClass from: oldSuper to: newSuper

	^ self new
		model: aRBSmalltalk;
		reparentClass: aClass from: oldSuper to: newSuper;
		yourself! !

!SChangeSuperclassRefactoring class methodsFor: 'instance creation' stamp: 'tfel 6/26/2012 18:08:06.843'!
reparentClass: aClass from: oldSuper to: newSuper

	^ self new
		reparentClass: aClass from: oldSuper to: newSuper;
		yourself! !

!SChangeSuperclassRefactoring methodsFor: 'preconditions' stamp: 'tfel 6/26/2012 18:14:12.549'!
preconditions
	
	^ (RBCondition hierarchyOf: oldSuperclass includes: newSuperclass)
		errorMacro: 'Hierarchy of old superclass must include the new superclass';
		yourself! !

!SChangeSuperclassRefactoring methodsFor: 'initialize-release' stamp: 'tfel 6/26/2012 18:06:51.624'!
reparentClass: aClass from: oldSuper to: newSuper
	self className: aClass name.
	oldSuperclass := oldSuper.
	newSuperclass := newSuper.
	category := aClass category! !

!SChangeSuperclassRefactoring methodsFor: 'transforming' stamp: 'tfel 6/26/2012 18:05:12.204'!
transform
	(self model)
		defineClass: ('<1p> subclass: #<2s> instanceVariableNames: '''' classVariableNames: '''' poolDictionaries: '''' category: <3p>' 
					expandMacrosWith: newSuperclass
					with: className
					with: category asString).! !

BorderedMorph subclass: #SMiniMap
	instanceVariableNames: 'scalingFactor viewedMorph scrollPane viewportMorph thumbnailMorph viewportGrabbingOffset hideByDefault'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SMiniMap class methodsFor: 'instance creation' stamp: 'ag 9/15/2011 20:07:00.993'!
for: aScrollPane
	"This constructor assumes, that the scroller of aScrollPane has exactly one morph put in it."
	
	^ self
		on: aScrollPane scroller submorphs first
		in: aScrollPane! !

!SMiniMap class methodsFor: 'instance creation' stamp: 'mp 1/22/2011 22:25:59.585'!
on: aPasteUpMorph

	^ self new
		viewAreaMorph: aPasteUpMorph;
		yourself! !

!SMiniMap class methodsFor: 'instance creation' stamp: 'ag 9/15/2011 20:36:51.767'!
on: aMorph in: aScrollPane
	
	^ self basicNew
		viewedMorph: aMorph;
		scrollPane: aScrollPane;
		initialize;
		yourself! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 5/18/2012 16:43:57.395'!
hideByDefault
	
	^ hideByDefault ifNil: [ false ]! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 5/18/2012 16:45:25.645'!
hideByDefault: aBoolean
	"If this is set to true, the receiver will hide itself when being added to a new owner (noteNewOwner:).
	The reason is to address the issue of poor performance, when the minimap is used. This way, it can be disabled by default."
	
	hideByDefault := aBoolean.! !

!SMiniMap methodsFor: 'initialize' stamp: 'ag 12/29/2011 17:16:48.172'!
initialize
	
	super initialize.
	self
		disableDragNDrop;
		layoutInset: 3;
		borderWidth: 3;
		borderColor: Color gray;
		color: Color transparent;
		initializeThumbnailMorph;
		initializeViewportMorph;
		addMorph: thumbnailMorph;
		addMorphFront: viewportMorph;
		on: #mouseDown send: #viewportJumped: to: self;
		on: #mouseMove send: #viewportMoved: to: self; "This will happen, if viewport-dragging has originated by a viewportJumped:"
		scalingFactor: 0.1.! !

!SMiniMap methodsFor: 'initialize' stamp: 'ag 12/31/2011 10:00:30.852'!
initializeThumbnailMorph
	
	thumbnailMorph := SSmoothableThumbnailMorph new
		objectToView: viewedMorph;
		yourself.! !

!SMiniMap methodsFor: 'initialize' stamp: 'ag 12/30/2011 16:19:20.094'!
initializeViewportMorph
	
	scrollPane scroller
		onOffsetChange: [ self refreshViewport ];
		onScaleChange: [ self refreshViewport ].
	viewportMorph := BorderedMorph new
		borderWidth: 2;
		borderColor: Color gray;
		color: Color transparent;
		on: #startDrag send: #viewportStartedDrag: to: self;
		on: #mouseMove send: #viewportMoved: to: self;
		yourself.! !

!SMiniMap methodsFor: 'initialize' stamp: 'ag 5/18/2012 22:50:08.238'!
noteNewOwner: aMorph
	
	super noteNewOwner: aMorph.
	self hideByDefault ifTrue: [ self hide ].! !

!SMiniMap methodsFor: 'refreshing' stamp: 'ag 12/29/2011 18:03:38.634'!
refreshExtent
	
	| oldExtent extent |
	oldExtent := self extent.
	extent := viewedMorph extent * self scalingFactor.
	thumbnailMorph extent: extent.
	self refreshViewport.! !

!SMiniMap methodsFor: 'refreshing' stamp: 'ag 4/19/2012 13:51:35.131'!
refreshViewport
	"The changes made here should not affect the viewportDraggingRectangle value, so don't refresh it here."
	
	| scrollerBounds viewportBounds |
	scrollerBounds := scrollPane scroller boundsInWorld.
	viewportBounds := 
		(scrollerBounds topLeft - viewedMorph boundsInWorld topLeft)
			extent: scrollerBounds extent.
	viewportMorph bounds:
		((viewportBounds scaleBy: self zoomedScalingFactor)
			translateBy: self position).! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 9/15/2011 21:11:38.818'!
scalingFactor
	^ scalingFactor! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 9/15/2011 21:11:56.32'!
scalingFactor: anObject
	
	scalingFactor := anObject.
	self refreshExtent.! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 9/15/2011 11:03:55.323'!
scrollPane: anObject
	scrollPane := anObject! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 12/31/2011 09:53:55.885'!
smoothing
	
	^ thumbnailMorph smoothing! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 12/31/2011 09:54:00.756'!
smoothing: aNumber
	
	^ thumbnailMorph smoothing: aNumber! !

!SMiniMap methodsFor: 'accessing' stamp: 'ag 9/15/2011 11:03:46.565'!
viewedMorph: anObject
	viewedMorph := anObject! !

!SMiniMap methodsFor: 'viewport' stamp: 'ag 12/26/2011 12:38:19.898'!
viewportJumped: anEvent
	
	viewportGrabbingOffset := 0 @ 0. "Simulate having grabbed the viewport in its exact center."
	self viewportMoved: anEvent.! !

!SMiniMap methodsFor: 'viewport' stamp: 'ag 12/30/2011 16:32:53.689'!
viewportMoved: anEvent
	"Make sure, that the viewport does not leave the allowed area."
	
	scrollPane scrollInsideBoundsBy: 
		(anEvent position - viewportGrabbingOffset - viewportMorph center) / self zoomedScalingFactor.
	self refreshViewport.! !

!SMiniMap methodsFor: 'viewport' stamp: 'ag 9/15/2011 19:29:49.295'!
viewportStartedDrag: anEvent
	
	viewportGrabbingOffset := anEvent position - viewportMorph center.! !

!SMiniMap methodsFor: 'viewport' stamp: 'ag 12/30/2011 16:33:12.305'!
zoomedScalingFactor
	"This takes the scale/zoom level of the scroller into account."
	
	^ self scalingFactor / scrollPane scroller scale! !

ExtractMethodToComponentRefactoring subclass: #SExtractMethodToComponentRefactoring
	instanceVariableNames: 'targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SExtractMethodToComponentRefactoring methodsFor: 'transforming' stamp: 'sp 7/2/2012 11:28:54.222'!
moveMethod
	"This method is copied from the super-class, then modified to use our own version of the 
	MoveMethodRefactoring."
	
	| variable refactoring |
	variable := self selectVariableToMoveMethodTo: extractedMethodSelector
				class: class.
	variable isNil ifTrue: [self refactoringError: 'Did not extract method'].
	refactoring := (SMoveMethodRefactoring 
				model: self model
				selector: extractedMethodSelector
				class: class
				variable: variable)
				targetClass: targetClass;
				yourself.
	self performComponentRefactoring: refactoring! !

!SExtractMethodToComponentRefactoring methodsFor: 'accessing' stamp: 'ag 6/28/2012 13:50:37.839'!
targetClass
	^ targetClass! !

!SExtractMethodToComponentRefactoring methodsFor: 'accessing' stamp: 'ag 6/28/2012 13:50:37.873'!
targetClass: anObject
	targetClass := anObject! !

TransformMorph subclass: #SScroller
	instanceVariableNames: 'offsetChangeBlock scaleChangeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SScroller methodsFor: 'private' stamp: 'ag 12/29/2011 17:00:03.194'!
appendBlock: newBlock to: oldBlock
	
	^ [ :arg1 :arg2 |
		{ oldBlock. newBlock } select: #notNil thenDo: [ :block |
			block valueWithPossibleArgs: { arg1. arg2 } ] ]! !

!SScroller methodsFor: 'accessing' stamp: 'ag 4/19/2012 14:02:42.202'!
offset: aPoint
	
	| oldOffset |
	oldOffset := self offset.
	
	"TODO -- there is a performance-issue with this super-call.
	If the minimap is enabled (visible, not hidden), then this super-offset: call takes really long, resulting in a very sluggish feeling when scrolling around in the diagram.
	However, when the minimap is disabled, this effect goes away, even with many morphs inside the diagram.
	Somehow the minimap affects the repaint-performance of this Scroller-morph, even though it is not even a submorph of this scroller morph!!"
	super offset: aPoint.
	
	offsetChangeBlock ifNotNil: [ offsetChangeBlock value: oldOffset value: self offset ].! !

!SScroller methodsFor: 'accessing' stamp: 'ag 12/29/2011 16:58:30.316'!
onOffsetChange: anObject
	"Don't want to disable the old action-blocks."
	
	offsetChangeBlock := self appendBlock: anObject to: offsetChangeBlock.! !

!SScroller methodsFor: 'accessing' stamp: 'ag 12/29/2011 16:56:32.074'!
onScaleChange: anObject
	"Don't want to disable the old action-blocks."
	
	scaleChangeBlock := self appendBlock: anObject to: scaleChangeBlock.! !

!SScroller methodsFor: 'accessing' stamp: 'ag 12/29/2011 17:00:28.813'!
scale: aNumber
	
	| oldScale |
	oldScale := self scale.
	super scale: aNumber.
	scaleChangeBlock ifNotNil: [ scaleChangeBlock value: oldScale value: self scale ].! !

SimpleBorder subclass: #SSimpleOverlappingBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SSimpleOverlappingBorder methodsFor: 'drawing' stamp: 'tfel 4/28/2011 23:00:11.727'!
frameRectangle: aRectangle on: aCanvas
	"We draw our frame 1 higher than our actual frame (expanding over the bottom). This way, the next morphs border falls in-line with ours"
	^ super frameRectangle: (aRectangle extendBy: 0@1) on: aCanvas! !

ScrollPane subclass: #SScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SScrollPane class methodsFor: 'instance creation' stamp: 'ag 12/29/2011 15:55:39.638'!
forMorph: aMorph
	
	| instance |
	instance := self new.
	instance scroller addMorph: aMorph..
	^ instance! !

!SScrollPane methodsFor: 'zooming' stamp: 'ag 12/30/2011 16:42:30.552'!
centerAround: originalSizePoint
	"Center the viewport around the given point. The parameter is inside the coordinates of the ORIGINAL size of the viewed morph,
	without any scaling or offset taken into account."
	
	self setOffsetInsideBounds: (originalSizePoint * self scroller scale) - (self scroller extent / 2).! !

!SScrollPane methodsFor: 'initialization' stamp: 'ag 12/30/2011 12:57:52.461'!
initialize
	
	super initialize.
	self scroller
		on: #startDrag send: #scrollerStartedDragging to: self;
		on: #mouseMove send: #scrollerMoved: to: self;
		onScaleChange: [ :oldScale :newScale | self scaleChangedTo: newScale ].! !

!SScrollPane methodsFor: 'initialization' stamp: 'ag 12/29/2011 15:25:16.413'!
initializeScrollBars
	"Copied from superclass, but replacing the class of the scroller with SScroller.
	Seems not possible in another way; the #scroller: method does not work properly after the initialization is complete."

"initialize the receiver's scrollBar"

	(scrollBar := ScrollBar new model: self slotName: 'vScrollBar')
			borderWidth: 1; 
			borderColor: Color black.
	(hScrollBar := ScrollBar new model: self slotName: 'hScrollBar')
			borderWidth: 1; 
			borderColor: Color black.

	""
	scroller := SScroller new color: Color transparent.
	scroller offset: -3 @ 0.
	self addMorph: scroller.
	""
	scrollBar initializeEmbedded: retractableScrollBar not.
	hScrollBar initializeEmbedded: retractableScrollBar not.
	retractableScrollBar ifFalse: 
			[self 
				addMorph: scrollBar;
				addMorph: hScrollBar].

	Preferences alwaysShowVScrollbar ifTrue:
		[ self alwaysShowVScrollBar: true ].
		
	Preferences alwaysHideHScrollbar
		ifTrue:[self hideHScrollBarIndefinitely: true ]
		ifFalse:
			[Preferences alwaysShowHScrollbar ifTrue:
				[ self alwaysShowHScrollBar: true ]].
! !

!SScrollPane methodsFor: 'scrolling' stamp: 'ag 12/31/2011 10:29:26.162'!
scaleChangedTo: newScale
	"To handle, that the scrollbars cannot cope with the change of the scale, we deactive them if the scale is not one."
	
	newScale = 1
		ifTrue: [ self showScrollBars; setScrollDeltas ]
		ifFalse: [ self hideScrollBars ].! !

!SScrollPane methodsFor: 'scrolling' stamp: 'ag 12/30/2011 16:36:40.941'!
scrollInsideBoundsBy: offset
	"Scroll by anOffset, but make sure, that the viewport does not leave the allowed bounds."
	
	| newCenter centerRectangle |
	newCenter := self scroller center + offset.
	centerRectangle := self scroller submorphBounds insetBy: self scroller extent / 2.
	(centerRectangle containsPoint: newCenter)
		ifFalse: [ newCenter := centerRectangle pointNearestTo: newCenter ].
	self scrollBy: self scroller center - newCenter.! !

!SScrollPane methodsFor: 'scrolling' stamp: 'ag 4/19/2012 13:51:06.317'!
scrollerMoved: anEvent
	"Move the scroller-viewport, take care to not move it over the boundaries of the contents."
	
	self scrollInsideBoundsBy: anEvent startPoint - anEvent position.! !

!SScrollPane methodsFor: 'initialization' stamp: 'ag 9/21/2011 17:54:21.676'!
scrollerStartedDragging
	"Ignored event, needs to be registered to get the scrollerMoved: events."
	! !

!SScrollPane methodsFor: 'scrolling' stamp: 'ag 12/30/2011 23:57:51.053'!
setOffsetInsideBounds: anOffset
	"Set the scroller-offset directly to anOffset, but also scroll the scrollbars and make sure that the viewport does not leave the allowed boundaries.
	This does not scroll by anOffset, but directly sets it (although the scrollBy: method is utilized for that)."
	
	self scrollInsideBoundsBy: anOffset - self scroller offset.! !

!SScrollPane methodsFor: 'zooming' stamp: 'ag 12/30/2011 16:46:00.804'!
zoomInBy: aNumber
	"This has the functionality of TransformationMorph >> adjustAfter:, subclassing SScroller from TransformationMorph instead of TransformMorph did not work.
	After setting the scale-value, move the viewport so that zooming in/out does not change the viewport-center."
	
	| oldCenter |
	oldCenter := (self scroller offset + (self scroller extent / 2)) / self scroller scale.
	self scroller scale: self scroller scale + aNumber.
	self centerAround: oldCenter.! !

PluggableButtonMorphPlus subclass: #SDiagramMorphToolbarButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SDiagramMorphToolbarButton methodsFor: 'accessing' stamp: 'tfel 5/22/2012 12:43:28.962'!
enabled: aBool

	super enabled: aBool.
	aBool ifTrue: [self show] ifFalse: [self hide].! !

!SDiagramMorphToolbarButton methodsFor: 'initialize-release' stamp: 'tfel 5/22/2012 13:45:43.816'!
initialize

	super initialize.
	offColor := onColor. "darker color scheme"! !

PasteUpMorph subclass: #SPasteUpMorph
	instanceVariableNames: 'minimap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SPasteUpMorph commentStamp: 'ag 12/6/2011 15:09:47.133' prior: 0!
This paste-up-morphs just adds interoperability with SMiniMap.!

SPasteUpMorph subclass: #SClassDiagram
	instanceVariableNames: 'classMorphs selectionMorph savedName dirty labelsHidden layoutProcess layoutingLocked multiWindowState savedStates currentState openMutex'
	classVariableNames: 'DebugOpenRandomMethods DebugShowSubgraphs'
	poolDictionaries: ''
	category: 'Path-View-ClassMorph'!

!SClassDiagram commentStamp: 'tfel 7/19/2011 14:16:04.54' prior: 0!
I am the canvas on which a PathView is drawn.
You can drop SClassMorphs on me, as well as
TransferMorphs containing classes from Browsers
and other tools.
!

!SClassDiagram class methodsFor: 'constants' stamp: 'ag 5/11/2012 12:19:27.157'!
additionalDiagramSpace
	"Return the percentage, by which the space in a newly opened path view diagram will be extended further
	than actually required by the diagram."
	
	^ 0.10! !

!SClassDiagram class methodsFor: 'layout-constants force-based' stamp: 'ag 9/26/2011 12:32:13.596'!
attractionConstant
	"Higher value here means shorter connections.
	This represents the attraction-force of the connections, like if they were rubber bands."
	
	^ 40! !

!SClassDiagram class methodsFor: 'layout-constants force-based' stamp: 'ag 9/25/2011 22:10:29.878'!
damping
	"To make the movement stop, the velocities are artificially dampened.
	Should be between 0.0 and 1.0.
	A too high value may cause the nodes to keep moving endlessly, a too low value might cause them to stop moving immediately."
	
	^ 0.0006! !

!SClassDiagram class methodsFor: 'debug graph layout' stamp: 'ag 4/18/2012 13:11:39.94'!
debugOpenRandomMethods
	<preference: 'Open some random methods for debugging-purposes'
		category: 'Path View'
		description: 'When dragging a whole class-category into a class-diagram, the contents will be automatically layouted. If this is enabled, some methods will be opened automatically in addition to adding the classes from the category.'
		type: #Boolean>
	^ DebugOpenRandomMethods ifNil: [ DebugOpenRandomMethods := false ]! !

!SClassDiagram class methodsFor: 'debug graph layout' stamp: 'ag 4/18/2012 13:14:52.934'!
debugOpenRandomMethods: aBoolean
	
	DebugOpenRandomMethods := aBoolean.! !

!SClassDiagram class methodsFor: 'debug graph layout' stamp: 'ag 4/18/2012 13:09:03.353'!
debugShowSubgraphs
	<preference: 'Show subgraphs for debugging-purposes'
		category: 'Path View'
		description: 'When auto-layouting a class-diagram, there will be multiple subgraphs involved. If this is enabled, each subgraph will be highlighted by another randomly colored box.'
		type: #Boolean>
	^ DebugShowSubgraphs ifNil: [ DebugShowSubgraphs := false ]! !

!SClassDiagram class methodsFor: 'debug graph layout' stamp: 'ag 4/18/2012 13:14:33.14'!
debugShowSubgraphs: aBoolean
	
	DebugShowSubgraphs := aBoolean.! !

!SClassDiagram class methodsFor: 'constants' stamp: 'ag 12/29/2011 16:39:20.572'!
defaultMinimapScale
	
	^ 0.065! !

!SClassDiagram class methodsFor: 'constants' stamp: 'ag 12/31/2011 10:23:45.333'!
defaultSmoothing
	"Value between 1 and 3 for default picture quality of scrollpane-content and minimap."
	
	^ 1! !

!SClassDiagram class methodsFor: 'save/restore' stamp: 'ag 12/27/2011 12:52:06.726'!
loadFromStream: aStream
	
	| stream morph |
	stream := (aStream class = FileStream
		ifTrue: [(MultiByteBinaryOrTextStream with: (aStream binary contentsOfEntireFile)) 
					binary reset]
		ifFalse: [aStream binary reset]).
	morph := stream fileInObjectAndCode.
	^ morph! !

!SClassDiagram class methodsFor: 'layout-constants force-based' stamp: 'ag 9/26/2011 12:46:58.591'!
minimalKineticEnergy
	"Average kinetic energy required per node to keep the simulation alive.
	Setting this to a smaller number might cause the movement to never stop;
	setting it to a higher number might cause it to stop early or directly after the first iteration."
	
	^ 0.45! !

!SClassDiagram class methodsFor: 'constants' stamp: 'ag 12/29/2011 16:30:53.432'!
minimapScaleStep
	
	^ 0.05! !

!SClassDiagram class methodsFor: 'debug graph layout' stamp: 'ag 4/18/2012 13:11:53.808'!
numberOfRandomAutoOpenedMethods
	"The returned number of methods is opened randomly and automatically when a category of classes
	is dragged into a graph-diagram."
	
	^ self debugOpenRandomMethods
		ifTrue: [ 3 ]
		ifFalse: [ 0 ]! !

!SClassDiagram class methodsFor: 'layout-constants force-based' stamp: 'ag 9/25/2011 19:18:04.046'!
repulsionConstant
	"This is approximately the actual Coulomb constant from Coulombs's law of repulsion."
	
	^ 8.987e8! !

!SClassDiagram class methodsFor: 'constants' stamp: 'ag 12/29/2011 16:06:22.423'!
zoomStep
	
	^ 0.2! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/19/2012 14:32:06.375'!
acceptClassCategory: aMorph
	
	^ (aMorph passenger isKindOf: OBClassCategoryNode)
		ifTrue: [ | classes |
			classes := aMorph passenger classes collect: #theClass.
			self addClasses: classes.
			self class numberOfRandomAutoOpenedMethods
				timesRepeat: [ | class assoc color |
					color := Color random.
					class := classes atRandom.
					assoc := class -> class methodDict keys atRandom.
					(self addMethod: assoc) color: color.
					(self morphForMethod: assoc)
						pin;
						setColorIcon: color blacker blacker blacker;
						highlightedColor: color ].
			self
				expandAndToggleLabels;
				layoutGraphForked ]! !

!SClassDiagram methodsFor: 'events-processing' stamp: 'ag 7/2/2012 13:26:41.94'!
acceptDroppingMorph: aMorph event: anEvent
	
	| newMorph isNewMorph |
	(aMorph isKindOf: SFloatingCodeSnippet) ifTrue: [ ^ self ].
	(aMorph isKindOf: SEntryMorph) ifTrue: [ ^ self ].
	aMorph class == SDebugRectangleMorph ifTrue: [ ^ super acceptDroppingMorph: aMorph event: anEvent ].
	(self carriesAcceptableClassCategory: aMorph) ifTrue: 
		[ ^ self acceptClassCategory: aMorph ].
	newMorph := aMorph asClassDiagramMorph.
	isNewMorph := false. "TODO -- find clean way to distinguish between dragged morph and really new morph. Checking the classMorphs collection or the newMorph owner does not work."
	super acceptDroppingMorph: newMorph event: anEvent.
	newMorph isClassMorph & (isNewMorph | aMorph isClassMorph not)
		ifTrue: [
			newMorph showLabels: labelsHidden not.
			newMorph optionallyOpenConnectors ].! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'sp 6/22/2012 16:22:35.936'!
addClass

	"Present a choice of classes or prompt for a new class name"
	| choices labels menuIndex newName |

	labels := OrderedCollection with: 'new...'.
	choices := SmalltalkImage current allClasses.
	labels addAll: (choices collect: [ :class| class name]) asSortedCollection.
	
	newName := (labels size = 1 or: [
		menuIndex := (UIManager default chooseFrom: labels title: 'Add Class').
		menuIndex = 0 ifTrue: [^ self].
		menuIndex = 1])
			ifTrue: [
				UIManager default request: 'Please type new class name'
					initialAnswer: 'ClassName']
			ifFalse: [
				choices at: menuIndex-1].
			
	newName isNil ifTrue: [^ self].
	newName isString ifTrue: [ 
		(AddClassRefactoring 
			addClass: newName 
			superclass: Object 
			subclasses: {} 
			category: (UIManager default 
							chooseFrom: SystemOrganization categories
							values: SystemOrganization categories
							title: 'Choose a system category')
			) execute.
		newName := Smalltalk at: newName asSymbol. ].  
	
	(SClassMorph on: newName) openInHand.
	! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/6/2012 20:06:11.443'!
addClasses: aCollectionOfClasses
	
	self
		openClassMorphs: aCollectionOfClasses at: self center;
		arrangeAssociations: classMorphs.! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/18/2012 13:30:50.716'!
addMethod: anAssociation
	"anAssociation: class -> methodSelectorSymbol.
	If everything goes fine, returns the opened morph."
	
	^ self
		morphForClass: anAssociation key
		do: [ :morph | morph openMethod: anAssociation ].! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/30/2012 11:47:42.292'!
addMethods: associations
	"associations is a collection of Associations from Class to method-selector-symbols.
	If one of the classes is not part of the diagram, the according association is ignored.
	Return a collection of morphs, that have been opened."
	
	^ associations
		collect: [ :association | self addMethod: association ]
		thenSelect: #notNil! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'sp 6/19/2012 15:20:25.972'!
addNote

	SNoteMorph new openInHand.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'sp 6/19/2012 15:19:58.828'!
addNoteOrClass

	| menu |
	menu := MenuMorph new.
	menu
		add: 'add class' target: self selector: #addClass;
		add: 'add note' target:  self selector: #addNote.
		
	menu items
		ifNotEmpty: [menu invokeAt: ActiveHand position in: ActiveWorld allowKeyboard: true]
		ifEmpty: [self clicked].! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/31/2011 09:56:02.845'!
addSmoothing: aNumber
	
	self setSmoothing: self currentSmoothing + aNumber.! !

!SClassDiagram methodsFor: 'submorphs-add/remove' stamp: 'ag 5/18/2012 16:41:55.96'!
addedMorph: aMorph
	"aMorph has just been added to me"
	
	"Hide the minimap by default to address the performance-issue when it is shown."
	self minimap ifNotNil: [ aMorph == self minimap ifTrue: [ aMorph hide. ] ].
	
	aMorph isClassMorph ifTrue: [
		classMorphs add: aMorph.
		aMorph focus ].
	self
		contentChangedBecauseOf: aMorph;
		changed: #morphAdded.! !

!SClassDiagram methodsFor: 'views' stamp: 'sp 7/6/2012 15:20:29.804'!
allViewReferences
	
	| methods |
	methods := SortedCollection new.
	Cursor wait showWhile:
		[ Class allSubInstances do:
			[ :class | "find all the methods of the receiver and not of all its superclasses "
				(class theMetaClass organization listAtCategoryNamed: SClassDiagramMorph diagramCodeCategory) 
						asSet asSortedArray do:
					[ :method |
						method numArgs = 1 ifTrue: [
							methods add: (MethodReference class: class theMetaClass selector: method)] ] ] ].
	^ methods! !

!SClassDiagram methodsFor: 'views' stamp: 'sp 7/6/2012 14:33:54.674'!
allViews
	
	| navigation methods |
	methods := SortedCollection new.
	navigation := SystemNavigation default.
	Cursor wait showWhile:
		[ Class allSubInstances do:
			[ :x |
				(x theMetaClass allMethodsInCategory: SClassDiagramMorph diagramCodeCategory) do:
					[ :sel |
						sel numArgs = 1 ifTrue: [
							methods addIfNotPresent: sel asString allButLast ] ] ] ].
	^ methods! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'omg 6/14/2011 13:45:16.977'!
alwaysEnabled

	^true! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 18:53:28.383'!
applyForces
	"Calculate the current force for each node and sum up the kinetic energy for each node."
	
	^ classMorphs
		inject: 0
		into: [ :energy :morph |
			energy + (morph
				applyForceFrom: classMorphs;
				kineticEnergy) ]! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 2/16/2012 13:55:09.707'!
arrangeAssociations: collectionOfClassMorphs
	
	collectionOfClassMorphs do: [ :aMorph | | classMorphs |
		classMorphs := collectionOfClassMorphs copyWithout: aMorph.
		aMorph
			openAssociationConnectionsWithAll: classMorphs;
			openInheritenceConnectionsWithAll: classMorphs ].! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 7/5/2012 14:56:47.524'!
canBeSaved

	[self classMorphs do: [:cm | cm saveToCodeFor: '']] on: Error do: [:e | ^ false].
	^ true! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'tfel 6/28/2012 08:02:05.484'!
canScaleMinimapBigger
	
	minimap ifNil: [^ false].
	^ minimap scalingFactor + self class minimapScaleStep < 1! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'tfel 6/28/2012 08:02:17.227'!
canScaleMinimapSmaller
	
	minimap ifNil: [^ false].
	^ minimap scalingFactor > 0! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/31/2011 09:38:15.25'!
canSmoothDown
	
	^ self currentSmoothing > 1! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/31/2011 10:21:37.164'!
canSmoothUp
	
	^ self currentSmoothing < 3! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/29/2011 16:44:46.67'!
canZoomOut
	
	^ self currentZoom - self class zoomStep > 0.15! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 12/12/2011 16:40:09.53'!
canvasWithoutWhitespace
	
	| topLeft bottomRight |
	(self classMorphs isNil | self submorphs isEmpty) ifNil: [ ^ nil ].
	topLeft := self submorphs first bounds origin.
	bottomRight := self submorphs first bounds corner.
	self submorphs do: [:each |
		topLeft := ((topLeft x) min: (each bounds origin x)) @ ((topLeft y) min: (each bounds origin y)).
		bottomRight := ((bottomRight x) max: (each bounds corner x)) @ ((bottomRight y) max: (each bounds corner y)) ].
	^ topLeft corner: bottomRight! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/6/2012 21:42:31.587'!
carriesAcceptableClassCategory: aMorph
	
	^ (aMorph isKindOf: TransferMorph) 
		and: [ aMorph passenger isKindOf: OBClassCategoryNode ]! !

!SClassDiagram methodsFor: 'accessing' stamp: 'ag 12/31/2011 10:03:55.771'!
classMorphFor: aClass nearestTo: aMorphOrPoint
	"Returns the class-morph matching aClass (if any), that is the nearest to aPoint.
	Small duplication with SClassMorph >> nearestMorph:"
	
	| point |
	point := aMorphOrPoint isPoint ifTrue: [ aMorphOrPoint ] ifFalse: [ aMorphOrPoint center ].
	^ (self classMorphsFor: aClass)
		detectMin: [ :each | point dist: each center ]! !

!SClassDiagram methodsFor: 'accessing' stamp: 'ag 12/29/2011 11:49:51.981'!
classMorphs 
	
	^ classMorphs! !

!SClassDiagram methodsFor: 'accessing' stamp: 'sp 7/6/2012 13:05:36.363'!
classMorphsFor: class

	^ classMorphs select: [ :each | each klass = class ]! !

!SClassDiagram methodsFor: 'accessing' stamp: 'ag 10/12/2011 14:25:24.492'!
classes
	"Collection-lookups are performed with the result, so use #visualizedClass instead of #klass"
	
	^ classMorphs collect: [ :m | m visualizedClass ]! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 18:04:59.18'!
clearAllVectors
	
	classMorphs do: [ :cl | cl vector: 0@0 ].! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 6/28/2012 13:10:41.512'!
close

	(savedStates isEmpty
	or: [savedStates keys size = 1 and: [savedStates keys first = currentState]])
		ifTrue: [(self ownerThatIsA: SystemWindow) delete]
		ifFalse: [
			savedStates removeKey: self stateKey ifAbsent: [].
			self restoreFrom: savedStates keys first]
! !

!SClassDiagram methodsFor: 'submorphs-add/remove' stamp: 'ag 12/28/2011 23:42:56.132'!
contentChangedBecauseOf: aMorph
	
	((aMorph isKindOf: SClassDiagramMorph) or: [ aMorph isKindOf: SConnector ])
		ifTrue: [ self makeDirty ].
	self changed: #hasSubmorphs.
	self hasSubmorphs not & self isSaved not ifTrue: [ self dirty: false ].! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 4/19/2012 13:19:14.422'!
currentSmoothing
	"Take the TransformMorph-smoothing as reference value, although the same smoothing value is also set in the minimap.
	If these two were different, it would be an illegal state, #setSmoothing: sets both values at the same time."
	
	^ (self ownerThatIsA: TransformMorph)
		ifNil: [ 0 ]
		ifNotNilDo: #smoothing! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 4/19/2012 13:18:26.096'!
currentZoom
	
	^ (self ownerThatIsA: TransformMorph)
		ifNil: [ 0 ]
		ifNotNilDo: #scale! !

!SClassDiagram methodsFor: 'submorphs-add/remove' stamp: 'ag 7/2/2012 11:41:47.641'!
delete
	
	self stopLayouting.
	SReleaseSystemEventsVisitor visitAll: self classMorphs.
	super delete.! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/6/2012 21:43:29.187'!
deleteDebugSubmorphs
	
	self submorphs
		select: [ :morph | morph isKindOf: SDebugRectangleMorph ]
		thenDo: #delete.! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 6/28/2012 15:39:49.284'!
dirty: aBoolean
	
	dirty := aBoolean.
	"The dirty-flag is the most frequently changed flag, use it to update all sorts of states."
	self
		changed: #isDirty;
		changed: #hasChanged;
		changed: #hasSubmorphs;
		changed: #windowLabel;
		changed: #isSaved.! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/8/2012 13:29:12.275'!
expandAndToggleLabels
	"This should only be called during initialization, to programmatically set up the diagram.
	All morphs, entries and subentries has first to be expanded (initialized), to ensure that pinned methods stay visible after toggleLabels."
	
	classMorphs do: #expandMorphs.
	self toggleLabels.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/9/2011 15:28:30.879'!
extendArea
	
	| value |
	value := UIManager default request: 'Please insert the number of pixels to extend the diagram area.' initialAnswer: '30'.
	value ifNotNil: [
		value := value asInteger.
		value ifNotNil: [
			value > 0
				ifTrue: [ self extent: (self extent + value) ]
				ifFalse: [ UIManager default inform: 'Input was not a valid integer > 0.' ] ] ].! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 7/2/2012 11:05:26.638'!
fileMenu
	| choices entry |
	choices := (savedStates associations collect: [:assoc | assoc key -> assoc value first -> [self switchTo: assoc key]]),
				{'New' -> [self new]. 'Open' -> [self open]. 'Close' -> [self close]}.

	choices
		detect: [:assoc | assoc key key = currentState
							ifTrue: [assoc key value:  '(current) ', assoc key value. true] ifFalse: [false]]
		ifNone: [].
	self isDirty ifTrue: [choices := choices, {'Save' -> [self save]}].
	self hasSubmorphs ifTrue: [choices := choices, {'Save as PNG' -> [self savePNG]}].
	self hasChanges ifTrue: [choices := choices, {'Revert' -> [self revert]}].
	self isSaved ifTrue: [choices := choices, {'Delete' -> [self remove]}].

	entry := UIManager default
		chooseFrom: ((choices collect: #key) collect: #value)
		values: (choices collect: #value)
		lines: {savedStates keys size}
		title: ''.
	entry value.! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 9/22/2011 13:15:41.205'!
handlesMouseDown: anEvent
	
	^ anEvent wasHandled not! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 12/10/2011 16:51:13.511'!
handlesMouseUp: anEvent
	
	^ anEvent wasHandled not! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 12/29/2011 00:01:31.811'!
hasChanges
	
	^ self isSaved & self isDirty! !

!SClassDiagram methodsFor: 'updating' stamp: 'ag 9/22/2011 13:54:52.306'!
hasClassMorphSelection

	^ classMorphs includes: self currentHand keyboardFocus! !

!SClassDiagram methodsFor: 'highlighting' stamp: 'ag 12/10/2011 16:49:57.248'!
highlightClassMorphs: aClass
	
	| color lastClass |
	self removeHighlights.
	color := SClassMorph highlightColor.
	lastClass := nil.
	(self sortedClassMorphs: aClass) do: [ :classMorph |
		(lastClass notNil and: [ classMorph klass ~= lastClass ])
			ifTrue: [ color := self lighterHighlightColorFor: color inClass: aClass ].
		lastClass := classMorph klass.
		classMorph highlight: color ].! !

!SClassDiagram methodsFor: 'initialization' stamp: 'tfel 7/5/2012 15:58:04.84'!
initialize 
	
	super initialize.
	self
		extent: 1500@1500;
		borderColor: Color gray;
		color: Color white.
	classMorphs := OrderedCollection new.
	layoutingLocked := false.
	"Comment this in to enable the selection morph"
	"selectionMorph := SSelectionMorph new."
	dirty := false.
	labelsHidden := false.
	self currentHand newKeyboardFocus: self.
	self changed: #hasSubmorphs. "This deactivates 'Save as PNG' button."
	savedStates := Dictionary new.
	self saveState.
	openMutex := Mutex new.! !

!SClassDiagram methodsFor: 'initialization' stamp: 'ag 12/31/2011 10:08:41.336'!
initializeSmoothing
	"This gets called when the two smoothable components are set: the owner and the minimap.
	There seems to be no event, when both are set at the same time."
	
	self setSmoothing: self class defaultSmoothing.! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 7/4/2011 10:30:58.547'!
isDirty

	^ dirty! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 12:57:47.142'!
isLayoutNotRunning
	
	^ self isLayoutRunning not! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 15:12:12.12'!
isLayoutRunning
	"If we use a separate process, we can just check whether we currently have one running.
	In case of stepping, we sometimes start stepping unwanted, e.g. sometime when moving the windows.
	We use the layoutProcess variable to store a flag, whether we are actually layouting, to avoid accidental movement of the class-morphs."
	
	^ self useSeparateLayoutProcess
		ifTrue: [ layoutProcess notNil ]
		ifFalse: [ layoutProcess == true and: [ self isStepping ] ]! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 11:51:30.271'!
isLayoutUnlocked
	
	^ layoutingLocked not! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 12/28/2011 23:45:08.763'!
isSaved
	
	^ self savedVersion notNil! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 5/18/2012 22:54:52.145'!
layoutGraph
	
	| graph |
	self deleteDebugSubmorphs.
	graph := SMatrixGraph buildFrom: self submorphs.
	graph
		groupNodesIntoInheritanceTrees;		"1. Find and build inheritance trees"
		groupNodesIntoMatrixGraphs.			"2. Split graph into groups of interconnected nodes"
	
	graph := SCenteringGraph 				"3. Offset the layout to be in the center of the diagram."
					center: graph 				"Also extend the diagram area."
					inside: self
					extendAreaBy: self class additionalDiagramSpace.
	graph performLayout.						"4. Calculate"
	
	self class debugShowSubgraphs 			"5. Now finally apply the calculated positions"
		ifTrue: [
			SGraph setCurrentGraph: graph. 	"(Enable debugging the layout algorithms)"
			graph applyDebugLayout ]
		ifFalse: [ graph applyLayout ].! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/19/2012 14:33:26.728'!
layoutGraphForked
	"Perform the layout in a separate thread, so that the morphs already have their positions and extents applied."
	"TODO find a clean way in Morphic to defer the layout until the PasteUpMorph with the graph is fully initialized."
	
	[ (Delay forMilliseconds: 300) wait.
	self layoutGraph ]
		fork.! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 12:58:43.687'!
layoutLoop
	"This is designed like morphics step-system to be able to switch to it easily, if wanted (see useSeparateLayoutProcess).
	layoutStep and layoutStepTime just have to be renamed and instead of forking this method, start/stopStepping must be called."
	
	[
		layoutProcess ~= Processor activeProcess ifTrue: [ ^ self ]. "layoutProcess has been set to nil or other process."
		self layoutStep.
		self layoutStepTime ~= 0 ifTrue: [ (Delay forMilliseconds: self layoutStepTime) wait ]
	]
	repeat.! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 12:49:02.562'!
layoutStep
	"Calculate the forces applied on each node. Then move the positions of the nodes according to the forces.
	Then check, whether we can stop the layouting, because the total energy is too low."
	
	| totalEnergy |
	classMorphs ifEmpty: [ ^ self stopLayouting ].
	totalEnergy := self applyForces / classMorphs size.
	self moveNodes.
	(layoutingLocked not and: [ totalEnergy < self class minimalKineticEnergy ])
		ifTrue: [ self stopLayouting ].! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 11:29:06.259'!
layoutStepTime
	
	^ 6! !

!SClassDiagram methodsFor: 'highlighting' stamp: 'ag 9/22/2011 20:47:03.178'!
lighterHighlightColorFor: aColor inClass: aClass
	
	^ aColor alpha: aColor alpha - (0.08 / (1 max: aClass allSuperclasses size - 1))! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/26/2011 11:56:07.787'!
lockLayouting
	
	layoutingLocked := true.
	self
		changed: #isLayoutUnlocked;
		startLayouting.! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 7/2/2012 11:48:27.441'!
makeDirty
	
	"Hacky; exception occurs when this is done with CLOSED diagram windows,
	in changed: #windowLabel. The model, that is sent #windowLabel, is nil."
	[ self dirty: true ]
		on: MessageNotUnderstood do: [ "nothing" ].! !

!SClassDiagram methodsFor: 'accessing' stamp: 'ag 5/18/2012 16:47:11.681'!
minimap: anSMiniMap
	"When we get our minimap, set our specific default values on it."
	
	super minimap: anSMiniMap.
	minimap scalingFactor: self class defaultMinimapScale.
	minimap hideByDefault: true. "Hide by default to address performance-issue."
	self initializeSmoothing.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 5/18/2012 22:50:19.994'!
minimapBigger
	
	minimap show.
	minimap scalingFactor: minimap scalingFactor + self class minimapScaleStep.
	self changed: #canScaleMinimapBigger.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 5/18/2012 09:07:15.333'!
minimapSmaller
	
	minimap scalingFactor: minimap scalingFactor - self class minimapScaleStep.
	self canScaleMinimapSmaller ifFalse: [ minimap hide ].
	self changed: #canScaleMinimapSmaller.! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/19/2012 14:53:07.05'!
morphForClass: aClass
	
	^ self morphForClass: aClass do: #yourself! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/30/2012 11:46:57.844'!
morphForClass: aClass do: aBlock
	
	^ classMorphs
		detect: [ :morph | morph klass = aClass theNonMetaClass ]
		ifFound: aBlock
		ifNone: [ nil ]! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/18/2012 13:23:14.835'!
morphForMethod: anAssociation
	"Return the SMethodMorph for the given methods (anAssociation: class -> methodSelectorSymbol).
	The returned object can be used to color the entry or to set an icon of that entry."
	
	^ self morphForMethod: anAssociation do: #yourself! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/18/2012 13:31:43.229'!
morphForMethod: association do: aBlock
	
	^ self
		morphForClass: association key
		do: [ :classMorph |
			aBlock value: (classMorph methodMorphFor: association) ]! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 12/29/2011 17:23:49.526'!
mouseDown: evt
	
	super mouseDown: evt.
	self removeHighlights.! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 12/10/2011 16:53:29.073'!
mouseUp: evt
	"Stop both possible dragging-activities, no matter wich one is actually running."
	
	super mouseUp: evt.
	self stopSelection.! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 9/25/2011 19:04:39.259'!
moveNodes
	
	classMorphs do: [ :morph |
		(morph owner = self) ifTrue: [ "Don't move nodes, that are grabbed by the hand."
			morph moveInside: self bounds ] ].! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 6/28/2012 13:44:16.043'!
new

	self saveState.
	self removeAllMorphs.
	self savedName: nil.
	currentState := nil.
	self saveState.
	self dirty: false.! !

!SClassDiagram methodsFor: 'submorphs-accessing' stamp: 'ag 5/18/2012 16:46:26.827'!
noteNewOwner: aMorph
	"Use this hook to initialize the smoothing-value of the TransformMorph-owner."
	
	super noteNewOwner: aMorph.
	self initializeSmoothing.! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 7/2/2012 15:53:29.343'!
open
	| projectViews otherViews |
	self submorphs isEmpty & self isDirty not ifFalse: [self saveState].
	projectViews := (self viewsFor: SProject current).
	otherViews := self allViews sort copyWithoutAll: projectViews.
	self openSaved: ((SMultipleChoiceRequest
								prompt: 'Views for ', SProject current
								labels: (projectViews collect: [:s | s asText addAttribute: TextEmphasis struckOut]), otherViews
								values: projectViews, otherViews
								lines: {projectViews size})
									ifNil: [^ self]).! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 12/29/2011 11:41:03.045'!
openClassMorphFor: aClass nextTo: aPoint positionedBy: aBlock
	"Ensure, that a class-morph for aClass exists in the diagram. If not, open one and execute aBlock with it as parameter
	to position it correctly.
	Receiver will try to find existing morphs in the area of aPoint."
	
	| target |
	target := self classMorphFor: aClass nearestTo: aPoint.
	target ifNil: [
		target := SClassMorph on: aClass. 
		self addMorph: target.
		aBlock value: target ].
	^ target! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 12/27/2011 16:49:14.648'!
openClassMorphFor: aClass positionedBy: aBlock
	
	^ self openClassMorphFor: aClass nextTo: self extent / 2 positionedBy: aBlock! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 12/27/2011 16:52:25.296'!
openClassMorphs: collectionOfClasses at: aCommonPosition
	"Open one class-morph for each class in collectionOfClasses at aCommonPosition."
	
	^ collectionOfClasses collect: [ :class |
		self
			openClassMorphFor: class
			nextTo: aCommonPosition
			positionedBy: [ :morph | morph position: aCommonPosition ] ]! !

!SClassDiagram methodsFor: 'accessing' stamp: 'tfel 7/5/2012 15:56:20.934'!
openMutex

	^ openMutex! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'omg 6/21/2011 14:32:11.284'!
openPreferences

	PreferenceBrowser open selectedCategory: #'Path View'.! !

!SClassDiagram methodsFor: 'multi-window support' stamp: 'tfel 7/5/2012 15:57:24.846'!
openSaved: aString
	| classes |
	self savedName: aString.
	classes := ((self systemNavigation allImplementorsOf: aString asSymbol asMutator)
					collect: #actualClass) collect: #theNonMetaClass.
	openMutex critical: [
		classes do: [:cls | cls perform: aString asSymbol asMutator with: self]].
	self dirty: false.
	currentState := nil.
	self saveState.! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/30/2012 11:12:14.529'!
pinAllVariablesInClass: aClass
	
	self
		morphForClass: aClass
		do: [ :morph | morph pinAllVariables ].! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 4/18/2012 13:30:32.413'!
pinMethod: association
	
	self
		morphForMethod: association
		do: #pin.! !

!SClassDiagram methodsFor: 'layout graph-based' stamp: 'ag 3/30/2012 11:29:11.669'!
pinVariable: aSymbol inClass: aClass
	
	self
		morphForClass: aClass
		do: [ :morph | morph pinVariable: aClass -> aSymbol ].! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 7/5/2012 15:08:55.405'!
pvtSave
	| param header |
	param := 'aClassDiagram'.
	header := savedName, ': ', param, String cr.
	(self classMorphs groupBy: [:cm | cm visualizedClass] having: [:r| true])
		associationsDo: [:assoc || klass method |
			klass := assoc key.
			method := String streamContents: [:code |
				code nextPutAll: header.
				assoc value
					do: [:cm | code nextPutAll: (cm saveToCodeFor: param)]
					separatedBy: [code cr]].
			klass theMetaClass
				compile: method
				classified: SClassDiagramMorph diagramCodeCategory]! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'sp 7/6/2012 15:22:19.768'!
remove
	self savedVersion ifNotNil: [
		self removeView: savedName].
	self makeDirty.! !

!SClassDiagram methodsFor: 'highlighting' stamp: 'ag 12/10/2011 16:50:03.186'!
removeHighlights
	
	classMorphs do: [ :morph | morph removeHighlight ].! !

!SClassDiagram methodsFor: 'views' stamp: 'sp 7/6/2012 14:30:54.079'!
removeView: aString
	
	^ (self allViewReferences)
		select: [:ref | (ref selector asString allButLast = aString) and: [ref classIsMeta] ]
		thenDo: [:ref | ref actualClass removeSelector: ref selector].! !

!SClassDiagram methodsFor: 'submorphs-add/remove' stamp: 'ag 12/27/2011 13:18:35.304'!
removedMorph: aMorph
	"aMorph has just been removed from me, stop observation"
	
	super removedMorph: aMorph.
	aMorph isClassMorph ifTrue: [ classMorphs remove: aMorph ifAbsent: [] ].
	aMorph removeDependent: self.
	self
		contentChangedBecauseOf: aMorph;
		changed: #morphRemoved.! !

!SClassDiagram methodsFor: 'multi-window support' stamp: 'tfel 7/2/2012 11:03:13.791'!
restoreFrom: aString

	self
		removeAllMorphs;
		addAllMorphs: (((savedStates at: aString) last) reject: #isNil).
	currentState := aString.
	self savedName: (aString copyUpToLast: $#).
	self dirty: false.! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 6/28/2012 13:17:07.393'!
revert
	
	self savedVersion ifNil: [^ self error: 'No saved version to revert to, sorry.'].
	self close.
	self openSaved: self savedName.! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 7/5/2012 14:57:07.282'!
save
	| oldSavedName |
	oldSavedName := savedName.
	(self submorphs anySatisfy: #isError) ifTrue: [^ self inform: 'I refuse to save inconsistent diagrams!!'].
	savedName := UIManager default
		request: 'Enter a name for this view'
		initialAnswer: ( savedName ifNil: [ '' ] ).
	
	(savedName isNil or: [savedName isEmpty or: [self canBeSaved not]])
		ifTrue: [
			self inform: 'Save aborted'.
			savedName := oldSavedName.
			self dirty: true]
		ifFalse: [
			self remove.
			self pvtSave.
			self dirty: false].! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 12/27/2011 16:03:31.976'!
saveOnStream: aStream
	
	^ aStream fileOutClass: nil andObject: self! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'ag 12/12/2011 16:29:08.794'!
savePNG
	
	PNGReadWriter
		putForm: (self imageFormForRectangle: self canvasWithoutWhitespace)
		onFileNamed: (FileDirectory default nextNameFor: '_pathview' extension: 'png').! !

!SClassDiagram methodsFor: 'multi-window support' stamp: 'tfel 7/2/2012 11:06:08.404'!
saveState
	| key |
	key := self stateKey.
	savedStates at: key put: {self windowLabelName. Array newFrom: self submorphs}.! !

!SClassDiagram methodsFor: 'accessing' stamp: 'tfel 7/14/2011 12:35:14.269'!
savedName

	^ savedName
! !

!SClassDiagram methodsFor: 'accessing' stamp: 'tfel 7/14/2011 11:23:49.401'!
savedName: aString

	savedName := aString.
! !

!SClassDiagram methodsFor: 'menu-actions' stamp: 'tfel 6/28/2012 07:19:35.366'!
savedVersion
	
	^ (self viewsFor: SProject current) includes: self savedName! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 1/4/2012 09:06:40.697'!
setSmoothing: aNumber
	"Adjust the smoothing-value of the scroll-pane content and the minimap. Could also be handled seperately, but is not really necessary.
	The minimap can smooth up more than 3, so set its smoothing in 2-seps.
	Smoothing 1 does not produce viewable results anyway."
	
	(self ownerThatIsA: TransformMorph) ifNotNilDo: [ :owner | owner smoothing: aNumber ].
	minimap ifNotNil: [ minimap smoothing: 2 * aNumber ].
	self
		changed: #canSmoothUp;
		changed: #canSmoothDown.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/31/2011 09:33:06.41'!
smoothDown
	
	self addSmoothing: -1.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/31/2011 09:32:59.541'!
smoothUp
	
	self addSmoothing: 1.! !

!SClassDiagram methodsFor: 'highlighting' stamp: 'ag 10/12/2011 14:20:21.595'!
sortedClassMorphs: aClass
	"Return a copy of the classMorphs-collection, sorted by their hierarchical relation to aClass.
	Collection-lookups are performed here, so we use #visualizedClass instead of #klass."
	
	| superclasses |
	superclasses := aClass allSuperclasses.
	^ (classMorphs
		select: [ :morph | aClass includesBehavior: morph visualizedClass ]) "Select the supserclasses"
		sort: [ :classMorph1 :classMorph2 |
			(superclasses indexOf: classMorph1 visualizedClass)
			<= (superclasses indexOf: classMorph2 visualizedClass) ]! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 9/15/2011 21:09:45.184'!
startDrag: anEvent
	
	anEvent redButtonPressed ifTrue: [ ^ self startSelectionAt: anEvent position ].! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 15:06:39.831'!
startLayouting
	
	self isLayoutRunning ifFalse: [
		self clearAllVectors.
		self useSeparateLayoutProcess
			ifTrue: [ layoutProcess := [ self layoutLoop ] fork ]
			ifFalse: [ layoutProcess := true. self startStepping ]. "See isLayoutRunning"
		self
			changed: #isLayoutRunning;
			changed: #isLayoutNotRunning ].! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 8/18/2011 13:29:36.907'!
startSelectionAt: position
	
	selectionMorph ifNotNil:  
		[ selectionMorph initializeAt: position.
		self addMorph: selectionMorph ].! !

!SClassDiagram methodsFor: 'multi-window support' stamp: 'tfel 6/28/2012 13:31:49.415'!
stateKey

	^ currentState ifNil: [
		currentState := (savedName ifNil: ['*unsaved*']), '#', DateAndTime now]! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 15:07:32.966'!
step
	"Stepping seems odd sometimes, so be carefull and do checks on our own."
	
	(self useSeparateLayoutProcess not and: [ self isLayoutRunning ])
		ifTrue: [ self layoutStep ]
		ifFalse: [ self stopStepping ] "stepping started without us calling startStepping it. Try and stop it."! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 12:54:51.02'!
stepTime
	
	^ self layoutStepTime! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 15:09:35.353'!
stopLayouting
	"If the process terminates itself, the terminate-call is the last thing, that happens here.
	The variables (especially layoutProcess itself) must be set before that call."
	
	| terminatedProcess |
	self useSeparateLayoutProcess
		ifTrue: [
			terminatedProcess := layoutProcess.
			layoutProcess := nil.
			terminatedProcess ifNotNil: [
				terminatedProcess terminate ] ]
		ifFalse: [
			layoutProcess := false. "See isLayoutRunning"
			self stopStepping ].
	layoutingLocked := false.
	self clearAllVectors.
	self
		changed: #isLayoutRunning;
		changed: #isLayoutNotRunning;
		changed: #isLayoutUnlocked.! !

!SClassDiagram methodsFor: 'event handling' stamp: 'ag 8/18/2011 13:29:16.644'!
stopSelection
	"The selectionMorph will be used again for the next selection.
	We try to avoid errors with the selection by reducing the number of instances to one."
	
	selectionMorph ifNotNil: [selectionMorph delete].! !

!SClassDiagram methodsFor: 'multi-window support' stamp: 'tfel 6/28/2012 13:22:43.449'!
switchTo: aString

	self
		saveState;
		restoreFrom: aString.! !

!SClassDiagram methodsFor: 'accessing' stamp: 'sp 7/6/2012 13:22:17.307'!
thContainerMorphFor: aString

	^ classMorphs select: [ :each |
		(each isKindOf: SContainerClassMorph) and: [each klass printString = aString]  . ]! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/3/2011 22:44:04.544'!
toggleLabels
	
	labelsHidden := labelsHidden not.
	classMorphs do: [ :classMorph | classMorph showLabels: labelsHidden not ].! !

!SClassDiagram methodsFor: 'updating' stamp: 'ag 5/18/2012 09:09:43.051'!
update: action
	
	action caseOf: {
		[ #classMorphSelected ] -> [ self changed: #hasClassMorphSelection ]
	}.! !

!SClassDiagram methodsFor: 'layout force-based' stamp: 'ag 10/12/2011 13:12:42.203'!
useSeparateLayoutProcess
	"Tells whether the layouting should be processed in a separate process.
	Seems better / more stable in general; but sometimes synchronization issues with the morphic thread throw fatal errors.
	Setting morphic-relevant values from the separate process has to be synchronized. [TODO]"
	
	^ false! !

!SClassDiagram methodsFor: 'copying' stamp: 'ag 12/27/2011 13:31:35.02'!
veryDeepCopy
	"Run the update hooks after copying"
	
	| copy |
	copy := super veryDeepCopy.
	copy submorphs select: #isClassDiagramMorph thenDo: #update.
	^ copy! !

!SClassDiagram methodsFor: 'views' stamp: 'sp 7/6/2012 14:44:52.44'!
viewMethodReferencesFor: aProject

	^ aProject allMethods
		select: [:ref |
			ref category = SClassDiagramMorph diagramCodeCategory
			and: [ref classIsMeta]]! !

!SClassDiagram methodsFor: 'views' stamp: 'tfel 6/28/2012 07:31:31.604'!
viewsFor: aProject
	
	^ ((self viewMethodReferencesFor: aProject)
		collect: [:ref | ref selector asString allButLast])
		asSet asSortedCollection! !

!SClassDiagram methodsFor: 'events-processing' stamp: 'ag 6/28/2012 14:23:26.383'!
wantsDroppedMorph: aMorph event: anEvent
	
	^ 
	(aMorph isKindOf: SDebugRectangleMorph) or:
	[ aMorph isClassDiagramMorph ] or:
	[ aMorph isKindOf: SFloatingCodeSnippet ] or:
	[ SClassMorph canBeConverted: aMorph ] or:
	[ self carriesAcceptableClassCategory: aMorph ]! !

!SClassDiagram methodsFor: 'accessing' stamp: 'tfel 7/2/2012 11:00:53.594'!
windowLabel

	^ String streamContents: [ :str |
		str nextPutAll: 'PathView - '.
		str nextPutAll: self windowLabelName ]! !

!SClassDiagram methodsFor: 'accessing' stamp: 'tfel 7/2/2012 11:01:38.489'!
windowLabelName

	^ String streamContents: [:str |  
		savedName
			ifNil: [ str nextPutAll: '*unsaved*' ]
			ifNotNil: [
				str nextPutAll: savedName.
				dirty ifTrue: [ str nextPutAll: ' (with unsaved changes)' ] ] ]! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/30/2011 16:11:25.76'!
zoom: aNumber
	
	(self ownerThatIsA: SScrollPane) zoomInBy: aNumber.
	self changed: #canZoomOut.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/29/2011 16:34:21.93'!
zoomIn
	
	self zoom: self class zoomStep.! !

!SClassDiagram methodsFor: 'toolbar-actions' stamp: 'ag 12/29/2011 16:47:30.844'!
zoomOut
	
	self zoom: self class zoomStep negated.! !

!SPasteUpMorph methodsFor: 'geometry' stamp: 'ag 12/6/2011 15:22:30.237'!
extent: newBounds
	
	super extent: newBounds.
	minimap ifNotNil: [
		minimap refreshExtent ].! !

!SPasteUpMorph methodsFor: 'accessing' stamp: 'ag 12/6/2011 15:10:46.735'!
minimap
	^ minimap! !

!SPasteUpMorph methodsFor: 'accessing' stamp: 'ag 12/6/2011 15:10:46.745'!
minimap: anObject
	minimap := anObject! !

!OrderedCollection methodsFor: '*Path-View-override-accessing' stamp: 'ag 12/11/2011 22:08:41.348'!
at: anInteger put: anObject 
	"This is a fix provided by SightL package."

	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	(anInteger < 1 or: [anInteger + firstIndex - 1 > array size])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: anInteger + firstIndex - 1 put: anObject]! !

RenameMethodRefactoring subclass: #SRenameMethodRefactoring
	instanceVariableNames: 'senders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Refactorings'!

!SRenameMethodRefactoring class methodsFor: 'instance creation' stamp: 'sp 6/27/2012 08:47:20.098'!
renameMethod: aSelector in: aClass to: newSelector permutation: aMap withSenders: aSymbol

	^self new 
		senders: aSymbol;
		renameMethod: aSelector
		in: aClass
		to: newSelector
		permutation: aMap! !

!SRenameMethodRefactoring methodsFor: 'support' stamp: 'sp 6/27/2012 21:49:29.012'!
convertReferencesTo: aSymbol inClass: aClass using: searchReplacer

	(SystemNavigation default allCallsOn: aSymbol localTo: aClass)
		do: [ :method |
				self convertMethod: method selector
					 for: (self model classFor: (Smalltalk at: (method classSymbol)))
					 using: searchReplacer]! !

!SRenameMethodRefactoring methodsFor: 'support' stamp: 'sp 6/27/2012 21:48:46.373'!
convertReferencesTo: aSymbol inPackage: aSystemCategory using: searchReplacer

	(SystemNavigation default allCallsOn: aSymbol localToPackage: aSystemCategory)
		do: [ :method |
				self convertMethod: method selector
					 for: (self model classFor: (Smalltalk at: (method classSymbol)))
					 using: searchReplacer]! !

!SRenameMethodRefactoring methodsFor: 'private' stamp: 'sp 6/26/2012 18:05:22.305'!
implementors

	implementors isNil 
		ifTrue: [implementors := Set with: class.].
	^implementors! !

!SRenameMethodRefactoring methodsFor: 'support' stamp: 'sp 6/27/2012 21:36:49.419'!
privateReferencesTo: aSelector 
	| methods |
	methods := OrderedCollection new.
	self allClassesDo: [ :class |
		(class whichSelectorsReferToSymbol: aSelector)
			do: [ :selector | methods add: (class methodFor: selector) ] ].
	^ methods! !

!SRenameMethodRefactoring methodsFor: 'transforming' stamp: 'sp 6/27/2012 19:43:51.301'!
renameMessageSends

	senders = #all
		ifTrue: [self convertAllReferencesTo: oldSelector using: self parseTreeRewriter].
		
	senders = #class
		ifTrue: [self convertReferencesTo: oldSelector inClass: class using: self parseTreeRewriter].    
		
	senders = #package
		ifTrue: [self convertReferencesTo: oldSelector inPackage: class category using: self parseTreeRewriter]. 
		
	senders = #none
		ifTrue: [^self].! !

!SRenameMethodRefactoring methodsFor: 'accessing' stamp: 'sp 6/27/2012 08:21:29.191'!
senders
	^senders ! !

!SRenameMethodRefactoring methodsFor: 'accessing' stamp: 'sp 6/27/2012 08:47:38.331'!
senders: aSymbol

	senders  := aSymbol.! !

!Morph methodsFor: '*Path-View-collecting' stamp: 'ag 3/6/2012 20:45:50.416'!
allSubmorphsOfKind: aClass
	
	^ self allSubmorphsSatisfying: [ :morph | morph isKindOf: aClass ]! !

!Morph methodsFor: '*Path-View-collecting' stamp: 'ag 3/6/2012 20:45:14.456'!
allSubmorphsSatisfying: aBlock
	
	^ self allSubmorphsSatisfying: aBlock into: Set new! !

!Morph methodsFor: '*Path-View-collecting' stamp: 'ag 3/6/2012 21:29:36.169'!
allSubmorphsSatisfying: aBlock into: aSet
	
	submorphs do: [ :morph |
		Transcript cr; show: morph.
		(aBlock value: morph) ifTrue: [ aSet add: morph ].
		morph allSubmorphsSatisfying: aBlock into: aSet ].
	^ aSet! !

!Morph methodsFor: '*Path-View-converting' stamp: 'ag 9/22/2011 19:34:00.538'!
asClassDiagramMorph
	
	^ (SClassMorph fromMorph: self)
		position: self position;
		yourself! !

!Morph methodsFor: '*Path-View-testing' stamp: 'tfel 7/14/2011 11:52:25.869'!
isClassDiagramMorph 

	^ false! !

!Morph methodsFor: '*Path-View-testing' stamp: 'fb 5/31/2011 13:08:32.252'!
isClassMorph 

	^ false! !

!Morph methodsFor: '*Path-View-testing' stamp: 'tfel 6/28/2012 13:57:31.489'!
isError

	^ false! !

!Morph methodsFor: '*Path-View' stamp: 'ag 7/2/2012 11:25:18.832'!
releaseSystemEvents
	
	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self.! !

Morph subclass: #SDiagramMorphToolbarPanel
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SDiagramMorphToolbarPanel commentStamp: 'mt 6/21/2010 16:38:29.674' prior: 0!
I just support the XpfCardMorph. You should normally not want to use me directly.

Normally, I contain some buttons and fade them in or out according to my alpha value.!

!SDiagramMorphToolbarPanel class methodsFor: 'as yet unclassified' stamp: 'fb 5/26/2011 11:34:19.352'!
extent
	^ 22! !

!SDiagramMorphToolbarPanel methodsFor: 'drawing' stamp: 'tfel 5/22/2012 13:43:00.398'!
drawOn: aCanvas
	
	(self submorphs noneSatisfy: #visible) ifTrue: [ ^ self ].
	aCanvas
		fillRoundRect: self panelBounds 
		radius: 5
		fillStyle: (SolidFillStyle color: (Color black alpha: 0.5)).! !

!SDiagramMorphToolbarPanel methodsFor: 'initialization' stamp: 'ag 8/19/2011 13:31:54.59'!
initialize

	super initialize.
	self
		color: Color green "transparent";
		changeTableLayout;
		cellInset: 2;
		layoutInset: 2;
		orientation: #vertical.! !

!SDiagramMorphToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:28.138'!
orientation

	^ orientation! !

!SDiagramMorphToolbarPanel methodsFor: 'accessing' stamp: 'ag 8/19/2011 13:21:33.268'!
orientation: aSymbol
	"#vertical #horizontal"
	
	orientation := aSymbol.! !

!SDiagramMorphToolbarPanel methodsFor: 'geometry' stamp: 'ag 8/19/2011 16:03:35.782'!
panelBounds

	^ self submorphBounds "outsetBy: 2"! !

!SDiagramMorphToolbarPanel methodsFor: 'updating' stamp: 'tfel 5/22/2012 12:40:25.714'!
update

	self submorphs do: [:m | m update: m getEnabledSelector].! !

!SDiagramMorphToolbarPanel methodsFor: 'layout' stamp: 'ag 8/19/2011 14:00:34.155'!
updateLayout
	
	self orientation = #vertical ifTrue: [
		self
			top: self owner top;
			height: self owner height;
			width: self class extent;
			listDirection: #topToBottom].
	
	self orientation = #horizontal ifTrue: [
		self
			left: self owner left;
			width: self owner width - (2 * self class extent);
			height: self class extent;
			listDirection: #leftToRight].! !

Morph subclass: #SIndentedLabelMorph
	instanceVariableNames: 'labelMorph indentationMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SIndentedLabelMorph methodsFor: 'accessing' stamp: 'ag 12/10/2011 14:19:47.204'!
indentation
	
	^ indentationMorph width! !

!SIndentedLabelMorph methodsFor: 'accessing' stamp: 'ag 12/10/2011 14:19:42.397'!
indentation: aNumber
	
	indentationMorph width: aNumber.! !

!SIndentedLabelMorph methodsFor: 'initialization' stamp: 'ag 12/10/2011 14:55:31.489'!
initialize
	
	super initialize.
	self
		color: Color transparent;
		height: 1;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		addMorph: (indentationMorph :=
			Morph new
				width: 0 ;
				height: 1; "Need to have impact on layouting."
				color: Color transparent;
				yourself);
		addMorphBack: (labelMorph := StringMorph contents: '').! !

!SIndentedLabelMorph methodsFor: 'accessing' stamp: 'ag 12/10/2011 13:38:09.974'!
labelMorph
	^ labelMorph! !

Morph subclass: #SPopupMorph
	instanceVariableNames: 'morph parentMorph morphHovered selfHovered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

SPopupMorph subclass: #SDiagramMorphToolbar
	instanceVariableNames: 'leftBar topBar rightBar bottomBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SDiagramMorphToolbar methodsFor: 'popup' stamp: 'tfel 5/22/2012 12:22:49.112'!
activate
	
	self
		updateBounds;
		updateButtons;
		hideSimilarPopups.
	"Behind the owner, to avoid stealing it's events, but above the rest, to cover connectors etc."
	parentMorph addMorph: self behind: morph.! !

!SDiagramMorphToolbar methodsFor: 'adding' stamp: 'tfel 5/22/2012 12:41:53.864'!
addButton: aLabelMorph model: anObject action: aSelector enabled: aSymbol edge: anEdge
	| aButton |
	aButton := SDiagramMorphToolbarButton new
					model: anObject;
					label: aLabelMorph;
					action: aSelector;
					getEnabledSelector: aSymbol;
					yourself.
	anEdge = #left ifTrue: [leftBar addMorphBack: aButton].
	anEdge = #top ifTrue: [topBar addMorphBack: aButton].
	anEdge = #right ifTrue: [rightBar addMorphBack: aButton].
	anEdge = #bottom ifTrue: [bottomBar addMorphBack: aButton].! !

!SDiagramMorphToolbar methodsFor: 'layout' stamp: 'ag 8/19/2011 15:57:46.26'!
drawOn: aCanvas
	
	"Receiver itself has nothing to draw, avoid the overhead. The submorphs will still be drawn."! !

!SDiagramMorphToolbar methodsFor: 'initialization' stamp: 'ag 1/4/2012 08:59:28.927'!
initialize
	"The toolbar is added to the owner-morph lazily in #show"
	
	super initialize.
	leftBar := SDiagramMorphToolbarPanel new orientation: #vertical; wrapDirection: #rightToLeft.  
	topBar := SDiagramMorphToolbarPanel new orientation: #horizontal; wrapDirection: #bottomToTop.
	rightBar := SDiagramMorphToolbarPanel new orientation: #vertical; wrapDirection: #leftToRight.
	bottomBar := SDiagramMorphToolbarPanel new orientation: #horizontal; wrapDirection: #topToBottom.
	self
		flag: #ag; "TODO set some properties, so that the extent is resized based on the submorphs; to avoid hiding popups, when the width is more than one button"
		color: Color transparent;
		addAllMorphs: {leftBar. topBar. rightBar. bottomBar}.! !

!SDiagramMorphToolbar methodsFor: 'layout' stamp: 'ag 8/19/2011 14:39:50.376'!
updateBounds
	
	self
		bounds: morph bounds;
		updateLayout.! !

!SDiagramMorphToolbar methodsFor: 'popup' stamp: 'tfel 5/22/2012 12:39:31.678'!
updateButtons

	{leftBar. topBar. rightBar. bottomBar} do: [:m | m update].! !

!SDiagramMorphToolbar methodsFor: 'layout' stamp: 'ag 8/19/2011 14:01:47.956'!
updateLayout
	
	leftBar updateLayout; right: self left.
	topBar updateLayout; bottom: self top.
	rightBar updateLayout; left: self right.
	bottomBar updateLayout; top: self bottom.! !

!SPopupMorph class methodsFor: 'instance creation' stamp: 'ag 8/30/2011 10:00:32.938'!
on: aMorph
	
	^ self new
		morph: aMorph;
		yourself! !

!SPopupMorph methodsFor: 'initialization' stamp: 'ag 12/26/2011 13:09:55.768'!
aboutToBeGrabbedBy: aHand
	"Disable being grabbable and close the popup when user accidentally grabs it."
	
	self disappear.
	^ nil! !

!SPopupMorph methodsFor: 'private' stamp: 'ag 9/9/2011 10:50:49.033'!
activate
	"Do whatever is necessary to display the popup. Especially, the subclass decides, where the popup will become visible.
	Don't call directly - the appear-method checks several conditions for this method to be called."
	
	self subclassResponsibility.! !

!SPopupMorph methodsFor: 'popup' stamp: 'ag 9/9/2011 12:07:13.331'!
appear
	
	self isInWorld not & parentMorph notNil
		ifTrue: [ self activate ].! !

!SPopupMorph methodsFor: 'popup' stamp: 'ag 8/26/2011 13:48:17.568'!
disappear
	"Don't abandon - this morph will be reused."
	
	self delete.! !

!SPopupMorph methodsFor: 'event handling' stamp: 'ag 8/26/2011 13:49:30.124'!
handlesMouseOver: anEvent
	
	^ anEvent isMouseLeave! !

!SPopupMorph methodsFor: 'popup' stamp: 'ag 9/23/2011 16:50:35.226'!
hideSimilarPopups
	"We still don't catch all mouseLeave event, that would close a popup-morph.
	So at least we close other still open popups, when a new one is opened."
	
	parentMorph ifNotNil: [
		parentMorph submorphs
			select: [ :m | (m isKindOf: self class) & (m ~= self) ]
			thenDo: [ :m | m disappear ] ].! !

!SPopupMorph methodsFor: 'initialization' stamp: 'ag 9/30/2011 13:02:21.874'!
initialize
	
	super initialize.
	morphHovered := false.
	selfHovered := false.! !

!SPopupMorph methodsFor: 'initialization' stamp: 'ag 9/9/2011 10:53:50.733'!
morph: aMorph
	"parentMorph will be the morph where the toolbar will be added to.
	This is the ClassDiagram containing all the elements of the diagram.
	parentMorph stays nil, if no correct parent could be found. In this case, no popups will appear."
	
	morph := aMorph.
	self updateParentMorph.! !

!SPopupMorph methodsFor: 'popup' stamp: 'ag 8/26/2011 13:56:45.292'!
morphUnhovered
	"We cannot dismiss the popup, if the mouse leaves the owner; the popup might contain buttons, etc. Only disappear, if the popup itself is not hovered.
	The popup-morph sometimes misses out on mouse-leave events, if the mouse is moved too fast. Try to use the events of the containing morph,
	as they seem more reliable. Still, this not always suffices to remove the toolbar when needed."
	
	(self intersects: self activeHand cursorBounds)
		ifFalse: [ self disappear ]! !

!SPopupMorph methodsFor: 'events-processing' stamp: 'ag 8/26/2011 13:51:14.697'!
mouseLeave: anEvent
	
	self disappear.! !

!SPopupMorph methodsFor: 'initialization' stamp: 'ag 12/29/2011 11:44:50.133'!
updateParentMorph
	
	parentMorph := morph diagramParent.! !

SPopupMorph subclass: #SSourceCodePopup
	instanceVariableNames: 'sourceCodeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-View-Morphic'!

!SSourceCodePopup class methodsFor: 'instance creation' stamp: 'ag 8/30/2011 10:01:07.285'!
on: aMorph withMethod: aSelector in: aClass
	
	^ (super on: aMorph)
		initializeWithClass: aClass andSelector: aSelector! !

!SSourceCodePopup methodsFor: 'popup' stamp: 'ag 8/30/2011 10:06:40.741'!
activate
	
	self hideSimilarPopups.
	self position: morph bounds topRight.
	parentMorph addMorphFront: self.! !

!SSourceCodePopup methodsFor: 'initialization' stamp: 'ag 9/30/2011 13:17:34.515'!
initializeWithClass: aClass andSelector: aSelector
	
	sourceCodeMorph := SSourceCodeMorph on: aSelector in: aClass.
	self
		color: Color transparent;
		addMorphFront: sourceCodeMorph;
		extent: sourceCodeMorph extent.! !
SGraph initialize!
